#coding: utf8;
import sys
import os
import socket

# The object path
spyro_path=["spyro-objects","opt-objects"]

# Module path
path=["packages"]

# Inserting our object and module paths in the sys.path
for p in path + spyro_path:
    if p not in sys.path:
        sys.path.insert(0, p)
import warn
import SPyRO
import shttp
from shttp import http

warn.output['main']=sys.stderr
hostname = socket.gethostname()
sysname = hostname

# If this instance should support global updates.
support_global_updates = False
# The port
if 'threekong.com' in hostname:
    port=80
    launch_browser = False
else:
    port=8000
    launch_browser = True
# The address of the server, use 0.0.0.0 to run in every available
# devices, used with -m flag
server_address=("0.0.0.0",port)
# Where to run the server if you set -s flag, this must be a local address
local_server_address=("127.0.0.1",port)
# The url to be handled directly for SPyRO, and the default protocol
spyro_url_full="http://%s:%s/spyro/spyro.py?XMLRPC"%server_address
spyro_url="/spyro/spyro.py?XMLRPC"
# The url to be called by the -k flag (kill the server)
spyro_url_close="/spyro/spyro.py?MARSHAL"
spyro_object_pool = SPyRO.ModulePool(spyro_path)
# The document root
document_root="html/"
# The sqlite database path
sqlite_dbpath="db"
desc_dbpath="sql"
proxy_host="localhost:%s"%port

template_index = os.path.join("templates","index.html")
template_admin = os.path.join("templates","admin.html")
seed_file="auth.seeds"
run_proxy=False

# If you need to overload the authentication functions. See auth3k.authweb
# documentation. If you need a deep customizations see spyro-packages/useradmin
# object-module

#def getgroup(groupname):
#   return []
#def validate_user(user, password):
#   return True


###
### SMTP and mail directives
### 

smtp_server="localhost"
if 'threekong' in hostname:
   mail_forum_post = 'info@threekong.com' # or None
   mail_warn = 'info@threekong.com'
else:
   mail_forum_post = None
   mail_warn = None
mail_admin_from = 'info@threekong.com'
###
### Configuring the authentication module
### 
from auth3k import authweb
import useradmin
class Environ(authweb.AuthEnviron):
    def __init__(self):
        # To the authentication
        expirationsoft = 3600 * 3 * 24
        expirationhard = 3600 * 30 * 24
        # A big expirationhard needs an a big number of seeds
        minseeds = 300
        maxseeds = 400
        authweb.AuthEnviron.__init__(self, seed_file, expirationsoft, expirationhard, minseeds, maxseeds)

    def getgroup(self, name):
        """ Queries for the group named |name|, returns an an object with __contains__ """
        # reload(useradmin)
        return useradmin.getgroup(name)

    def validate_user(self, user, password):
        """ Validate an user against a password, returns boolean """
        # reload(useradmin)
        return useradmin.validate_user(user, password)

###
### An user and an object name to stop the server
###
USER_ADMIN_SPYRO="AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
OBJECT_SPYRO="BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
USESSL=False

###
### Logging data
###

log_err="log.err"
log_out="log.out"
try:
    os.mkdir("logs")
except OSError, e:
    warn.debug("'mkdir logs' error", e)

def log_function(logid, logname):
    x = ["log-" + logname]
    try:
        x = _log_function(logid, logname)
    except:
        sys.stderr.write(repr(sys.exc_info()))
        sys.stderr.write("\n")
        raise
    # sys.stderr.write(repr(x) + "\n")
    return x

import mailadmin
if mail_warn:
    def warn_handler(string, msgtype, logs):
        if msgtype == 'WARN':
            msg = [string]
            try:
                msg.append(repr(http.getrequest()))
            except KeyError:
                pass
            try:
                msg.append(repr(SPyRO.getrequest()))
            except KeyError:
                pass
            mailadmin._sendmail(mail_warn, mail_warn,"A %s warn was detected "%msgtype, "\n".join(msg) )
else:
    warn_handler = None
    
def _log_function(logid, logname):
    res = ["main", logname]
    try:
        xreq = SPyRO.getrequest()
    except KeyError:
        return res
    try:
        res.append("usr-"+ xreq['auth'][0])
    except (KeyError,TypeError,IndexError),e:
        sys.stderr.write("auth:"+repr(e)+"\n")
        pass
    try:
        res.append("obj-" + xreq['objname'])
    except KeyError,e:
        sys.stderr.write("objname:"+repr(e)+"\n")
        pass
    return res

def log_openfun(logid, logname):
    return file("logs/warn.%s.%s"%(logid,logname),"ab",0)

logger = warn.logger_create_by_function("main", log_function, openfun=log_openfun, hookfun=warn_handler) # Using the SPyRO's Module
warn.set_main_log_function(logger)
###
### The main rewrite function, if you want it, or set a variable main_rewrite to None if not
###

def main_rewrite(request):
    # You can rewrite use request.path, request.method, request.headers
    if request.uri in ('/','/index.html'):
        request.uri = '/call/pages/index'
    else:
        for x in ('/?','/index.html?'):
            if request.uri.startswith(x):
                request.uri = '/call/pages/index?%s'%(request.uri[len(x):])

###
### 
### prototype
# def vectorize(doc):
#     res = {}
#     maxfreq = 0
#     for w in wordreg.findall(doc):
#         w = w.lower()
#         # normalize, stemme, expand, etc
#         try:
#             res[w] = freq = res[w] + 1
#         except KeyError:
#             freq = res[w] = 1
#         maxfreq = max(maxfreq, freq)
#     return res, maxfreq

def server_run(spyroserver, httpserver):
    # server.serve_forever()
    import asyncore
    if launch_browser:
        import launch_webbrowser
        launch_webbrowser.launch("http://%s:%s/"%(local_server_address))
    asyncore.loop()
    
