var __DOM3K_dictauth = new Array();
var __DOM3K_defaultcookiename = 'SPyRO_AuthMethod';
var __DOM3K_authdefaultexpirationscalar = 60 * 60 * 24 * 7;
var __DOM3K_checkexpiration = 60 * 60;
var __DOM3K_authdefaultexpiration = new Array();
var __DOM3K_authdefaultpath = new Array();
var __DOM3K_previousauthentications = new Array();

function DOM3K_AuthSetDefaultCookieName(cookiename)
{
    __DOM3K_defaultcookiename = cookiename;
}

function DOM3K_AuthGetDefaultCookieName()
{
    return __DOM3K_defaultcookiename;
}

function DOM3K_AuthSetDefaultCookieExpiration(cookiename,timeinsecondsfromnow)
{
    if (cookiename == null) cookiename = DOM3K_AuthGetDefaultCookieName();
    __DOM3K_authdefaultexpiration[cookiename] = timeinsecondsfromnow;
}

function DOM3K_AuthGetDefaultCookieExpiration(cookiename)
{
    if (cookiename == null) cookiename = DOM3K_AuthGetDefaultCookieName();
    var e = __DOM3K_authdefaultexpiration[cookiename];
    if (e == null) {
	return __DOM3K_authdefaultexpirationscalar;
    }
    return e;
}

function DOM3K_AuthSetPath(cookiename, path)
{
    if (cookiename == null) cookiename = DOM3K_AuthGetDefaultCookieName();
    __DOM3K_authdefaultpath[cookiename] = path;
}

function DOM3K_AuthGetPath(cookiename)
{
    if (cookiename == null) cookiename = DOM3K_AuthGetDefaultCookieName();
    var e = __DOM3K_authdefaultpath[cookiename];
    if (e == null) {
	return document.location.pathname;
    }
    return e;
}

function DOM3K_AuthFromCookie(cookiename)
{
    if (cookiename == null) cookiename = DOM3K_AuthGetDefaultCookieName();
    var cookies = DOM3K_getCookieDict();
    cookievalue = cookies[cookiename];
    if (cookievalue && cookievalue != '') {
        var authcookies = cookievalue.split(",");
	var authvalues = new Array();
	for (var x = 0; x < authcookies.length; x++) {
	    authvalues.push(cookies[authcookies[x]]);
	}
	if (authvalues.length == 0) return null;
	__DOM3K_dictauth[cookiename] = authvalues;
	var dtime = (new Date()).getTime() / 1000.0;
	if (__DOM3K_previousauthentications[cookiename] == null || (dtime - __DOM3K_previousauthentications[cookiename]) > __DOM3K_checkexpiration) {
	    var f = function(d) {
		DOM3K_AuthSetAuth(cookiename, authvalues[0], d);
	    }
	    call2({'handler' : f}, 'auth', 'update_authentication',[authvalues[0],authvalues[1]]);
	    __DOM3K_previousauthentications[cookiename] = dtime;
	}
	return authvalues;
    } else {
	return null;
    }
}

function DOM3K_AuthSetAuth(cookiename, user, data)
{
    __DOM3K_dictauth[cookiename] = data;
    var locale = DOM3K_GetLocale();
    if (!data) { /* error in the authentication */
	alert(locale['auth_msg_auth_not_valid']);
	return DOM3K_GetAuth(callwhenauthenticate, cookiename);
    }    
    var cookienameuser = cookiename + '_user';
    var cookienameauth = cookiename + '_auth';
    var expiration = DOM3K_AuthGetDefaultCookieExpiration(cookiename);
    var path = DOM3K_AuthGetPath(cookiename);
    DOM3K_setCookie(cookiename, cookienameuser + ',' + cookienameauth, expiration, path);
    DOM3K_setCookie(cookienameuser, user, expiration, path);
    DOM3K_setCookie(cookienameauth, data, expiration, path);
}

function DOM3K_HasAuth(cookiename)
{
    if (cookiename == null) cookiename = DOM3K_AuthGetDefaultCookieName();
    authcookie = DOM3K_AuthFromCookie(cookiename);
    if (authcookie == null) return false;
    return authcookie[1] != '';
}

DOM3K_RegisterLocaleDictionary ({
    'es' : {
	'auth_submit' : 'Enviar',
	'auth_password' : 'Clave',
	'auth_username' : 'Usuario',
	'auth_windowname' : 'Autenticacion',
	'auth_msg_auth_not_valid': 'La autenticacion no es valida\nFavor de autenticarse nuevamente para realizar la operacion'
    },
    'en' : {
	'auth_submit' : 'OK',
	'auth_password' : 'Password',
	'auth_username' : 'Username',
	 'auth_windowname' : 'Authentication',
	 'auth_msg_auth_not_valid': 'The authentication is not valid.\nYou must authenticate your self again in order to perform this operation\nYou will be asked again for authentication'
    }
});

function DOM3K_GetAuth(callwhenauthenticate,cookiename)
{
    if (cookiename == null) cookiename = DOM3K_AuthGetDefaultCookieName();
    if (DOM3K_HasAuth(cookiename)) {
	return DOM3K_AuthFromCookie(cookiename);
    }
    var locale = DOM3K_GetLocale();
    var user;
    var password;
    var form = document.createElement("form");
    form.setAttribute("action","javascript: void(0);");
    var userinput = document.createElement("input");
    var passinput = document.createElement("input");
    var submit = document.createElement("input");
    submit.setAttribute("name","OK");
    submit.setAttribute("value",locale['auth_submit']);
    submit.setAttribute("type","submit");
    userinput.setAttribute("name","user");
    userinput.setAttribute("type","text");
    userinput.setAttribute("value","");
    passinput.setAttribute("name","password");
    passinput.setAttribute("value","");
    passinput.setAttribute("type","password");
    form.onsubmit = function(event) {
	frame.deleteFrame();
	user = userinput.value;
	password = passinput.value;
	var xhandler = function (d) {
	    DOM3K_AuthSetAuth(cookiename, user, d);
	    if (callwhenauthenticate) {
		callwhenauthenticate([user,d]);
	    }
	}
	call2({'handler': xhandler},'auth', 'create_authentication',[user,password]);
    }
    var clave = DOM3K_createElement([locale['auth_password'] + ':',passinput],"div");
    var nombre = DOM3K_createElement([locale['auth_username'] + ':',userinput],"div");
    DOM3K_appendListToElement([nombre,
			       clave,
			       DOM3K_createElement(['',submit],"div")], form);
    form.style.textAlign = "right";
    var frame = DOM3K_createFrame(form,"title='"+locale['auth_windowname']+"'");
    return null;
}

function DOM3K_Call(callback,cookiename)
{
    if (cookiename == null) cookiename = DOM3K_AuthGetDefaultCookieName();
    if (DOM3K_HasAuth(cookiename)) {
	callback(__DOM3K_dictauth[cookiename]);
    } else {
	DOM3K_GetAuth(callback,cookiename);
    }
}

function DOM3K_DelAuth(cookiename)
{
    if (cookiename == null) cookiename = DOM3K_AuthGetDefaultCookieName();
    var path = DOM3K_AuthGetPath(cookiename);
    DOM3K_setCookie(cookiename, null, 0, path);
    DOM3K_setCookie(cookiename + '_user', null, 0, path);
    DOM3K_setCookie(cookiename + '_auth', null, 0, path);
}
