var __DOM3K_ManagedMenus = new Array();

/*
  function DOM3K_Menu(options) 
  
  Returns a menu with options |options|.
  Valid options:
  |menutype| must be one of the following string names:
  
  "float" Floating menu, it will rise at element's  right, and will float over the page
  "bottom" The menu will be located below the clicked element, it resize containers.
 
  Following options are valid only for automatically generated menus with DOM3K_MenuSet, in other cases it must be manually handled:
  
  |expand| The expand behaviour
  "onclick" Expand when a click event is performed
  "onmouseover" When the mouse is over the element, quit when onmouseout event is performed
  Example DOM3K_Menu("type='float'")
*/
function DOM3K_Menu(options) {
    
    var menu = new Object();
    menu.Items = new Array();
    var menutype = 'float';
    var expand = 'onclick';
    var name = '';
    eval(options);
    menu.expand = expand;
    menu.menutype = menutype;
    menu.name = name;

    menu.Deep = function (element)
	{
	    var x = 0;
	    for (x = 0; element.tagName.toLowerCase() != 'body'; x++) {
		element = element.parentNode;
	    }
	    return x;
	}

    menu.Show = function (data, element)
	{
	    var i = 0;
	    if (element == null) {
		if (menu.Items.length > 1) {
		    DOM3K_deleteElement(menu.Items[1][0]);
		    menu.Items = new Array();
		}
		return;
	    }
	    var deep = menu.Deep(element);
	    for (i = 0; i < menu.Items.length; i++) {
		var node = menu.Items[i][0];
		var nodedeep = menu.Items[i][1];
		if (nodedeep == deep) {
		    var e = null;
		    for(var j = menu.Items.length-1; j >= i; j--) {
			e = menu.Items.pop()[0];
		    }
		    if (e != null) {
			DOM3K_deleteElement(e.nextSibling);
		    }
		    if (e == element) return;
		    break;
		}
	    }
	    var e = DOM3K_createElement([data],(menutype == "float") ? "span" : "div");
	    DOM3K_appendToElement(e,element.parentNode);
	    menu.Items.push([element, menu.Deep(element)]);
	    if (menutype == "float") {
		e.style.position = "absolute";
	    } else {
		e.style.position = 'relative';
		e.style.left = '15pt';
	    }
	}
    return menu;
}

/*
function DOM3K_MenuSetAction(menu, X, i, link)

Internal function
*/
function DOM3K_MenuSetAction(menu, submenu, link) 
{
    var action = function(event) {
	menu.Show(DOM3K_MenuCreate(submenu, menu), link);
    }

    if (menu.expand == 'onmouseover') {
	link.onmouseover = action;
    }
    link.onclick = action;
}

/*function DOM3K_MenuCreate(X, menu)

  
Creates a DOM3K_Menu feeding the menu with a arrays. It returns a DOM Object

The menu's definition must have the form:

menu = [ sub-menu 0, sub-menu 1, ..., sub-menu n ]

sub-menu: menu-node|menu-leaf

menu-node = ['name', menu]
menu-leaf = [DOM-Object-OR-HTML-String, null]

For example:

var x = [
	     ['Search engines', [ ['<a href="http://www.google.com">Google</a>', null],
				  ['<a href="http://www.yahoo.com">Yahoo</a>', null]
				]
	      ],
	      ['News', [ ['Computers News', [
					     ['<a href="http://osnews.com/">OS News</a>', null],
					     ['<a href="http://slashdot.com/">Slashdot</a>', null]
					     ]],
			  ['Mexican Journals', [
						['<a href="http://www.milenio.com/">Milenio</a>', null],
						['<a href="http://www.jornada.unam.mx/">La Jornada</a>', null]
                                               ]]
			]
              ]
	     ];


var y = DOM3K_MenuCreate(x, DOM3K_Menu("float"));

And show the resulting menu with a DOM primitive.

Or the shorter way:

DOM3K_MenuSet("menu-name",x,"menutype='float'");
And the use DOM3K_MenuShow("menu-name");

 */

function DOM3K_MenuCreate(X, menu)
{
    var r = [];
    for (i in X) {
	var name = X[i][0];
	var submenu = X[i][1];
	var link;
	var close = false;
	if (submenu == null) {
	    link = name;
	    close = true;
	} else {
	    link = DOM3K_createElement([name],"a");
	    link.setAttribute("href","javascript: void(0);");
	    DOM3K_MenuSetAction(menu,submenu,link);
	}
	var elem = DOM3K_createElement([link], "div");
	elem.setAttribute("class","menuitem");
	if (close) DOM3K_addEventListener(elem, "click",function() { DOM3K_MenuHide(menu.name); }, false);
	r.push(elem);
    }
    var e = DOM3K_createElement(r,(menu.menutype == "float")?"span":"div");
    if (menu.menutype == "float") {
	e.style.position = "absolute";
    } else {
	e.style.position = "relative";
    }
    e.setAttribute("class","menu");
    return e;
}

/*function DOM3K_MenuSet(name, definition, menuoptions)

Save a menu definition with name |name| and definition |definition|. |menuoptions| is used to specify arguments to DOM3K_Menu
*/
function DOM3K_MenuSet(name, definition, menuoptions)
{
    __DOM3K_ManagedMenus[name] = [DOM3K_MenuCreate(definition, DOM3K_Menu(menuoptions + ',name="'+name+'"')),false];
}

/*
function DOM3K_MenuShow(self, name)

Shows the menu |name|, previously defined with DOM3K_MenuSet.
|self| is used as DOM object reference to positionate the menu

 */
function DOM3K_MenuShow(self, name)
{
    var menu = __DOM3K_ManagedMenus[name];
    if (menu[1]) {
    	DOM3K_MenuHide(name);
    } else {
	DOM3K_appendToElement(menu[0], self.parentNode);
	menu[1] = true;
    }
}

/*
function DOM3K_MenuHide(name)

Hides the menu with name |name|

*/
function DOM3K_MenuHide(name)
{
    var menu = __DOM3K_ManagedMenus[name];
    if (menu[1]) {
	DOM3K_deleteElement(menu[0]);
	menu[1] = false;
    }
}
