/*
Eric Sadit Tellez Avila

DOM3K issues related to Styles, and don't fill in any other category

*/

/*
function DOM3K_TableClass(idTag, listofclasses, headerclass, changeevery)

Set css class to rows elements in |idTag| element (it can contain several
tables and each table will me modified).

|listofclasses| A list of classes to use
|headerclass| The class of the header
|changeevery| Change every N rows


*/
function DOM3K_TableClass(idTag, listofclasses, headerclass, changeevery)
{
    if (!changeevery) {
	changeevery=1;
    }
    var skip = 0;
    if (headerclass) {
	skip = 1;
    }
    var elem = DOM3K_getElement(idTag);
    var rows = elem.getElementsByTagName('tr');
    var i;
    if (rows.length > 0 && headerclass) {
	rows.item(0).className = headerclass;
    }
    for (i = skip; i < rows.length; i++) {
	try {
	    rows.item(i).className = listofclasses[parseInt((i-skip)/changeevery) % listofclasses.length];
	} catch(e) {
	}
    }
}

/*
function DOM3K_BackgroundRowColors(idTag, listofcolors, headercolor, changeevery)

Set background colors to rows elements in |idTag| element (it can contain several
tables and each table will me modified).

|listofcolors| A list of colors to use
|headercolor| The color of the header
|changeevery| Change every N rows
*/
function DOM3K_BackgroundRowColors(idTag, listofcolors, headercolor, changeevery)
{
    if (!changeevery) {
	changeevery=1;
    }
    var skip = 0;
    if (headercolor) {
	skip = 1;
    }
    var elem = DOM3K_getElement(idTag);
    var rows = elem.getElementsByTagName('tr');
    var i;
    if (rows.length > 0 && headercolor) {
	rows.item(0).style.backgroundColor=headercolor;
    }
    for (i = skip; i < rows.length; i++) {
	try {
	    rows.item(i).style.backgroundColor = listofcolors[parseInt((i-skip)/changeevery) % listofcolors.length];
	} catch(e) {
	}
    }
}

/*
function DOM3K_BackgroundColumnColors(idTag, listofcolors)

Set background colors to td elements in the |idTag| element (it can contain several tables and each table will me modified).
|listofcolors| are the list of colors to be used

*/
function DOM3K_BackgroundColumnColors(idTag, listofcolors)
{
    var elem = DOM3K_getElement(idTag);
    var rows = elem.getElementsByTagName('td');
    var i;
    for (i = 0; i < rows.length; i++) {
	try {
	    rows.item(i).style.backgroundColor = listofcolors[i % listofcolors.length];
	} catch(e) {
	}
    }
}

/*
function DOM3K_TableClassColumn(idTag, listofclasses)

Set background colors to td elements in the |idTag| element (it can contain several tables and each table will me modified).
|listofclasses| A list of classes to be used

*/
function DOM3K_TableClassColumn(idTag, listofcolors)
{
    var elem = DOM3K_getElement(idTag);
    var rows = elem.getElementsByTagName('td');
    var i;
    for (i = 0; i < rows.length; i++) {
	try {
	    rows.item(i).className = listofcolors[i % listofcolors.length];
	} catch(e) {
	}
    }
}
