/*
function Easyform_readForm(idTagOrObject)

Reads a form, and validate the values against contrainst.

*/

function Easyform_errorHandler(elem, error)
{
    var elemcolor = elem.style.backgroundColor;
    var f;
    f = function (event) {
	elem.style.backgroundColor = elemcolor;
	DOM3K_removeEventListener(elem, "focus", f, true);
    }
    DOM3K_addEventListener(elem, "focus", f, true);
    elem.style.backgroundColor = '#FF0066';
}

/*
function Easyform_checkDate(name, value, elem)

Checks a date format of |value| (in html dom element |elem| and with name |name|)
*/

function Easyform_checkDate(name, value, elem)
{
    if (!value||value=="") return;
        var parts = value.split("-");
        var year = parts[0];
        var month = parts[1];
        var day = parts[2];
        var errors = '';
        if (year == null || month == null || day == null) {
                throw Easyform_errorHandler(elem,'' + name + ' has not a valid date: ' + value);
        }
	try {
		DOM3K_CheckInt(name, day);
		DOM3K_CheckInRange(name, __Easyform_parseInt(day), 1, 31);
	} catch(error) {
		Easyform_errorHandler(elem, error);
                errors += ' ' + error;
	}
	try {
		DOM3K_CheckInt(name, month);
		DOM3K_CheckInRange(name, __Easyform_parseInt(month), 1, 12);
	} catch(error) {
		Easyform_errorHandler(elem, error);
                errors += ' ' + error;
	}
	try {
		DOM3K_CheckInt(name, year);
	} catch(error) {
		Easyform_errorHandler(elem, error);
                errors += ' ' + error;
	}
        if (errors != '') {
                throw errors;
        }
}

/*
function Easyform_checkTime(name, value, elem)

Checks a time format of |value| (in html dom element |elem| and with name |name|)
*/
function Easyform_checkTime(name, value, elem)
{
    if (!value||value=="") return;
        var parts = value.split(":");
        var hour = parts[0];
        var minute = parts[1];
        var second = parts[2];
        var errors = '';
        if (hour == null || minute == null || second == null) {
                throw Easyform_errorHandler(elem,'' + name + ' has not a valid time: ' + value);
        }
	try {
		DOM3K_CheckInt(name, hour);
		DOM3K_CheckInRange(name, __Easyform_parseInt(hour), 0, 23);
	} catch(error) {
		Easyform_errorHandler(elem, error);
                errors += ' ' + error;
	}
	try {
		DOM3K_CheckInt(name, minute);
		DOM3K_CheckInRange(name, __Easyform_parseInt(minute), 0, 59);
	} catch(error) {
		Easyform_errorHandler(elem, error);
                errors += ' ' + error;
	}
	try {
		DOM3K_CheckInt(name, second);
		DOM3K_CheckInRange(name, __Easyform_parseInt(second), 0, 59);
	} catch(error) {
		Easyform_errorHandler(elem, error);
                errors += ' ' + error;
	}
        if (errors != '') {
                throw errors;
        }
}


var Easyform_Locale_Support = {
	'es' : {
		'list_month' : new Array('Enero','Febrero','Marzo','Abril','Mayo','Junio','Julio','Agosto','Septiembre','Octubre','Noviembre','Diciembre'),
                'frame_time_title': 'Entrada de hora',
                'frame_date_title': 'Entrada de fecha',
                'frame_datetime_title': 'Entrada de fecha y hora',
                'display_day' : 'Dia',
                'display_month': 'Mes',
                'display_year' : 'Ano',
                'display_hour' : 'Hora',
                'display_minute': 'Minuto',
                'display_second' : 'Segundo',
                'display_submit_datetime': 'Captura'
	},
	'en' : {
		'list_month' : new Array('January','February','March','April','May','June','July','August','September','October','November','December'),
                'frame_time_title': 'Time input',
                'frame_date_title': 'Date input',
                'frame_datetime_title': 'Date and time input',
                'display_day' : 'Day',
                'display_month': 'Month',
                'display_year' : 'Year',
                'display_hour' : 'Hour',
                'display_minute': 'Minute',
                'display_second' : 'Second',
                'display_submit_datetime': 'Enter'
	}
};

DOM3K_RegisterLocaleDictionary(Easyform_Locale_Support);

/*
function Easyform_setLocale(locale)

Picks a global locale
*/
function Easyform_setLocale(locale)
{
        Easyform_Language = locale;
        Easyform_Locale = Easyform_Locale_Support[Easyform_Language];
}

var Easyform_Language = 'es';
var Easyform_Locale;
Easyform_setLocale(Easyform_Language);

/*
function Easyform_createOptionRange(select, min, max, namearray)

Creates and append to select a set of option elements from mix to max. If |namearray|
is passed then it must be an array of names to show in the option element (indexed form 0 to N where N is max - min)

*/

function Easyform_createOptionRange(select, min, max, namearray)
{
	var option;
	var i;
	var counter = 0;
	for (i = min; i <= max; i++) {
		option = document.createElement('option');
		option.setAttribute('value', '' + i);
		if (namearray == null) {
		    DOM3K_setInnerXML(option, '' + i);
		} else {
		    DOM3K_setInnerXML(option, '' + namearray[counter]);
		}
		select.appendChild( option );
		counter++;
	}
}

function __Easyform_createElementWithLabel(node, element_label_list)
{
        for (var x = 0; x < element_label_list.length; x++) {
                var disp = document.createElement("strong");
                DOM3K_setInnerXML(disp, Easyform_Locale[element_label_list[x][1]] + ':');
                node.appendChild(disp);
                node.appendChild(element_label_list[x][0]);
        }

}

function __Easyform_createDate(form, default_date)
{	
        if (default_date == null || default_date == '') {
                var d = new Date();
                default_date = d.getFullYear() + '-' + (d.getMonth() + 1) + '-' + d.getDate();
        }
        var dvals = default_date.split('-');
	/* Year */
	var year = document.createElement('input');
	year.setAttribute('name', 'year');
	year.setAttribute('size', '4');
        year.setAttribute('value', dvals[0]);
	/* Month */
	var month = document.createElement('select');
	month.setAttribute('name', 'month');
	Easyform_createOptionRange(month, 1, 12, Easyform_Locale['list_month']);
        DOM3K_selectAnItem(month, __Easyform_parseInt(dvals[1]), __Easyform_parseInt);
	/* Day */
	var day = document.createElement('select');
	day.setAttribute('name','day');
	Easyform_createOptionRange(day, 1, 31);
        DOM3K_selectAnItem(day, __Easyform_parseInt(dvals[2]), __Easyform_parseInt);
        var data = [ [year, 'display_year'], [month, 'display_month'], [day, 'display_day'] ] ;
        __Easyform_createElementWithLabel(form, data);
        form.appendChild(document.createElement('br'));
}

function __Easyform_createTime(form, default_time)
{
        if (default_time == null || default_time == '') {
                var d = new Date();
                default_time = d.getHours() + ':' + d.getMinutes() + ':' + d.getSeconds();
        }
        var dvals = default_time.split(':');
	/* Hour */
	var hour = document.createElement('select');
	hour.setAttribute('name', 'hour');
	Easyform_createOptionRange(hour, 0, 23);
        DOM3K_selectAnItem(hour, __Easyform_parseInt(dvals[0]), __Easyform_parseInt);
	/* Minute */
	var minute = document.createElement('select');
	minute.setAttribute('name', 'minute');
	Easyform_createOptionRange(minute, 0, 59);
        DOM3K_selectAnItem(minute, __Easyform_parseInt(dvals[1]), __Easyform_parseInt);
	/* Second*/
	var second = document.createElement('select');
	second.setAttribute('name','second');
	Easyform_createOptionRange(second, 0, 59);
        DOM3K_selectAnItem(second, __Easyform_parseInt(dvals[2]), __Easyform_parseInt);
        var data = [ [hour, 'display_hour'], [minute, 'display_minute'], [second, 'display_second'] ];
        __Easyform_createElementWithLabel(form, data);
        form.appendChild(document.createElement('br'));
}

function __Easyform_appendSubmit(form, submitId)
{
        var submit = document.createElement('input');
        submit.setAttribute('name','');
        submit.setAttribute('type','submit');
        submit.setAttribute('value',Easyform_Locale[submitId]);
        form.appendChild(submit);

}

function __Easyform_readDateInt(value)
{
        if (value < 10) {
                return '0' + value;
        }
	return value;
}

function __Easyform_parseInt(value)
{
        return parseInt(value, 10);
}

/*
function Easyform_frameReadDate(initvalue, onsubmit, onsubmitsecondarg, top, left)

Shows an special frame to read a date.

|initvalue| The initial value as string 'yyyy-mm-dd'.
|onsubmit| Function to execute when you pick a date called as onsubmit('newdate as yyyy-mm-dd', onsumitsecondargument)
|onsubmitsecondargument| Second argument of onsubmit
|top| The length from top
|left| The length from the left side of the page

*/
function Easyform_frameReadDate(initvalue, onsubmit, onsubmitsecondarg, top, left)
{
	var f = DOM3K_createFrame();
	f.setFrameOnTop();
	var form = document.createElement('form');
	form.setAttribute('name','__DOM3K_readDate');
        form.setAttribute('action','javascript: void(0);');
        form.onsubmit = function() {
                var dict = DOM3K_formToDict(form);
                onsubmit(__Easyform_readDateInt(dict['year']) + '-' + __Easyform_readDateInt(dict['month']) + '-' + __Easyform_readDateInt(dict['day']), onsubmitsecondarg);
                f.deleteFrame();
        }
	__Easyform_createDate(form, initvalue);
        __Easyform_appendSubmit(form, 'display_submit_datetime');
	f.div.appendChild(form);
        f.setTitle(Easyform_Locale["frame_date_title"]);
	if (f.container.style.position == 'fixed') {
	    if (top != null) f.container.style.top = top;
	    if (left != null) f.container.style.left = left;
	}
	return f;
}

/*
function Easyform_frameReadTime(initvalue, onsubmit, onsubmitsecondarg, top, left)

Shows an special frame to read a time value.

|initvalue| The initial value as string 'hh:mm:ss'.
|onsubmit| Function to execute when you pick a time called as onsubmit('newtime as hh-mm-ss', onsumitsecondargument)
|onsubmitsecondargument| Second argument of onsubmit
|top| The length from top
|left| The length from the left side of the page

*/

function Easyform_frameReadTime(initvalue, onsubmit, onsubmitsecondarg, top, left)
{
	var f = DOM3K_createFrame();
	f.setFrameOnTop();
	var form = document.createElement('form');
	form.setAttribute('name','__DOM3K_readTime');
        form.setAttribute('action','javascript: void(0);');
        form.onsubmit = function() {
                var dict = DOM3K_formToDict(form, initvalue);
                onsubmit(__Easyform_readDateInt(dict['hour']) + ':' + __Easyform_readDateInt(dict['minute']) + ':' + __Easyform_readDateInt(dict['second']), onsubmitsecondarg);
                f.deleteFrame();
        }
	__Easyform_createTime(form, initvalue);
        __Easyform_appendSubmit(form, 'display_submit_datetime');
	f.div.appendChild(form);
        f.setTitle(Easyform_Locale["frame_time_title"]);
	if (f.container.style.position == 'fixed') {
	    if (top != null) f.container.style.top = top;
	    if (left != null) f.container.style.left = left;
	}
	return f;
}

/*
function Easyform_frameReadDatetime(initvalue, onsubmit, onsubmitsecondarg, top, left)

Shows an special frame to read a date and time value.

|initvalue| The initial value as string 'yyyy-mm-dd hh:MM:ss'.
|onsubmit| Function to execute when you pick a date and time value called as onsubmit('newdatetime as yyyy-mm-dd hh:MM:ss', onsumitsecondargument)
|onsubmitsecondargument| Second argument of onsubmit
|top| The length from top
|left| The length from the left side of the page

*/

function Easyform_frameReadDatetime(initvalue, onsubmit, onsubmitsecondarg, top, left)
{
	var f = DOM3K_createFrame();
	f.setFrameOnTop();
	var form = document.createElement('form');
	form.setAttribute('name','__DOM3K_readDatetime');
        form.setAttribute('action','javascript: void(0);');
        form.onsubmit = function() {
                var dict = DOM3K_formToDict(form);
                var date = __Easyform_readDateInt(dict['year']) + '-' + __Easyform_readDateInt(dict['month']) + '-' + __Easyform_readDateInt(dict['day']);
                var time = __Easyform_readDateInt(dict['hour']) + ':' + __Easyform_readDateInt(dict['minute']) + ':' + __Easyform_readDateInt(dict['second']);
                onsubmit(date + ' ' + time, onsubmitsecondarg);
                f.deleteFrame();
        }
        var dvals = initvalue.split(new RegExp("\\s+"))
	__Easyform_createDate(form,dvals[0]);
	__Easyform_createTime(form,dvals[1]);
        __Easyform_appendSubmit(form, 'display_submit_datetime');
        f.setTitle(Easyform_Locale["frame_datetime_title"]);
	f.div.appendChild(form);
	if (f.container.style.position == 'fixed') {
	    if (top != null) f.container.style.top = top;
	    if (left != null) f.container.style.left = left;
	}
	return f;
}

/*
function Easyform_formToDict(idTag)

  this function reads the form with DOM3K_readForm and parses the values, then
  rewrite values in a new dictionary, then it validate the data against its type
  constraints. Any validation against other constraints (i.e. value in a set, in
  a range, arity, etc) must be performed outside this function.
*/

function Easyform_formToDict(idTag)
{
	var form = DOM3K_getElement(idTag);
	var dict = DOM3K_formToDict(form);
        var dnew = new Array(); /*result*/
        var errors = '';
	/* name:type[:field] */

	for (d in dict) {
		parts = d.split(':');
		var name; var value; var type; var field;
		name = parts[0];
                if (name == '') continue;
		type = parts[1];
		value = dict[d];
                /*alert(name + ':' + type + ':' + __Easyform_parseInt(value));*/
                if (type == 'int') {
			try {
				DOM3K_CheckInt(name, value);
                                value = parseInt(value);
			} catch(error) {
				Easyform_errorHandler(form[d], error);
                                errors += ' ' + error;
			}
		} else if (type == 'float') {
			try {
				DOM3K_CheckFloat(name, value);
                                value = parseFloat(value);
			} catch(error) {
				Easyform_errorHandler(form[d], error);
                                errors += ' ' + error + value;
			}
		} else if (type == 'date') {
                        try {
			     Easyform_checkDate(name, value, form[d]);
                        } catch(error) {
                                errors += ' ' + error;
                        }

		} else if (type == 'time') {
                        try {
			     Easyform_checkTime(name, value, form[d]);
                        } catch(error) {
                                errors += ' ' + error;
                        }
		} else if (type == 'datetime') {
                        var datetime = value.split(' ');
                        var date; var time;
			date = datetime[0];
			time = datetime[1];

                        try {
			     Easyform_checkDate(name, date, form[d]);
                        } catch (error) {
                                errors += ' ' + error;
                        }
                        try {
			     Easyform_checkTime(name, time, form[d]);
                        } catch (error) {
			    alert("Name:" + name +", time:" + time +", form[d]:" + form[d] + "Error:" + error);
			    errors += ' ' + error;
                        }
		} else if (type == 'boolean') {
		        value = (value == 't');
                }

		var ismandatory = false;
                if (parts.length > 2) {
                        for (var x = 2; x < parts.length; x++) {
                                if (parts[x] == 'mandatory') {
				        ismandatory = true;
                                        try {
                                                DOM3K_CheckMandatory(name, value);
                                        } catch(error) {
                                                Easyform_errorHandler(form[d], error);
                                                errors += ' ' + error;
                                        }
                                } 
                        }
                }
		if (!ismandatory) {
		    if (typeof(value) == 'number') {
			if (isNaN(value)) {
			    continue;
			}
		    } else if(value == '') {
			continue;
		    }
		}
                dnew[name] = value;
	}
        if (errors != '') {
                alert(errors);
                throw errors;
        }
        return dnew;
}

/* function Easyform_dictToForm(idTag,dict)

Fills a form with idTag (idTag can be the html id or the DOM object) with the
values of dictionary

*/
function Easyform_dictToForm(dict, idTag)
{
     return DOM3K_dictToForm(dict, idTag, ':');
}
