import template3k
import warn 
import db3k
from shttp import http
import SPyRO as spyro
import auth3k
import auth3k.authweb as authweb
_spyro_authentication = authweb.Auth()
# To set permisions to the global module or object, uncomment the following
# [ [allowed users list], [ allowed groups list], [ denied user list] ]
_spyro_authentication.perms['catalogos.caja'] = [[], ['caja_usuario', 'caja_admin'], []]

# to initialize the module
import catalogos
catalogos.index()
dbtxn = catalogos.db
cotizaciones = {}

index_persona = None
index_estados_venta = None
index_estados_fiscales = None
index_tipo_pago = None
index_codigo_barras = None
index_catalogo_producto = None
index_productos = None

import time
import random
def _get_email():
    email = spyro.getrequest()['auth'][0]
    if email == 'sadit': email = 'donsadit@gmail.com'
    return email

def generate_idventa():
    xid = index_persona[_get_email()]['xid']
    return "%s%s%s"%(xid, time.strftime("%y%m%d%H%M%S"),random.randint(100,999))

def _reload_caches():
    global index_persona, index_estados_venta, index_estados_fiscales, index_tipo_pago
    global index_codigo_barras, index_catalogo_producto, index_productos
    index_persona = db3k.index_result(dbtxn.hquery("SELECT * FROM persona"), "email")
    index_codigo_barras = db3k.index_result(dbtxn.hquery("SELECT * FROM producto"), "codigo_barras")
    index_productos = db3k.index_result(dbtxn.hquery("SELECT * FROM producto"), "xid")
    index_catalogo_producto = db3k.index_result(dbtxn.hquery("SELECT * FROM catalogo_producto"), "idproducto")
    index_estados_venta = db3k.index_result(dbtxn.hquery("SELECT * FROM estados_venta"), "nombre")
    index_estados_fiscales = db3k.index_result(dbtxn.hquery("SELECT * FROM estados_fiscales"), "nombre")
    index_tipo_pago = db3k.index_result(dbtxn.hquery("SELECT * FROM tipo_pago"), "nombre")

_reload_caches()

def index(**kwargs):
    temp = template3k.get_template("opt-objects/catalogos/caja_template.html")
    return temp.merge()

def _monto_venta(venta):
    total = dbtxn.query("SELECT SUM(costo_final*cantidad) FROM venta_productos WHERE idventa = %(xid)s"%venta)[0][0]
    return total

def remove_productos(idproducto):
    email = _get_email()
    try:
        venta = cotizaciones[email]
    except KeyError:
        return ()
    if venta['estado_venta'] == 'PAGADA':
        return (('Informacion','Esta venta ha sido pagada, debe iniciar una nueva','','frame'),)
    dbtxn.delete("venta_productos", {'idventa': venta['xid'], 'idproducto': idproducto})
    return list_productos() 

def list_productos(**kwargs):
    email = _get_email()
    try:
        venta = cotizaciones[email]
    except KeyError:
        return ()
    if venta['estado_venta'] == 'PAGADA':
        return (('Informacion','Esta venta ha sido pagada, debe iniciar una nueva','','frame'),)
    fields = ['idventa', 'idproducto', 'cantidad', 'costo_final']
    listprod = dbtxn.query("SELECT %s FROM venta_productos WHERE idventa = %s ORDER BY rowid DESC"%(",".join(fields),venta['xid']))
    def remove_gen(loc):
        q = loc['q']
        return [
            """<a href="javascript: callto({'handler': Show},'catalogos.caja', 'remove_productos', """
            """ null, {'idproducto': '%s'}); void(0);">Borrar</a>"""%(q[1])
            ]

    def map_result(tabname, field, data, outmap, config):
        if field == 'idproducto':
            return index_productos[data]["nombre"]
        return str(data)

    config = {'internal_fields': ['idventa'],
              'outmap': None,
              'structured_search': lambda: False,
              'indexable': lambda: False,
              'insertable': lambda: False,
              'control_generator': remove_gen,
              'map_result': map_result
              }
    listprod = catalogos._out_list('venta_productos', fields, listprod, None, config)
    total = _monto_venta(venta)
    if not total:
        total = 0.0
    return (( '', listprod, 'list_venta_productos'),
            ( '', "%0.2f"%(total), 'Total'),
            ( 'DOM3K_getElement("barcode").focus();', '', '','javascript'),
            ('', '', 'Cobro')
            )

def paga_venta(monto, tipo_pago='EFECTIVO', **kwargs):
    email = _get_email()
    try:
        venta = cotizaciones[email]
    except KeyError:
        return (('document.location.reload();','','','javascript'),)
    if venta['estado_venta'] == 'PAGADA':
        return (('Informacion','Esta venta ha sido pagada','','frame'),)
    total = _monto_venta(venta)
    monto = float(monto)
    if monto < total:
        return (('Aviso Error','El monto recibido debe ser de al menos %s'%(total),'', 'frame'),)
    venta['estado_venta'] = 'PAGADA'
    idventa = venta['xid']
    txn = "%s-%s"%(idventa, random.random())
    dbtxn.execute("UPDATE venta SET estado_venta = 'PAGADA' WHERE xid = '%s'"%(idventa))
    dbtxn.execute("INSERT INTO pagos (idventa, fecha_pago, costo, txid, type) VALUES('%s', current_timestamp, %s, '%s', '%s')"%(idventa, total, txn, tipo_pago))
    del cotizaciones[email]
    # abrir cajon
    return (('', "%0.2f"%(monto-total), 'cambio'),
            ('var f = DOM3K_createFrame(data[1], data[2]); f.div.className = "ListaProductos"; f.div.style.backgroundColor="black";',
             """<pre>"""
             """Muchas gracias por su compra.\n"""
             """=============================\n"""
             """ Monto: %0.2f\n"""
             """  Pago: %0.2f\n"""
             """Cambio: %0.2f"""
             """</pre>"""
             %(total,monto,monto-total),
             'Cobro'),
            )

def form_caja_cobros(venta):
    f = """
    <div class="ListaProductos">
    <form action="javascript: void(0);" onsubmit="callto({'handler': Show}, 'catalogos.caja', 'paga_venta', null, Easyform_formToDict(this));">
    <table><tbody>
    <tr><td>Recib&iacute; monto:</td><td><input name="monto:float" type="text" value="" id="monto" /></td></tr>
    <tr><td>Cambio:</td><td><div id="cambio">0.00</div></td></tr>
    <tr><td>&nbsp;</td><td><input name=":string" type="submit" value="Pagar"/></td></tr>
    </form>
    <div>
    <script type="text/javascript">
    DOM3K_getElement('monto').focus();
    </script>
    """
    return f
    
def close_venta(cancelar=None):
    email = _get_email()
    try:
        venta = cotizaciones[email]
    except KeyError:
        return (('', '0.00', 'Total'),
                ('', '', 'Cobro'),
                ('', '', 'list_venta_productos'))
    if cancelar:
        estado = 'CANCELADA'
        del cotizaciones[email]
    else:
        estado = 'COMPLETADA'
    dbtxn.execute("UPDATE venta SET estado_venta = '%s' WHERE xid = %s"%(estado,venta['xid']))
    ventadata = dbtxn.hquery("SELECT * FROM venta WHERE xid = %(xid)s"%venta)
    # send to server
    if cancelar:
        return (('', '0.00', 'Total'),
                ('', '', 'list_venta_productos'),
                ('', '', 'Cobro')
                )
    else:
        return (('Cobro',form_caja_cobros(venta),'Cobro'),
                ('DOM3K_getElement("monto").focus(); ','','','javascript')
                )

def insert_productos(codigo_barras='', cantidad=1, **kwargs):
    if codigo_barras == '':
        return list_productos()
    email = _get_email()
    try:
        ventadata = cotizaciones[email]
        if ventadata['estado_venta'] == 'PAGADA':
            return (('Informacion','Esta venta ha sido pagada. No puede modificarse','','frame'),)
    except KeyError:
        _reload_caches()
        ventadata = {'personaid': 'anonimo',
                     'vendedorid': index_persona[email]['xid'],
                     'estado_venta': index_estados_venta['COTIZACION']['nombre'],
                     'estado_fiscal': index_estados_fiscales['NOTA_VENTA']['nombre'],
                     }
        cotizaciones[email] = ventadata
        ventadata['xid'] = generate_idventa()
        catalogos.modify_venta('insert', ventadata, None, dbconn=dbtxn)
    try:
        idproducto = index_codigo_barras[codigo_barras]['xid']
    except KeyError, e:
        print repr(index_codigo_barras), e
        raise Exception("Producto no encontrado %s"%repr(codigo_barras))
    res = dbtxn.query("""SELECT 1 FROM venta_productos """
                      """ WHERE idventa = %s AND idproducto = %s"""%(ventadata['xid'], idproducto))
    if len(res) == 0:
        catalogos.modify_venta_productos('insert',
                                         {'idventa': ventadata['xid'],
                                          'idproducto': idproducto,
                                          'cantidad': cantidad,
                                          'costo_final': index_catalogo_producto[idproducto]['costo']
                                          },
                                         None,
                                         dbconn=dbtxn)
    else:
        dbtxn.execute("""UPDATE venta_productos SET cantidad = cantidad + %s """
                   """ WHERE idventa = '%s' AND idproducto = '%s'"""
                   """ """%(int(cantidad), ventadata['xid'], idproducto))
    warn.debug("modificar existencias cuando se paga o aqui?")
    return list_productos()
