#coding: utf8;

__doc__ = ''' Easyform server to escuelas.escuelas '''

import auth3k
import auth3k.authweb as authweb
_spyro_authentication = authweb.Auth()
# To set permisions to the global module or object, uncomment the following
# [ [allowed users list], [ allowed groups list], [ denied user list] ]
_spyro_authentication.permsobject['escuelas.escuelas'] = [[],['admin'],[]]
# Note: In module objects the object name must be the name of the object. If an authobject is
# manages many objects, there may exists many object names

# For method level management
# _spyro_authentication.perms['methodname'] = [[],['admin'],[]]

# Gets automatically the connection because is already charged
import re
import warn
import db3k
import time
import locale3k
import template3k
import SPyRO as spyro
import appconfig
import ft3k
import types
# import marshal

dbmanager='sqlite3'
if dbmanager.startswith('sqlite'): # param style qmark
    likechar = '%'
else:
    likechar = '%%'
db = db3k.Connection(name='db/escuelas',
                     database='db/escuelas',
                     user='',
                     password='',
                     host=None,
                     manager=dbmanager)

ftname="ft%s"%('db/escuelas')
ftpool=db3k.ThreadPool(ftname, dbmanager)
dbftindex = db3k.Connection(
                     name=ftname,
                     database='db/escuelas',
                     user='',
                     password='',
                     host=None,
                     manager=dbmanager,
                     pool=ftpool)

#######################################
#######################################
#############
############  INDEX
#############
#######################################
#######################################
def index(**kwargs):
    objname = 'escuelas.escuelas'
    title = 'Escuelas.Escuelas'
    temp = template3k.get_template(appconfig.template_admin)
    return temp.merge(PageTitle=objname.title(),
                      Menu='''<td><a href="index">%s</a></td>'''%objname.title(),
                      JavascriptInit='''callto({'handler':Show},'escuelas.escuelas','showpage')''',
                      DevelQuote='',
                      Title='Module ' + title,
                      Content=''
                      )

def showpage(**kwargs):
    objname = 'escuelas.escuelas'
    import time
    itime = time.time()
    if True:
        for x in ['persona', 'alumno_tutor', 'materia', 'persona_materia', 'calificacion_parcial', 'mensaje']:
            # print "DDDDD manage ft: ", x
            eval("manage_fulltext_%s"%x)(0,1)
    print "***********************************> index time: ", time.time() - itime
    
    res = []
    res.append(('Persona',list_persona(),'persona'))
    res.append(('Alumno Tutor',list_alumno_tutor(),'alumno_tutor'))
    res.append(('Materia',list_materia(),'materia'))
    res.append(('Persona Materia',list_persona_materia(),'persona_materia'))
    res.append(('Calificacion Parcial',list_calificacion_parcial(),'calificacion_parcial'))
    res.append(('Mensaje',list_mensaje(),'mensaje'))
    return res



#######################################
#####
####   COMMON CUSTOMIZABLE FUNCTIONS
#####
#######################################
def _sql_quote(f):
    return str(f).replace("'","''")

def _join_cond(d,joinmethod=None):
    try:
        items = d.items()
    except AttributeError:
        return ' 1=1 '
    if len(items) == 0:
        return ' 1=1 '
    else:
        if joinmethod == 'LIKE':
            return ' AND '.join([ "%s LIKE '%s%s'"%(_sql_quote(x[0]),_sql_quote(x[1]),likechar) for x in d.items()])
        else:
            return ' AND '.join([ "%s = '%s'"%(_sql_quote(x[0]),_sql_quote(x[1])) for x in d.items()])

def _quote_html(f):
    return f.replace("<","&lt;").replace(">","&gt;") #.replace("&","&amp;")

def _strip_field(value):
    if value is None:
        return ''
    elif type(value) in types.StringTypes:
        for enc in ("utf8","latin1","latin2","latin3","utf16"):
            try:
		return value.encode(enc).decode(enc)
                # return value.encode(enc)
            except (UnicodeDecodeError,UnicodeEncodeError), e:
                warn.debug("Ignoring and Retrying on UnicodeError (enc, value, error): ", repr((enc, value, e)))
        enc = "utf8"
        return value.decode(enc,"replace")
        # return value.encode(enc,"replace")
    else:
        return str(value)

def _strip_dict(d):
    for k,v in d.items():
        try:
            d[k] = _strip_field(d[k])
        except AttributeError:
            pass
    return d

def _pager(begin, count, total, template, num=15):
    xres = [ "Viewing %s elements (starting at %sth) from %s total entries "%(min(count,total-begin), begin, total) ]
    start = max(begin - num * count, 0)
    for x in range(num*2):
        page_number = start / count + 1
        if start == begin:
            xres.append("%s&nbsp;"%page_number)
        else:
            xres.append( template % locals() )
        start += count
        if start > total:
            if page_number == 1: return []
            break
    return xres

######
##### Global data
######

objname = 'escuelas.escuelas'

#######################################################################################
#######################################################################################
######
######   FORMS
######
#######################################################################################
#######################################################################################
modconfig = {}
###############################################################################################
###############################################################################################
###
### Table persona UI
###

### Configuring persona

modconfig['persona'] = {
    'internal_fields' : [],
    'dict_default': { '' : '<python:locale id="general.submit" />','fecha_nacimiento' : '','telefono1' : '','calle' : '','curp' : '','telefono2' : '','colonia' : '','observaciones' : '','numero' : '','sexo' : '','apellidos' : '','matricula' : '','nombre' : '','login' : '','nacionalidad' : '','estado' : '','id' : '','municipio' : '','tipo' : '',
                     '__objname__': 'escuelas.escuelas',
                     '__tabname__': 'persona',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='persona', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['id', 'nombre', 'apellidos', 'fecha_nacimiento', 'sexo', 'telefono1', 'telefono2', 'calle', 'numero', 'colonia', 'municipio', 'estado', 'nacionalidad', 'curp', 'login', 'matricula', 'tipo', 'observaciones'],
    'preview_fields': ['id', 'nombre', 'apellidos', 'fecha_nacimiento', 'sexo', 'telefono1', 'telefono2', 'calle', 'numero', 'colonia', 'municipio', 'estado', 'nacionalidad', 'curp', 'login', 'matricula', 'tipo', 'observaciones'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("persona:form_element",
     """
            <strong>Persona</strong>
            <form method="POST" enctype="multipart/form-data" id="form-persona<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="persona" >
                <table><tbody>
            
<tr><td>
<python:locale id="persona.id">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Id'} ]
</python:locale>:</td><td><input name="id:int:" type="text" value="<python:keyword id="id" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string:mandatory" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.apellidos">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Apellidos'} ]
</python:locale>:</td><td><input name="apellidos:string:mandatory" type="text" value="<python:keyword id="apellidos" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.fecha_nacimiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Nacimiento'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" />
            <input type="text" name="fecha_nacimiento:date:" value="<python:keyword id="fecha_nacimiento" />" onclick="Easyform_frameReadDate(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>


<tr><td>
<python:locale id="persona.sexo">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Sexo'} ]
</python:locale>:</td><td><input name="sexo:string:" type="text" value="<python:keyword id="sexo" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.telefono1">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Telefono1'} ]
</python:locale>:</td><td><input name="telefono1:string:" type="text" value="<python:keyword id="telefono1" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.telefono2">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Telefono2'} ]
</python:locale>:</td><td><input name="telefono2:string:" type="text" value="<python:keyword id="telefono2" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.calle">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Calle'} ]
</python:locale>:</td><td><input name="calle:string:" type="text" value="<python:keyword id="calle" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.numero">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Numero'} ]
</python:locale>:</td><td><input name="numero:string:" type="text" value="<python:keyword id="numero" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.colonia">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Colonia'} ]
</python:locale>:</td><td><input name="colonia:string:" type="text" value="<python:keyword id="colonia" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.municipio">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Municipio'} ]
</python:locale>:</td><td><input name="municipio:string:" type="text" value="<python:keyword id="municipio" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.estado">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Estado'} ]
</python:locale>:</td><td><input name="estado:string:" type="text" value="<python:keyword id="estado" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.nacionalidad">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nacionalidad'} ]
</python:locale>:</td><td><input name="nacionalidad:string:mandatory" type="text" value="<python:keyword id="nacionalidad" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.curp">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Curp'} ]
</python:locale>:</td><td><input name="curp:string:mandatory" type="text" value="<python:keyword id="curp" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.login">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Login'} ]
</python:locale>:</td><td><input name="login:string:" type="text" value="<python:keyword id="login" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.matricula">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Matricula'} ]
</python:locale>:</td><td><input name="matricula:string:" type="text" value="<python:keyword id="matricula" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.tipo">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Tipo'} ]
</python:locale>:</td><td><input name="tipo:string:" type="text" value="<python:keyword id="tipo" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.observaciones">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Observaciones'} ]
</python:locale>:</td><td><textarea cols="50" rows="12" name="observaciones:text:" ><python:keyword id="observaciones" /></textarea></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("persona:form_element_search",
     """
            <strong>Persona</strong>
            <form method="POST" enctype="multipart/form-data" id="form-persona<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="persona" >
                <table><tbody>
            
<tr><td>
<python:locale id="persona.id">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Id'} ]
</python:locale>:</td><td><input name="id:int:" type="text" value="<python:keyword id="id" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.apellidos">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Apellidos'} ]
</python:locale>:</td><td><input name="apellidos:string" type="text" value="<python:keyword id="apellidos" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.fecha_nacimiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Nacimiento'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" />
            <input type="text" name="fecha_nacimiento:date:" value="<python:keyword id="fecha_nacimiento" />" onclick="Easyform_frameReadDate(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>


<tr><td>
<python:locale id="persona.sexo">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Sexo'} ]
</python:locale>:</td><td><input name="sexo:string:" type="text" value="<python:keyword id="sexo" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.telefono1">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Telefono1'} ]
</python:locale>:</td><td><input name="telefono1:string:" type="text" value="<python:keyword id="telefono1" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.telefono2">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Telefono2'} ]
</python:locale>:</td><td><input name="telefono2:string:" type="text" value="<python:keyword id="telefono2" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.calle">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Calle'} ]
</python:locale>:</td><td><input name="calle:string:" type="text" value="<python:keyword id="calle" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.numero">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Numero'} ]
</python:locale>:</td><td><input name="numero:string:" type="text" value="<python:keyword id="numero" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.colonia">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Colonia'} ]
</python:locale>:</td><td><input name="colonia:string:" type="text" value="<python:keyword id="colonia" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.municipio">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Municipio'} ]
</python:locale>:</td><td><input name="municipio:string:" type="text" value="<python:keyword id="municipio" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.estado">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Estado'} ]
</python:locale>:</td><td><input name="estado:string:" type="text" value="<python:keyword id="estado" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.nacionalidad">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nacionalidad'} ]
</python:locale>:</td><td><input name="nacionalidad:string" type="text" value="<python:keyword id="nacionalidad" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.curp">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Curp'} ]
</python:locale>:</td><td><input name="curp:string" type="text" value="<python:keyword id="curp" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.login">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Login'} ]
</python:locale>:</td><td><input name="login:string:" type="text" value="<python:keyword id="login" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.matricula">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Matricula'} ]
</python:locale>:</td><td><input name="matricula:string:" type="text" value="<python:keyword id="matricula" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.tipo">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Tipo'} ]
</python:locale>:</td><td><input name="tipo:string:" type="text" value="<python:keyword id="tipo" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.observaciones">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Observaciones'} ]
</python:locale>:</td><td><textarea cols="50" rows="12" name="observaciones:text:" ><python:keyword id="observaciones" /></textarea></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_persona'] = False
#_spyro_authentication.perms['list_persona'] = False
#_spyro_authentication.perms['modify_persona'] = False
#_spyro_authentication.perms['delete_persona'] = False
 
def _get_rowid_persona(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'persona'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_persona(mode, condition_dict):
    tabname = 'persona'
    return ((tabname,(list_persona(condition_dict)),tabname),)

def _map_result_persona(fieldname, value, outmap=None):
    tabname = 'persona'
    objname = 'escuelas.escuelas'
    foreigns = {}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_persona(fields, query, dopager=None):
    objname = 'escuelas.escuelas'
    tabname = 'persona'
    suffix = 'persona'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_persona(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_persona(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_persona(fields, query, idtag, previewsize):
    tabname = 'persona'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_persona(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_persona(mode = None,condition_dict = None, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_persona(mode, data, cond, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_persona)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_persona(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_persona('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_persona(config['list_fields'][0],data)[0]
            rowid = _get_rowid_persona(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_persona(mode, cond)

def delete_persona(cond, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_persona)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_persona(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_persona("delete", cond)

def list_persona(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'escuelas.escuelas'
    tabname = 'persona'
    suffix = 'persona'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_persona(fields, query, dopager)

def form_search_persona(method=None, *args, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_persona(drop_index, reindex):
    tabname = 'persona'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_persona(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_persona(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_persona(output='list', idtag='', query='',**kwargs):
    tabname = 'persona'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_persona(query, output="", idtag="", **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_persona(fields, res, idtag, size)
    else:
        x = _out_list_persona(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_persona(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    return (('', list_persona(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_persona(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['id', 'nombre', 'apellidos', 'fecha_nacimiento', 'sexo', 'telefono1', 'telefono2', 'calle', 'numero', 'colonia', 'municipio', 'estado', 'nacionalidad', 'curp', 'login', 'matricula', 'tipo', 'observaciones']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_persona(fields, query, idtag, previewsize)

def preview_persona(id, condition_dict=None, display = None, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_persona)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'nombre'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_persona(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of persona UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table alumno_tutor UI
###

### Configuring alumno_tutor

modconfig['alumno_tutor'] = {
    'internal_fields' : [],
    'dict_default': { '' : '<python:locale id="general.submit" />','tutor' : '','alumno' : '',
                     '__objname__': 'escuelas.escuelas',
                     '__tabname__': 'alumno_tutor',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='alumno_tutor', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['alumno', 'tutor'],
    'preview_fields': ['alumno', 'tutor'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("alumno_tutor:form_element",
     """
            <strong>Alumno Tutor</strong>
            <form method="POST" enctype="multipart/form-data" id="form-alumno_tutor<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="alumno_tutor" >
                <table><tbody>
            
<tr><td>
<python:locale id="alumno_tutor.alumno">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Alumno'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="alumno" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['id'])" name="alumno:string"  id="select-persona_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="alumno_tutor.tutor">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Tutor'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="tutor" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['id'])" name="tutor:string"  id="select-persona_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("alumno_tutor:form_element_search",
     """
            <strong>Alumno Tutor</strong>
            <form method="POST" enctype="multipart/form-data" id="form-alumno_tutor<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="alumno_tutor" >
                <table><tbody>
            
<tr><td>
<python:locale id="alumno_tutor.alumno">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Alumno'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="alumno" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['id'])" name="alumno:string"  id="select-persona_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="alumno_tutor.tutor">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Tutor'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="tutor" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['id'])" name="tutor:string"  id="select-persona_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_alumno_tutor'] = False
#_spyro_authentication.perms['list_alumno_tutor'] = False
#_spyro_authentication.perms['modify_alumno_tutor'] = False
#_spyro_authentication.perms['delete_alumno_tutor'] = False
 
def _get_rowid_alumno_tutor(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_alumno_tutor(mode, condition_dict):
    tabname = 'alumno_tutor'
    return ((tabname,(list_alumno_tutor(condition_dict)),tabname),)

def _map_result_alumno_tutor(fieldname, value, outmap=None):
    tabname = 'alumno_tutor'
    objname = 'escuelas.escuelas'
    foreigns = {u'tutor': (u'persona', u'id'), u'alumno': (u'persona', u'id')}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_alumno_tutor(fields, query, dopager=None):
    objname = 'escuelas.escuelas'
    tabname = 'alumno_tutor'
    suffix = 'alumno_tutor'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_alumno_tutor(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_alumno_tutor(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_alumno_tutor(fields, query, idtag, previewsize):
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_alumno_tutor)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_alumno_tutor(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_alumno_tutor(mode = None,condition_dict = None, **kwargs):
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_alumno_tutor(mode, data, cond, **kwargs):
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_alumno_tutor)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_alumno_tutor(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_alumno_tutor('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_alumno_tutor(config['list_fields'][0],data)[0]
            rowid = _get_rowid_alumno_tutor(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_alumno_tutor(mode, cond)

def delete_alumno_tutor(cond, **kwargs):
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_alumno_tutor)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_alumno_tutor(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_alumno_tutor("delete", cond)

def list_alumno_tutor(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'escuelas.escuelas'
    tabname = 'alumno_tutor'
    suffix = 'alumno_tutor'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_alumno_tutor)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_alumno_tutor(fields, query, dopager)

def form_search_alumno_tutor(method=None, *args, **kwargs):
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_alumno_tutor(drop_index, reindex):
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_alumno_tutor(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_alumno_tutor(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_alumno_tutor(output='list', idtag='', query='',**kwargs):
    tabname = 'alumno_tutor'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_alumno_tutor(query, output="", idtag="", **kwargs):
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_alumno_tutor(fields, res, idtag, size)
    else:
        x = _out_list_alumno_tutor(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_alumno_tutor(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    return (('', list_alumno_tutor(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_alumno_tutor(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_alumno_tutor)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['alumno', 'tutor']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_alumno_tutor(fields, query, idtag, previewsize)

def preview_alumno_tutor(id, condition_dict=None, display = None, **kwargs):
    tabname = 'alumno_tutor'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_alumno_tutor)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'tutor'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_alumno_tutor(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of alumno_tutor UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table materia UI
###

### Configuring materia

modconfig['materia'] = {
    'internal_fields' : [],
    'dict_default': { '' : '<python:locale id="general.submit" />','nombre' : '','nivel' : '','id' : '','creditos' : '',
                     '__objname__': 'escuelas.escuelas',
                     '__tabname__': 'materia',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='materia', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['id', 'nombre', 'creditos', 'nivel'],
    'preview_fields': ['id', 'nombre', 'creditos', 'nivel'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("materia:form_element",
     """
            <strong>Materia</strong>
            <form method="POST" enctype="multipart/form-data" id="form-materia<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="materia" >
                <table><tbody>
            
<tr><td>
<python:locale id="materia.id">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Id'} ]
</python:locale>:</td><td><input name="id:int:" type="text" value="<python:keyword id="id" />" size="40" /></td></tr>


<tr><td>
<python:locale id="materia.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string:mandatory" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="materia.creditos">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Creditos'} ]
</python:locale>:</td><td><input name="creditos:int:" type="text" value="<python:keyword id="creditos" />" size="40" /></td></tr>


<tr><td>
<python:locale id="materia.nivel">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nivel'} ]
</python:locale>:</td><td><input name="nivel:int:" type="text" value="<python:keyword id="nivel" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("materia:form_element_search",
     """
            <strong>Materia</strong>
            <form method="POST" enctype="multipart/form-data" id="form-materia<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="materia" >
                <table><tbody>
            
<tr><td>
<python:locale id="materia.id">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Id'} ]
</python:locale>:</td><td><input name="id:int:" type="text" value="<python:keyword id="id" />" size="40" /></td></tr>


<tr><td>
<python:locale id="materia.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="materia.creditos">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Creditos'} ]
</python:locale>:</td><td><input name="creditos:int:" type="text" value="<python:keyword id="creditos" />" size="40" /></td></tr>


<tr><td>
<python:locale id="materia.nivel">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nivel'} ]
</python:locale>:</td><td><input name="nivel:int:" type="text" value="<python:keyword id="nivel" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_materia'] = False
#_spyro_authentication.perms['list_materia'] = False
#_spyro_authentication.perms['modify_materia'] = False
#_spyro_authentication.perms['delete_materia'] = False
 
def _get_rowid_materia(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'materia'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_materia(mode, condition_dict):
    tabname = 'materia'
    return ((tabname,(list_materia(condition_dict)),tabname),)

def _map_result_materia(fieldname, value, outmap=None):
    tabname = 'materia'
    objname = 'escuelas.escuelas'
    foreigns = {}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_materia(fields, query, dopager=None):
    objname = 'escuelas.escuelas'
    tabname = 'materia'
    suffix = 'materia'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_materia(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_materia(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_materia(fields, query, idtag, previewsize):
    tabname = 'materia'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_materia)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_materia(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_materia(mode = None,condition_dict = None, **kwargs):
    tabname = 'materia'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_materia(mode, data, cond, **kwargs):
    tabname = 'materia'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_materia)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_materia(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_materia('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_materia(config['list_fields'][0],data)[0]
            rowid = _get_rowid_materia(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_materia(mode, cond)

def delete_materia(cond, **kwargs):
    tabname = 'materia'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_materia)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_materia(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_materia("delete", cond)

def list_materia(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'escuelas.escuelas'
    tabname = 'materia'
    suffix = 'materia'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_materia)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_materia(fields, query, dopager)

def form_search_materia(method=None, *args, **kwargs):
    tabname = 'materia'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_materia(drop_index, reindex):
    tabname = 'materia'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_materia(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_materia(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_materia(output='list', idtag='', query='',**kwargs):
    tabname = 'materia'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_materia(query, output="", idtag="", **kwargs):
    tabname = 'materia'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_materia(fields, res, idtag, size)
    else:
        x = _out_list_materia(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_materia(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'materia'
    config = modconfig[tabname]
    return (('', list_materia(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_materia(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'materia'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_materia)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['id', 'nombre', 'creditos', 'nivel']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_materia(fields, query, idtag, previewsize)

def preview_materia(id, condition_dict=None, display = None, **kwargs):
    tabname = 'materia'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_materia)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'nombre'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_materia(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of materia UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table persona_materia UI
###

### Configuring persona_materia

modconfig['persona_materia'] = {
    'internal_fields' : [],
    'dict_default': { '' : '<python:locale id="general.submit" />','ciclo' : '','observaciones' : '','idpersona' : '','calificacion_final' : '','id' : '','idmateria' : '',
                     '__objname__': 'escuelas.escuelas',
                     '__tabname__': 'persona_materia',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='persona_materia', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['id', 'idpersona', 'idmateria', 'ciclo', 'calificacion_final', 'observaciones'],
    'preview_fields': ['id', 'idpersona', 'idmateria', 'ciclo', 'calificacion_final', 'observaciones'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("persona_materia:form_element",
     """
            <strong>Persona Materia</strong>
            <form method="POST" enctype="multipart/form-data" id="form-persona_materia<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="persona_materia" >
                <table><tbody>
            
<tr><td>
<python:locale id="persona_materia.id">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Id'} ]
</python:locale>:</td><td><input name="id:int:" type="text" value="<python:keyword id="id" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_materia.idpersona">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Idpersona'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="idpersona" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['id'])" name="idpersona:int"  id="select-persona_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona_materia.idmateria">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Idmateria'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="idmateria" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_materia',['id'])" name="idmateria:int"  id="select-materia_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-materia_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'materia'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_materia', ['choose_search','select-materia_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_materia', ['choose_search','select-materia_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona_materia.ciclo">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Ciclo'} ]
</python:locale>:</td><td><input name="ciclo:int:mandatory" type="text" value="<python:keyword id="ciclo" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_materia.calificacion_final">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Calificacion Final'} ]
</python:locale>:</td><td><input name="calificacion_final:float:" type="text" value="<python:keyword id="calificacion_final" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_materia.observaciones">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Observaciones'} ]
</python:locale>:</td><td><textarea cols="50" rows="12" name="observaciones:text:" ><python:keyword id="observaciones" /></textarea></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("persona_materia:form_element_search",
     """
            <strong>Persona Materia</strong>
            <form method="POST" enctype="multipart/form-data" id="form-persona_materia<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="persona_materia" >
                <table><tbody>
            
<tr><td>
<python:locale id="persona_materia.id">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Id'} ]
</python:locale>:</td><td><input name="id:int:" type="text" value="<python:keyword id="id" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_materia.idpersona">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Idpersona'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="idpersona" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['id'])" name="idpersona:int"  id="select-persona_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona_materia.idmateria">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Idmateria'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="idmateria" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_materia',['id'])" name="idmateria:int"  id="select-materia_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-materia_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'materia'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_materia', ['choose_search','select-materia_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_materia', ['choose_search','select-materia_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona_materia.ciclo">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Ciclo'} ]
</python:locale>:</td><td><input name="ciclo:int" type="text" value="<python:keyword id="ciclo" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_materia.calificacion_final">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Calificacion Final'} ]
</python:locale>:</td><td><input name="calificacion_final:float:" type="text" value="<python:keyword id="calificacion_final" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_materia.observaciones">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Observaciones'} ]
</python:locale>:</td><td><textarea cols="50" rows="12" name="observaciones:text:" ><python:keyword id="observaciones" /></textarea></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_persona_materia'] = False
#_spyro_authentication.perms['list_persona_materia'] = False
#_spyro_authentication.perms['modify_persona_materia'] = False
#_spyro_authentication.perms['delete_persona_materia'] = False
 
def _get_rowid_persona_materia(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'persona_materia'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_persona_materia(mode, condition_dict):
    tabname = 'persona_materia'
    return ((tabname,(list_persona_materia(condition_dict)),tabname),)

def _map_result_persona_materia(fieldname, value, outmap=None):
    tabname = 'persona_materia'
    objname = 'escuelas.escuelas'
    foreigns = {u'idpersona': (u'persona', u'id'), u'idmateria': (u'materia', u'id')}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_persona_materia(fields, query, dopager=None):
    objname = 'escuelas.escuelas'
    tabname = 'persona_materia'
    suffix = 'persona_materia'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_persona_materia(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_persona_materia(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_persona_materia(fields, query, idtag, previewsize):
    tabname = 'persona_materia'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona_materia)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_persona_materia(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_persona_materia(mode = None,condition_dict = None, **kwargs):
    tabname = 'persona_materia'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_persona_materia(mode, data, cond, **kwargs):
    tabname = 'persona_materia'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_persona_materia)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_persona_materia(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_persona_materia('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_persona_materia(config['list_fields'][0],data)[0]
            rowid = _get_rowid_persona_materia(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_persona_materia(mode, cond)

def delete_persona_materia(cond, **kwargs):
    tabname = 'persona_materia'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_persona_materia)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_persona_materia(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_persona_materia("delete", cond)

def list_persona_materia(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'escuelas.escuelas'
    tabname = 'persona_materia'
    suffix = 'persona_materia'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona_materia)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_persona_materia(fields, query, dopager)

def form_search_persona_materia(method=None, *args, **kwargs):
    tabname = 'persona_materia'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_persona_materia(drop_index, reindex):
    tabname = 'persona_materia'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_persona_materia(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_persona_materia(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_persona_materia(output='list', idtag='', query='',**kwargs):
    tabname = 'persona_materia'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_persona_materia(query, output="", idtag="", **kwargs):
    tabname = 'persona_materia'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_persona_materia(fields, res, idtag, size)
    else:
        x = _out_list_persona_materia(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_persona_materia(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'persona_materia'
    config = modconfig[tabname]
    return (('', list_persona_materia(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_persona_materia(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'persona_materia'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona_materia)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['id', 'idpersona', 'idmateria', 'ciclo', 'calificacion_final', 'observaciones']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_persona_materia(fields, query, idtag, previewsize)

def preview_persona_materia(id, condition_dict=None, display = None, **kwargs):
    tabname = 'persona_materia'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_persona_materia)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'idpersona'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_persona_materia(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of persona_materia UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table calificacion_parcial UI
###

### Configuring calificacion_parcial

modconfig['calificacion_parcial'] = {
    'internal_fields' : [],
    'dict_default': { 'idpersona' : '','nivel' : '','' : '<python:locale id="general.submit" />','calificacion' : '',
                     '__objname__': 'escuelas.escuelas',
                     '__tabname__': 'calificacion_parcial',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='calificacion_parcial', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['nivel', 'calificacion', 'idpersona'],
    'preview_fields': ['nivel', 'calificacion', 'idpersona'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("calificacion_parcial:form_element",
     """
            <strong>Calificacion Parcial</strong>
            <form method="POST" enctype="multipart/form-data" id="form-calificacion_parcial<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="calificacion_parcial" >
                <table><tbody>
            
<tr><td>
<python:locale id="calificacion_parcial.nivel">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nivel'} ]
</python:locale>:</td><td><input name="nivel:int:" type="text" value="<python:keyword id="nivel" />" size="40" /></td></tr>


<tr><td>
<python:locale id="calificacion_parcial.calificacion">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Calificacion'} ]
</python:locale>:</td><td><input name="calificacion:float:" type="text" value="<python:keyword id="calificacion" />" size="40" /></td></tr>


<tr><td>
<python:locale id="calificacion_parcial.idpersona">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Idpersona'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="idpersona" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona_materia',['id'])" name="idpersona:string"  id="select-persona_materia_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_materia_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona_materia'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona_materia', ['choose_search','select-persona_materia_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona_materia', ['choose_search','select-persona_materia_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("calificacion_parcial:form_element_search",
     """
            <strong>Calificacion Parcial</strong>
            <form method="POST" enctype="multipart/form-data" id="form-calificacion_parcial<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="calificacion_parcial" >
                <table><tbody>
            
<tr><td>
<python:locale id="calificacion_parcial.nivel">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nivel'} ]
</python:locale>:</td><td><input name="nivel:int:" type="text" value="<python:keyword id="nivel" />" size="40" /></td></tr>


<tr><td>
<python:locale id="calificacion_parcial.calificacion">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Calificacion'} ]
</python:locale>:</td><td><input name="calificacion:float:" type="text" value="<python:keyword id="calificacion" />" size="40" /></td></tr>


<tr><td>
<python:locale id="calificacion_parcial.idpersona">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Idpersona'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="idpersona" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona_materia',['id'])" name="idpersona:string"  id="select-persona_materia_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_materia_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona_materia'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona_materia', ['choose_search','select-persona_materia_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona_materia', ['choose_search','select-persona_materia_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_calificacion_parcial'] = False
#_spyro_authentication.perms['list_calificacion_parcial'] = False
#_spyro_authentication.perms['modify_calificacion_parcial'] = False
#_spyro_authentication.perms['delete_calificacion_parcial'] = False
 
def _get_rowid_calificacion_parcial(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_calificacion_parcial(mode, condition_dict):
    tabname = 'calificacion_parcial'
    return ((tabname,(list_calificacion_parcial(condition_dict)),tabname),)

def _map_result_calificacion_parcial(fieldname, value, outmap=None):
    tabname = 'calificacion_parcial'
    objname = 'escuelas.escuelas'
    foreigns = {u'idpersona': (u'persona_materia', u'id')}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_calificacion_parcial(fields, query, dopager=None):
    objname = 'escuelas.escuelas'
    tabname = 'calificacion_parcial'
    suffix = 'calificacion_parcial'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_calificacion_parcial(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_calificacion_parcial(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_calificacion_parcial(fields, query, idtag, previewsize):
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_calificacion_parcial)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_calificacion_parcial(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_calificacion_parcial(mode = None,condition_dict = None, **kwargs):
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_calificacion_parcial(mode, data, cond, **kwargs):
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_calificacion_parcial)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_calificacion_parcial(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_calificacion_parcial('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_calificacion_parcial(config['list_fields'][0],data)[0]
            rowid = _get_rowid_calificacion_parcial(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_calificacion_parcial(mode, cond)

def delete_calificacion_parcial(cond, **kwargs):
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_calificacion_parcial)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_calificacion_parcial(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_calificacion_parcial("delete", cond)

def list_calificacion_parcial(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'escuelas.escuelas'
    tabname = 'calificacion_parcial'
    suffix = 'calificacion_parcial'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_calificacion_parcial)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_calificacion_parcial(fields, query, dopager)

def form_search_calificacion_parcial(method=None, *args, **kwargs):
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_calificacion_parcial(drop_index, reindex):
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_calificacion_parcial(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_calificacion_parcial(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_calificacion_parcial(output='list', idtag='', query='',**kwargs):
    tabname = 'calificacion_parcial'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_calificacion_parcial(query, output="", idtag="", **kwargs):
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_calificacion_parcial(fields, res, idtag, size)
    else:
        x = _out_list_calificacion_parcial(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_calificacion_parcial(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    return (('', list_calificacion_parcial(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_calificacion_parcial(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_calificacion_parcial)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['nivel', 'calificacion', 'idpersona']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_calificacion_parcial(fields, query, idtag, previewsize)

def preview_calificacion_parcial(id, condition_dict=None, display = None, **kwargs):
    tabname = 'calificacion_parcial'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_calificacion_parcial)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'calificacion'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_calificacion_parcial(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of calificacion_parcial UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table mensaje UI
###

### Configuring mensaje

modconfig['mensaje'] = {
    'internal_fields' : [],
    'dict_default': { 'contenido' : '','' : '<python:locale id="general.submit" />','remitente' : '','fecha_emision' : '','destinatario' : '',
                     '__objname__': 'escuelas.escuelas',
                     '__tabname__': 'mensaje',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='mensaje', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['fecha_emision', 'remitente', 'destinatario', 'contenido'],
    'preview_fields': ['fecha_emision', 'remitente', 'destinatario', 'contenido'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("mensaje:form_element",
     """
            <strong>Mensaje</strong>
            <form method="POST" enctype="multipart/form-data" id="form-mensaje<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="mensaje" >
                <table><tbody>
            
<tr><td>
<python:locale id="mensaje.fecha_emision">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Emision'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" /> 
            <python:locale id="date.format_time" /> 
            <input type="text" name="fecha_emision:datetime:mandatory" value="<python:keyword id="fecha_emision" />" onclick="Easyform_frameReadDatetime(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>


<tr><td>
<python:locale id="mensaje.remitente">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Remitente'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="remitente" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['id'])" name="remitente:string"  id="select-persona_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="mensaje.destinatario">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Destinatario'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="destinatario" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['id'])" name="destinatario:string"  id="select-persona_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="mensaje.contenido">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Contenido'} ]
</python:locale>:</td><td><textarea cols="50" rows="12" name="contenido:text:mandatory" ><python:keyword id="contenido" /></textarea></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("mensaje:form_element_search",
     """
            <strong>Mensaje</strong>
            <form method="POST" enctype="multipart/form-data" id="form-mensaje<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="mensaje" >
                <table><tbody>
            
<tr><td>
<python:locale id="mensaje.fecha_emision">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Emision'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" /> 
            <python:locale id="date.format_time" /> 
            <input type="text" name="fecha_emision:datetime" value="<python:keyword id="fecha_emision" />" onclick="Easyform_frameReadDatetime(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>


<tr><td>
<python:locale id="mensaje.remitente">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Remitente'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="remitente" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['id'])" name="remitente:string"  id="select-persona_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="mensaje.destinatario">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Destinatario'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="destinatario" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['id'])" name="destinatario:string"  id="select-persona_id_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_id_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_id_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="mensaje.contenido">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Contenido'} ]
</python:locale>:</td><td><textarea cols="50" rows="12" name="contenido:text" ><python:keyword id="contenido" /></textarea></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_mensaje'] = False
#_spyro_authentication.perms['list_mensaje'] = False
#_spyro_authentication.perms['modify_mensaje'] = False
#_spyro_authentication.perms['delete_mensaje'] = False
 
def _get_rowid_mensaje(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'mensaje'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_mensaje(mode, condition_dict):
    tabname = 'mensaje'
    return ((tabname,(list_mensaje(condition_dict)),tabname),)

def _map_result_mensaje(fieldname, value, outmap=None):
    tabname = 'mensaje'
    objname = 'escuelas.escuelas'
    foreigns = {u'remitente': (u'persona', u'id'), u'destinatario': (u'persona', u'id')}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_mensaje(fields, query, dopager=None):
    objname = 'escuelas.escuelas'
    tabname = 'mensaje'
    suffix = 'mensaje'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_mensaje(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_mensaje(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_mensaje(fields, query, idtag, previewsize):
    tabname = 'mensaje'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_mensaje)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_mensaje(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_mensaje(mode = None,condition_dict = None, **kwargs):
    tabname = 'mensaje'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_mensaje(mode, data, cond, **kwargs):
    tabname = 'mensaje'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_mensaje)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_mensaje(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_mensaje('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_mensaje(config['list_fields'][0],data)[0]
            rowid = _get_rowid_mensaje(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_mensaje(mode, cond)

def delete_mensaje(cond, **kwargs):
    tabname = 'mensaje'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_mensaje)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_mensaje(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_mensaje("delete", cond)

def list_mensaje(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'escuelas.escuelas'
    tabname = 'mensaje'
    suffix = 'mensaje'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_mensaje)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_mensaje(fields, query, dopager)

def form_search_mensaje(method=None, *args, **kwargs):
    tabname = 'mensaje'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_mensaje(drop_index, reindex):
    tabname = 'mensaje'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_mensaje(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_mensaje(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_mensaje(output='list', idtag='', query='',**kwargs):
    tabname = 'mensaje'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_mensaje(query, output="", idtag="", **kwargs):
    tabname = 'mensaje'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_mensaje(fields, res, idtag, size)
    else:
        x = _out_list_mensaje(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_mensaje(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'mensaje'
    config = modconfig[tabname]
    return (('', list_mensaje(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_mensaje(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'mensaje'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_mensaje)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['fecha_emision', 'remitente', 'destinatario', 'contenido']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_mensaje(fields, query, idtag, previewsize)

def preview_mensaje(id, condition_dict=None, display = None, **kwargs):
    tabname = 'mensaje'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_mensaje)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'remitente'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_mensaje(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of mensaje UI
###
###############################################################################################
###############################################################################################
