#coding: utf8;

"""
Library3K it's aims to be a full featured open library for
any python enabled system (Windows, Linux, MacOSX, etc.)
It's working on threekong.com's dweba platform.
"""

import warn
import template3k
import lib3k
reload(lib3k)
from shttp import http
db = lib3k.db
import commands

def upload_file_form(namename, namevalue, dataname, action, resourceid):
    return template3k.get_template("templates/upload_request.html").merge(
        Namename=namename,
        Namevalue=namevalue,
        Dataname=dataname,
        Action=action,
        Formbody = ("""<input name="resourceid" value="%s" type="hidden" />"""%resourceid)
    )
configresource = lib3k.modconfig['lib3k_resource']
configannotation = lib3k.modconfig['lib3k_annotation']
configannotation['internal_fields'] = [ 'resourceid', 'annotation_owner' ]
configresource['internal_fields'] = ['xid', 'sha1', 'foreignid', 'owner', 'access_policies']

def output_table_row(row, q, fields):
    # print row
    row[0] = ("""<span><img src="fetch?resourceid=%s" style="width:200pt; height:auto;" onclick="if (this.style.width != '100%%') {this.style.width='100%%';} else {this.style.width='200pt';}" style="border: 2pt solid orange; margin: 1pt;"/></span> """
              """<span style="text-align: top;">%s</span>"""%(q[0], row[0]))
    return "<tr>%s</tr>"%("<td>%s</td>"%("</td><td>".join(row)))

configresource['output_table_row'] =  output_table_row

__controls = configresource['control_generator']
def _controls(loc):
    data_id=loc['q'][0]
    if loc['q'][1]: #sha1
        fetchlink = """<a href="javascript: viewweb('fetch?resourceid=%s'); void(0);">View</a>"""%data_id
    else:
        fetchlink = "No fetch"
    return __controls(loc) + \
            [
             """<a href="javascript: callto({'handler': handle_commands}, 'lib3k', 'list_annotations', [%s]);void(0);">Annotations</a>"""%(data_id),
            ("""<a href="javascript: sendfile('%s', 'push', 'upload_file_form', '&resourceid=%s'); void(0);">"""
             """Push resource</a>""")%(data_id,data_id),
             fetchlink
            ]

import os
import sys
import sha
import time
from shttp import http
import mimetypes
REPOSITORY_ROOT=os.path.join("opt-objects", "lib3k", "root")
RESOURCES_FIELDS = ['xid', 'sha1', 'owner', 'description', 'keywords', 'contenttype']
RESOURCES_FSJOIN = ",".join(RESOURCES_FIELDS)
configresource['control_generator'] = _controls
configresource['list_fields'] = RESOURCES_FIELDS
try:
    os.mkdir(REPOSITORY_ROOT)
except OSError:
    pass

def showpage(**kwargs):
    objname = 'lib3k.lib3k'
    itime = time.time()
    res = []
    show = lib3k.modconfig['lib3k_resource']['output_showpage']
    res.append(show('Lib3K Resource', lib3k.list_lib3k_resource(), 'lib3k_resource'))
    return res

def index(**kwargs):
    temp =  template3k.get_template("templates/admin.html")
    # lst = lst.encode("utf8","replace")
    return temp.merge(Title="Lib3K",
                      Content="",
                      JavascriptGlobal = template3k.get_template("templates/manage_files.js").merge({})                    ,
                      JavascriptInit = """callto({'handler': handle_commands}, 'lib3k', 'showpage');""",
                      ).encode("utf8")

# def push(**kwargs):
#     dht.push(data)

# def fetch(resourceid=None):
#     dht.fetch(data)

def list_annotations(resourceid):
    d = lib3k._list_method_lib3k_annotation('list', {'resourceid': resourceid})
    d = list(d)
    d[0] = list(d[0])
    d[0][0] = 'frame'
    return d

def _get_resource_filename(shahash):
    if shahash is None:
        raise http.CustomResponse(("ERROR: This resource hasn't associated files. "
                                   "Please, report this incident to the resource owner."), status=404)
    return os.path.join(REPOSITORY_ROOT, shahash)

def _get_resource_metadata(resourceid=None, sha=None):
    if resourceid is None:
        res = db.hquery("SELECT * FROM lib3k_resource WHERE sha1 = ? LIMIT 1", (sha,))[0]
    else:
        res = db.hquery("SELECT * FROM lib3k_resource WHERE xid = ? LIMIT 1", (resourceid,))[0]
    return res

def show(resourceid=None, sha=None):
    xres = []
    for k,v in _get_resource_metadata(resourceid, sha).items():
        xres.append([k,v])
    return template3k.get_template("templates/upload_response.html").merge(IFrameName=resourceid,
                                                                           InnerContent=repr(xres))

def _prepare_push(data, metadata):
    """
    Push's preparation
    """
    sha1 = sha.new(data.value).hexdigest()
    metadata['contenttype'] = mimetypes.guess_type(data.filename)[0]
    metadata['sha1'] = sha1
    return metadata
    
def push_full(data, metadata):
    """
    Push a document and a metadata
    
    @param data: File to push.
    @param metadata: dict of metadata key-values.
    """
    _prepare_push(data, metadata)
    lib3k.lib3k.modify_lib3k_resource('insert', metadata, None)
    return metadata

def push(data, resourceid=None, **kwargs):
    """
    Push a document, related to the record with xid=resourceid
    
    @param data: File to push.
    @param resourceid: Identifier of the record.
    """
    value = data.value
    metadata = _prepare_push(data, _get_resource_metadata(resourceid))
    sha1 = metadata['sha1']
    lib3k.modify_lib3k_resource("update", metadata, {'xid': resourceid}, dbconn=db, doreturn=False)
    try:
        f = file(os.path.join(REPOSITORY_ROOT, sha1), "wb")
        f.write(value)
    finally:
        f.close()
    return show(resourceid, sha1)

def fetch(resourceid):
    """
    Fetch a file linked to the record.
    
    @param resourceid: Resource id
    """
    metadata = _get_resource_metadata(resourceid)
    raise http.CustomResponse(file(_get_resource_filename(metadata['sha1']), "rb"), content_type=metadata['contenttype'])
