#!/usr/bin/python
#coding: utf-8;
############################################################################
#                                                                          #
#    This file 'setup.py'                                                  #
#    is part of 'SPyRO: Simple Python Remote Objects'                      #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    Copyright (C) 2006      by Eric Sadit Téllez Avila                    #
#    Copyright (C) 2007      by Eric Sadit Téllez Avila                    #
#    Copyright (C) 2008      by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This file 'setup.py'                                                  #
#    is part of 'Dweba: Distributed Web Applications (for Python)'         #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    Copyright (C) 2006      by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

from distutils.core import setup
from distutils.extension import Extension
import sys, os

classifiers=["Development Status :: 4 - Beta",
             "License :: OSI Approved :: GNU General Public License (GPL)",
             "Programming Language :: Python",
             "Environment :: Web Environment",
             "Topic :: Internet :: WWW/HTTP",
             "Topic :: Software Development :: Libraries :: Python Modules",
             "Topic :: Software Development :: Object Brokering"
             ]
# "Topic :: Software Development :: Libraries :: Code Generators"
setup(
    name="dweba",
    version="1.0.0-pre5",
    author="Eric Sadit Tellez Avila".decode("latin1").encode('utf8'),
    author_email="sadit@lsc.fie.umich.mx",
    url="http://threekong.com/",
    license="GPL",
    platforms=["POSIX",'any'],
    classifiers=classifiers,
    description="Dweba: Distributed and Web Application Framework for Python",
    long_description="""
    Dweba is a framework for the development of distributed and web applications for the python
    programming language.
    
    Dweba is the continuation an fusion of SPyRO and DOM3K frameworks. It keeps the the API
    for SPyRO and DOM3K, but delivered in a single package, additionally to new automatic
    web application generators.

    The main focus of SPyRO is the distributed applications via Remote Objects, and the main
    focus of DOM3K is the connection with spyro via WebBrowser (i.e. firefox, opera, etc) using an
    AJAX User Interface, connecting to web services. DOM3K can use several backends to SPyRO, or
    any kind of CGIs.

    ======

    Some critical changes:
        + Some bug fixes in shttp, it's now faster
        + Many improvements in easyform
    """,
    packages=['warn', 'shttp', 'SPyRO', 'threadutils',
              'db3k','dom3k', 'auth3k', 'template3k', "medusa", "cache3k"]
)
