#!/usr/bin/python
#coding: utf-8;
############################################################################
#                                                                          #
#    This file 'setup.py'                                                  #
#    is part of 'SPyRO: Simple Python Remote Objects'                      #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    Copyright (C) 2006      by Eric Sadit Téllez Avila                    #
#    Copyright (C) 2007      by Eric Sadit Téllez Avila                    #
#    Copyright (C) 2008      by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This file 'setup.py'                                                  #
#    is part of 'Dweba: Distributed Web Applications (for Python)'         #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    Copyright (C) 2006      by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

from distutils.core import setup
from distutils.extension import Extension
import sys, os

classifiers=["Development Status :: 4 - Beta",
             "License :: OSI Approved :: GNU General Public License (GPL)",
             "Programming Language :: Python",
             "Environment :: Web Environment",
             "Topic :: Internet :: WWW/HTTP",
             "Topic :: Software Development :: Libraries :: Python Modules",
             "Topic :: Software Development :: Object Brokering"
             ]
# "Topic :: Software Development :: Libraries :: Code Generators"
setup(
    name="dweba",
    version="1.0.0-pre14",
    author="Eric Sadit Tellez Avila".decode("latin1").encode('utf8'),
    author_email="donsadit@gmail.com",
    url="http://threekong.com/",
    license="GPL",
    platforms=["POSIX",'any'],
    classifiers=classifiers,
    description="Dweba: Distributed and Web Application Framework for Python",
    long_description="""
    Dweba is a framework and work environment
    to develop and run distributed and web applications using
    the python programming language. It contains SPyRO and DOM3K (the libraries for
    Distributed applications and AJAX framework).

    In this package you will find packages (named objects in SPyRO) as follows:
       + Useradmin: Management of users and groups
       + Packadmin: Package manager and editor. You can update, upload, pack, unpack, backup,
                    files and packages, and connects the objects pools to GuiGo!
       + ProxyKong: A Simple and flexible http proxy, with support for authentication
       + GuiGo!: The Graphical User Interface Object Generator, it uses databases to create
                 object GUIs that can be easy customizables.
       + forum: A simple forum
       + ft3k: An lightweight SQL fulltext indexer for sqlite3
       + locale3k: A locale manager and locale editor for spyro's objects
    ======
        Guigo! focuses in creation of GUI APIs, not only Web UIs
	shttp/http.py now has fully multithreading support for medusa
	DOM3K now it's more remotelly customizable (see show.js for the handle_commands function)
	Documentation
	Too many changes and bug fixes

    """

)
