#coding: utf8;
__doc__ = """
Guigo: Graphical User Interface Generator Object

This is a port of the program dbcreateui.py from SPyRO and DOM3K to dweba,
and then to threekong. It's a simplified and powerful version of dbcreateui.py

"""
import auth3k
import auth3k.authweb as authweb
_spyro_authentication = authweb.Auth()
_spyro_authentication.permsobject['Guigo'] = [[],['admin'],[]]

import easyform
reload(easyform)
import DBGui
reload(DBGui)
import os
import sys
import appconfig
import warn
warn = warn.Warn("Guigo")

# import getpass
import shutil
import template3k
import packadmin
import db3k
dbconn = db3k.Connection(name="guigo",database="guigo",manager="sqlite3")
import spyropack
import time
from shttp import http

try:
    dbconn.query("""SELECT * FROM admin_guigo limit 1""")
except Exception:
    spyropack.sql_script(dbconn, "sql/guigo.sql")
    
# PREFIX = os.path.join(sys.prefix,"share","dweba")
def _makehtml(**kwargs):
    temp = template3k.get_template(appconfig.template_admin)
    kwargs['Quote'] = "GuiGo!: Just GUI it!"
    kwargs['DevelQuote']=("""<strong>GuiGo!</strong> """)
    kwargs['Comments'] = ''
    kwargs['CommentsTitle'] = ''
    return temp.merge(kwargs)

def index(**kwargs):
    return list_projects(**kwargs)

import gui_Guigo
def form_import_project(objpath=None,**kwargs):
    temp = template3k.get_template("templates/selectdatabase.html")
    res = []
    for q in list_db():
        res.append("""<option value="%s">%s</option>"""%(q,q))
    listdesc = []
    for q in list_db_desc():
        listdesc.append("""<option value="%s">%s</option>"""%(q,q))
    listdesc = "".join(listdesc)
    data = """<div><a href="list_projects?objpath=%s">List projects</a></div>
    %s\n%s"""%(objpath,
               gui_Guigo.form_generate_from_object(),
               temp.merge(SqliteDatabases="".join(res),
                          SqliteDatabasesDesc=listdesc,
                          Objpath=objpath
                          ))
    return _makehtml(Title="GuiGo!: Graphical User Interface Object Generator",
                     Content=data,
                     Comments='',
                     CommentsTitle='')

def list_projects(objpath=None):
    res = ["""<table class="packlist"><tbody>"""
           """<tr><th>Name</th><th>Edit</th><th>Generate</th><th>Remove</th></tr>"""]
    for r in dbconn.query("SELECT objname FROM admin_guigo_project"):
        project = r[0]
        if objpath is None:
            s = ""
        else:
            s = "&objpath=%s"%objpath
        res.append("""<tr>"""
                   """<td>%(project)s</td>"""
                   """<td><a href="manager/index?objname=%(project)s%(s)s">Edit</a></td>"""
                   """<td><a href="generate_ui?objname=%(project)s%(s)s">Generate UI</a></td>"""
                   """<td><a href="remove_project?objname=%(project)s%(s)s">Remove Project</a></td>"""
                   """</tr>"""%locals())
    res.append("</tbody></table>")
    res.append("""<a href="form_import_project?objpath=%s">Import project</a>"""%objpath)
    return _makehtml(Title="List of Projects",
                     Content="".join(res),
                     Objpath=objpath)

def remove_project(objname=None,objpath=None):
    if objname is None:
        raise Exception("The project name must be specified")
    dbconn.execute("DELETE FROM admin_guigo WHERE objname = ?",(objname,))
    dbconn.execute("DELETE FROM admin_guigo_project WHERE objname = ?",(objname,))
    return list_projects(objpath=objpath)

def create_db(objname=None, sqldescription=None, sqldescriptionx=None, objpath=None, **kwargs):
    database = os.path.join(appconfig.sqlite_dbpath,objname)
    if objname is None:
        raise Exception("objname and sqldescription must be set")
    if sqldescriptionx is None:
        desc = sqldescription.value
    else:
        fname = packadmin.getabsname(sqldescriptionx + ".sql")
        f = file(fname)
        desc = f.read()
        f.close()
    dbname = "%s%s"%(objname,time.time())
    try:
        db3k.get_database_data(dbname)
        raise Exception("There's a working database with the same objname, this can't be. Please change it and try again")
    except KeyError:
        xconn = db3k.Connection(manager="sqlite3",name=dbname,database=database)
    spyropack.sql_script_data(xconn, desc)
    db3k.del_database_data(dbname)
    raise http.CustomResponse("",status=302,headers=(('Location','form_import_project?objpath=%s'%objpath),))

import glob
def list_db():
    return [ x.split(".sqlite3")[0] for x in glob.glob(os.path.join(appconfig.sqlite_dbpath, "*.sqlite3"))]

def list_db_desc():
    return [ x.split(".sql")[0] for x in glob.glob(os.path.join(appconfig.desc_dbpath, "*.sql"))]


def generate_ui(objname=None,objpath=None):
    if not(objname and objpath):
        raise Exception("objname and objpath must be set")
    ui = DBGui.UserInterfaceGenerator(dbconn, objname)
    ui.createsite(dbconn, objpath)
    return list_projects(objpath=objpath)

def generate_from_object(objname="Guigo",obj=None):
    import inspect
    if obj is None:
        obj = __import__(objname)
    objdata = {}
    forms = []
    xobjname = "gui_%s"%objname
    objdata = {'objname': xobjname,
               'dbname': objname.replace("\\","/"),
               'tempobject': 'templates/newobjectinsp.py',
               'tempform': 'templates/newforminsp.py',
               }
    for elem in dir(obj):
        m = getattr(obj, elem)
        if inspect.isfunction(m):
            args, varargs, varkwargs, defaults = inspect.getargspec(m)
            for a in args:
                forms.append({'objname': xobjname, 'form': elem, 'name': a, 'type_code': 'char'})
                # print forms[-1]
    dbconn.insert("admin_guigo_project",objdata)
    for f in forms:
        dbconn.insert("admin_guigo", f)

def import_project(user='',
                   password='',
                   database=None,
                   host=None,
                   schema='public',
                   manager='postgresql',
                   language='en',
                   objpath=None,
                   objname=None,
                   internal_fields=''):
    if database is None:
        raise Exception("You must specify a database")
    # dbconn.execute("DELETE FROM admin_guigo")
    # dbconn.execute("DELETE FROM admin_guigo_project")
    dbconn.insert('admin_guigo_project', {'dbname': database.replace('\\','/'),
                                          'dbuser': user,
                                          'dbhost': host,
                                          'dbpass': password,
                                          'dbmanager': manager,
                                          'dbschema': schema,
                                          'objname': objname,
                                          'language': language,
                                          'objpath': objpath
                                          })
    DBGui.import_user_interface(dbconn, database=database, objname=objname,
                                user=user, password=password, host=host,
                                manager=manager, language=language, schema=schema,
                                internal_fields=internal_fields)
    return "Done"
