#coding: utf8;

__doc__ = ''' Easyform server to guigo '''

import auth3k
import auth3k.authweb as authweb
_spyro_authentication = authweb.Auth()
# To set permisions to the global module or object, uncomment the following
# [ [allowed users list], [ allowed groups list], [ denied user list] ]
_spyro_authentication.permsobject['Guigo.manager'] = [[],['admin'],[]]
# Note: In module objects the object name must be the name of the object. If an authobject is
# manages many objects, there may exists many object names

# For method level management
# _spyro_authentication.perms['methodname'] = [[],['adm'],[]]

# Gets automatically the connection because is already charged
import db3k
import warn
import appconfig

db = db3k.Connection(name='guigo',database="guigo",manager='sqlite3')

def _sql_quote(f):
    return str(f).replace("'","''")

def _join_cond(d):
    try:
        items = d.items()
    except AttributeError:
        return ' 1=1 '
    if len(items) == 0:
        return ' 1=1 '
    else:
        return ' AND '.join([ "%s = '%s'"%(_sql_quote(x[0]),_sql_quote(x[1])) for x in d.items()])

# def _field_title(f):
#     return f.replace("_",' ').title()

# Field names transformations
_dictionary = {
    '_newitem' : 'New Item',
    '_delitem' : 'Delete',
    '_moditem' : 'Modify',
    }

import re

def _title(g):
    """  To support accuted languages"""
    w = g.group(2)
    return " %s%s"%( w[0].title(),w[1:])
    
def _field_title(f):
    try:
        f = _dictionary[f]
    except KeyError:
        pass
    return re.sub(r"([\s_])([^_\s]+)",_title," " + f)
    # simpler, but doesn't support accuted characters
    # return f.replace("_",' ').title()


def _quote_html(f):
    return f.replace("<","&lt;").replace(">","&gt;") #.replace("&","&amp;")

def _strip_field(f):
    if f is None: return ''
    try:
        # return _quote_html(f.encode("utf8").rstrip())
        return _quote_html(f.encode("utf8").rstrip())
    except:
        return f

def _strip_dict(d):
    for k,v in d.items():
        try:
            d[k] = _strip_field(d[k])
        except AttributeError:
            pass
    return d

def _pager(begin, count, total, template, num=15):
    xres = [ "Viewing %s elements (starting at %sth) from %s total entries "%(min(count,total-begin), begin, total) ]
    start = max(begin - num * count, 0)
    for x in range(num*2):
        page_number = start / count + 1
        if start == begin:
            xres.append("%s&nbsp;"%page_number)
        else:            xres.append( template % locals() )
        start += count
        if start > total:
            if page_number == 1: return []
            break
    return xres    

_InternalFields_admin_guigo = ['id', 'form', 'objname', 'scale']
#_spyro_authentication.perms['form_admin_guigo'] = False
#_spyro_authentication.perms['list_admin_guigo'] = False
#_spyro_authentication.perms['modify_admin_guigo'] = False
#_spyro_authentication.perms['delete_admin_guigo'] = False

def form_admin_guigo(mode = None, condition_dict = None, **kwargs):
    if mode is None:
        mode = 'insert'
    dictdefault = {'foreignfield' : '','' : 'Send','play_size' : '','name' : '','form' : kwargs.get('form',''),
                   'foreigntable' : '','precision' : '','objname' : kwargs.get('objname',''),
                   'scale' : '','type_code' : '','null_ok' : '','internal_size' : '','id' : '', 'ui_ok': ''}
    dictdefault['__mode__'] = mode
    if condition_dict is None:
        dictdefault['__cond__'] = '{}'
    else:
        dictdefault['__cond__'] = condition_dict
    if mode == 'update':
        dictdefault.update( db.hquery('SELECT * FROM admin_guigo WHERE %s'%_join_cond(condition_dict))[0] )
        _strip_dict(dictdefault)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    import time
    dictdefault['__objid'] = 'guigo-%s-%s'%(time.time(), id(dictdefault))
    return r"""
            <strong>Admin Guigo</strong>
            <form method="POST" enctype="multipart/form-data" id="admin_guigo" action="javascript: void(0);" onsubmit="commitform(this, 'Guigo.manager','admin_guigo',['%(__mode__)s',Easyform_formToDict(this),%(__cond__)s]);" name="admin_guigo" >
            <input type="hidden" name="objname:string" value="%(objname)s" />
                <table><tbody>
<tr><td>Form: </td><td><input name="form:string:mandatory" type="text" value="%(form)s" size="40" /></td></tr>
<tr><td>Foreigntable: </td><td>
<select id="%(__objid)s" onfocus="callto({'rawhandler' : createhandlerselect('%(foreigntable)s'), 'handlerargs' : this},'Guigo.manager','preview_admin_guigo',['form',{'objname': '%(objname)s'},'form'])" name="foreigntable:string">
                </select>

                </td></tr>
<tr><td>Foreignfield: </td><td>
<select onfocus="callto({'rawhandler' : createhandlerselect('%(foreignfield)s'), 'handlerargs' : this},'Guigo.manager','preview_admin_guigo',['name',{'form': DOM3K_readInput('%(__objid)s'), 'objname': '%(objname)s'}, 'name']);" name="foreignfield:string">
                </select>
                <a style="text-decoration: none; font-family: sans-serif;" href="javascript: showformmodify('Guigo.manager', 'admin_guigo_project'); void(0);">+</a>
                </td></tr>
<tr><td>Name: </td><td><input name="name:string:mandatory" type="text" value="%(name)s" size="40" /></td></tr>
<tr><td>Type Code: </td><td>
<select onfocus="callto({'rawhandler' : createhandlerselect('%(type_code)s'), 'handlerargs' : this}, 'Guigo.manager','preview_type_code',['form',{'objname': '%(objname)s'},'form'])" name="type_code:string">
                </select>
</td></tr>
<tr><td>Play Size: </td><td><input name="play_size:string" type="text" value="%(play_size)s" size="40" /></td></tr>
<tr><td>Internal Size: </td><td><input name="internal_size:string" type="text" value="%(internal_size)s" size="40" /></td></tr>
<tr><td>Precision: </td><td><input name="precision:string" type="text" value="%(precision)s" size="40" /></td></tr>
<tr><td>Scale: </td><td><input name="scale:string" type="text" value="%(scale)s" size="40" /></td></tr>
<tr><td>Null Ok: </td><td><input name="null_ok:int" type="text" value="%(null_ok)s" size="40" /></td></tr>
<tr><td>UI Ok: </td><td><input name="null_ok:int" type="text" value="%(null_ok)s" size="40" /></td></tr>
<tr><td><input type="submit" name=":submit" value="%()s" /></td></tr>
                </tbody></table>
            </form>
            """%dictdefault

def modify_admin_guigo(mode, data, cond, **kwargs):
    # assert _spyro_authentication._rawauth(kwargs['auth'], 'Guigo.manager', 'modify_admin_guigo')
    try:
        del data['id']
    except KeyError:
        pass
    objname = data['objname']
    if mode == 'update':
        if None in (data,cond): raise "Unable to update table with empty data"
        if len(cond) == 0: raise "Unable to update without condition"
        del data['objname']
        x = db.update('admin_guigo', _strip_dict(data), cond)
    elif mode == 'insert':
        if data is None: raise "Unable to insert into table with empty data"
        x = db.insert('admin_guigo', _strip_dict(data))
    else:
        raise "Unknown action to modify admin_guigo "
    if kwargs.has_key('__dont_return_list'):
        return x
    else:
        try:
            x = kwargs['__list_kwargs']
        except:
            x = {}
        x['objname'] = objname
        return (('admin_guigo',(list_admin_guigo(x)),'admin_guigo'),)

def delete_admin_guigo(cond, **kwargs):
    if None is cond: raise "Unable to delete table with empty condition"
    if len(cond) == 0: raise "Unable to delete without condition"
    #assert _spyro_authentication._rawauth(kwargs['auth'], 'Guigo.manager', 'delete_admin_guigo')
    #cond['idusuario'] = kwargs['auth'][0]
    xcond = _join_cond(cond)
    qres = db.query("SELECT objname FROM admin_guigo WHERE %s"%xcond)
    if len(qres) != 1:
        raise "Too many results to delete"
    x = db.execute('DELETE FROM admin_guigo WHERE %s'%xcond)
    if kwargs.has_key('__dont_return_list'):
        return x
    else:
        try:
            x = kwargs['__list_kwargs']
        except:
            x = {}
        x['objname'] = qres[0][0]
        return (('admin_guigo',(list_admin_guigo(x)),'admin_guigo'),)


def list_admin_guigo(condition_dict = None, orderby = None, **kwargs):
    tabname = 'admin_guigo'
    objname = 'Guigo.manager'
    suffix = 'admin_guigo'
    objlisting = condition_dict['objname']
    _newitem = _dictionary['_newitem']
    _delitem = _dictionary['_delitem']
    _moditem = _dictionary['_moditem']    
    if condition_dict is None: condition_dict = {}
    #assert _spyro_authentication._rawauth(kwargs['auth'], 'Guigo.manager', 'list_admin_guigo')
    #condition_dict['idusuario'] = kwargs['auth'][0]
    condition = _join_cond(condition_dict)
    #condition = 'true'
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    global db
    fields = ['id', 'objname', 'form', 'foreigntable', 'foreignfield', 'name', 'type_code', 'play_size', 'internal_size', 'precision', 'scale', 'null_ok','ui_ok']
    formindex = 2
    count = kwargs.get('count',50)
    begin = kwargs.get('begin',0)
    # Using cursors yields to a very poor performance (maybe we use in a wrong way). Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
    query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    l = [ '<tr>' ]
    for f in fields:
        if f in _InternalFields_admin_guigo: continue
        l.append("<th>%s</th>"%_field_title(f))
    l.append('</tr>')
    header = "".join(l)
    forms = {}
    for q in query:
        l = []
        name_id = fields[0]
        data_id = q[0]
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in _InternalFields_admin_guigo: continue
            r.append(_strip_field(q[i]))
        controls = [
            r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', ['update', {'%(name_id)s':'%(data_id)s'}]);void(0);">%(_moditem)s</a>"""%locals(),
            r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  [{'%(name_id)s':'%(data_id)s'}]);void(0);">%(_delitem)s</a>"""%locals()
        ]
        r.append("&nbsp;".join(controls))
        row = ("<tr>" + " ".join(map(lambda s: "<td>%s</td>"%s,r))+"</tr>")
        try:
            forms[q[formindex]].append(row)
        except KeyError:
            forms[q[formindex]] = [row]
    # cursor.close()
    tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [%(condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locals()

    res = [ "".join( _pager(begin, count, rowcount, tem) ) ]
    items = forms.items()
    items.sort()
    newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s',null,{'objname': '%(objlisting)s','form': 'Please set a new form name'}); ">Field in a new form (creates a new form)</a><br />"""%locals()
    res.append(newitemlink)
    for formname, formvalue in items:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s',null,{'objname': '%(objlisting)s','form': '%(formname)s'}); ">%(_newitem)s</a>"""%locals()
        res.append("""<div style="border: 1pt solid rgb(250,150,150); background-color: rgb(250,250,250); padding: 5pt;">""")
        res.append("<h1>Form: %s</h1>"%(formname.title()))
        res.append( "".join(['<table><tbody>', header, '\n'.join(formvalue),' </tbody></table>',newitemlink]) )
        res.append("""</div>""")
        res.append("<br />")
    res.append(res[0])
    return "".join(res)

def preview_admin_guigo(id, condition_dict=None, display = None, **kwargs):
    if condition_dict is None: condition_dict = {}
    #assert _spyro_authentication._rawauth(kwargs['auth'], 'Guigo.manager', 'preview_admin_guigo')
    #condition_dict['idusuario'] = kwargs['auth'][0]
    cond = _join_cond(condition_dict)
    # cond = '1=1'
    if display is None: display = 'name'
    return [[' ',' ']] + db.query('SELECT DISTINCT %s, %s FROM admin_guigo WHERE %s ORDER BY id'%(_sql_quote(id),_sql_quote(display),cond))



_InternalFields_admin_guigo_project = []
#_spyro_authentication.perms['form_admin_guigo_project'] = False
#_spyro_authentication.perms['list_admin_guigo_project'] = False
#_spyro_authentication.perms['modify_admin_guigo_project'] = False
#_spyro_authentication.perms['delete_admin_guigo_project'] = False

def form_admin_guigo_project(mode = None,condition_dict = None, **kwargs):
    if mode is None: mode = 'insert'
    dictdefault = {'' : 'Send','dbhost' : '','objpath' : '',
                   'dbname' : '','dbpass' : '','objname' : '','dbmanager' : '','dbuser' : '','id' : '','dbschema' : '',
                   'tempobject': '', 'tempform': ''}
    dictdefault['__mode__'] = mode
    if condition_dict is None:
        dictdefault['__cond__'] = '{}'
    else:
        dictdefault['__cond__'] = condition_dict
    if mode == 'update':
        dictdefault.update( db.hquery('SELECT * FROM admin_guigo_project WHERE %s'%_join_cond(condition_dict))[0] )
        _strip_dict(dictdefault)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode 
    return r"""
            <strong>Admin Guigo Objname</strong>
            <form method="POST" enctype="multipart/form-data" id="admin_guigo_project" action="javascript: void(0);" onsubmit="commitform(this, 'Guigo.manager','admin_guigo_project',['%(__mode__)s',Easyform_formToDict(this),%(__cond__)s]);" name="admin_guigo_project" >
                <table><tbody>
            <tr><td>Id: </td><td><input name="id:int:mandatory" type="text" value="%(id)s" size="40" /></td></tr>
<tr><td>Objname: </td><td><input name="objname:string:mandatory" type="text" value="%(objname)s" size="40" /></td></tr>
<tr><td>Objpath: </td><td><input name="objpath:string:mandatory" type="text" value="%(objpath)s" size="40" /></td></tr>
<tr><td>Dbname: </td><td><input name="dbname:string:mandatory" type="text" value="%(dbname)s" size="40" /></td></tr>
<tr><td>Dbhost: </td><td><input name="dbhost:string" type="text" value="%(dbhost)s" size="40" /></td></tr>
<tr><td>Dbuser: </td><td><input name="dbuser:string" type="text" value="%(dbuser)s" size="40" /></td></tr>
<tr><td>Dbpass: </td><td><input name="dbpass:string" type="text" value="%(dbpass)s" size="40" /></td></tr>
<tr><td>Dbmanager: </td><td><input name="dbmanager:string:mandatory" type="text" value="%(dbmanager)s" size="40" /></td></tr>
<tr><td>Dbschema: </td><td><input name="dbschema:string" type="text" value="%(dbschema)s" size="40" /></td></tr>
<tr><td>Template Object: </td><td><input name="tempobject:string" type="text" value="%(tempobject)s" size="40" /><br />
  (e.g. templates/newobject.py)</td></tr>
<tr><td>Template Form: </td><td><input name="tempform:string" type="text" value="%(tempform)s" size="40" /></td></tr>
<tr><td></td><td><input type="submit" name=":submit" value="%()s" /></td></tr>
                </tbody></table>
            </form>
            """%dictdefault

def modify_admin_guigo_project(mode, data, cond, **kwargs):
    # assert _spyro_authentication._rawauth(kwargs['auth'], 'Guigo.manager', 'modify_admin_guigo_project')
    if mode == 'update':
        if None in (data,cond): raise "Unable to update table with empty data"
        if len(cond) == 0: raise "Unable to update without condition"
        # cond['idusuario'] = kwargs['auth'][0]
        x = db.update('admin_guigo_project', _strip_dict(data), cond)
    elif mode == 'insert':
        if data is None: raise "Unable to insert into table with empty data"
        # data['idusuario'] = kwargs['auth'][0]
        x = db.insert('admin_guigo_project', _strip_dict(data))
    else:
        raise "Unknown action to modify admin_guigo_project "
    if kwargs.has_key('__dont_return_list'):
        return x
    else:
        try:
            x = kwargs['__list_kwargs']
        except:
            x = {}
        return (('admin_guigo_project',(list_admin_guigo_project(**x)),'admin_guigo_project'),)

def delete_admin_guigo_project(cond, **kwargs):
    if None is cond: raise "Unable to delete table with empty condition"
    if len(cond) == 0: raise "Unable to delete without condition"
    # assert _spyro_authentication._rawauth(kwargs['auth'], 'Guigo.manager', 'delete_admin_guigo_project')
    # cond['idusuario'] = kwargs['auth'][0]
    x = db.execute('DELETE FROM admin_guigo_project WHERE %s'%_join_cond(cond))
    if kwargs.has_key('__dont_return_list'):
        return x
    else:
        try:
            x = kwargs['__list_kwargs']
        except:
            x = {}
        return (('admin_guigo_project',(list_admin_guigo_project(**x)),'admin_guigo_project'),
                )


def list_admin_guigo_project(condition_dict = None, orderby = None, **kwargs):
    tabname = 'admin_guigo_project'
    objname = 'Guigo.manager'
    suffix = 'admin_guigo_project'
    _newitem = _dictionary['_newitem']
    _delitem = _dictionary['_delitem']
    _moditem = _dictionary['_moditem']    
    if condition_dict is None: condition_dict = {}
    #assert _spyro_authentication._rawauth(kwargs['auth'], 'Guigo.manager', 'list_admin_guigo_project')
    #condition_dict['idusuario'] = kwargs['auth'][0]
    condition = _join_cond(condition_dict)
    #condition = 'true'
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    global db
    fields = ['id', 'objname', 'dbname', 'dbhost', 'dbuser', 'dbpass', 'dbmanager', 'dbschema', 'objpath', 'tempobject', 'tempform']
    count = kwargs.get('count',50)
    begin = kwargs.get('begin',0)
    # Using cursors yields to a very poor performance (maybe we use in a wrong way). Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
    query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    l = [ '<tr>' ]
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    for q in query:
        name_id = fields[0]
        data_id = q[0]
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in _InternalFields_admin_guigo_project: continue
            r.append("<tr><td>%s</td><td>%s</td></tr>"%(_field_title(f),_strip_field(q[i])))
        controls = [
            r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', ['update', {'%(name_id)s':'%(data_id)s'}]);void(0);">%(_moditem)s</a>"""%locals(),
            # r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  [{'%(name_id)s':'%(data_id)s'}]);void(0);">%(_delitem)s</a>"""%locals(),
            r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
        ]
        r.append("<tr><td></td><td>" + "&nbsp;".join(controls) + "</td></tr>")
        l.append("".join(r))
    # cursor.close()
    tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [%(condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locals()

    res = [ "".join( _pager(begin, count, rowcount, tem) ) ]
    res.append( "".join(['<table><tbody>', '\n'.join(l),' </tbody></table>']) )
    res.append("<br />")
    res.append(res[0])
    return "".join(res)

def preview_admin_guigo_project(id, condition_dict=None, display = None, **kwargs):
    if condition_dict is None: condition_dict = {}
    #assert _spyro_authentication._rawauth(kwargs['auth'], 'Guigo.manager', 'preview_admin_guigo_project')
    #condition_dict['idusuario'] = kwargs['auth'][0]
    #cond = _join_cond(condition_dict)
    cond = '1=1'
    if display is None: display = 'objname'
    return db.query('SELECT %s,%s FROM admin_guigo_project WHERE %s'%(_sql_quote(id),_sql_quote(display),cond))


def preview_type_code(*args,**kwargs):
    res = []
    for x in ('char','varchar','int','float','list','datetime','timestamp','time','date','bool','submit'):
        res.append([x,x.title()])
    return res

import template3k
def index(objname=None,**kwargs):
    temp = template3k.get_template(appconfig.template_admin)
    return temp.merge(PageTitle='Guigo.manager',
                      Menu='''<td><a href="/">guigo</a></td>''',
                      JavascriptInit='''callto({'handler':Show},'Guigo.manager','showpage',[%s])'''%repr(objname),
                      DevelQuote='',
                      Title='Module Guigo',
                      Content='',
                      Comments='',
                      CommentsTitle=''
                      )

def showpage(objname=None,**kwargs):
   res = []
   res.append(('Admin Guigo Objname',list_admin_guigo_project({'objname':objname}),'admin_guigo_project'))
   res.append(('Admin Guigo',list_admin_guigo({'objname': objname}),'admin_guigo'))
   return res
