"""

This SPyRO's object focuses in administration issues over all SPyRO's objects
and services of Dweba applications.

"""

import os
import re
import db3k
import warn
import template3k
import appconfig
import warn
import auth3k
import auth3k.authweb as authweb
import SPyRO  as spyro
_spyro_authentication = authweb.Auth()
# To set permisions to the global module or object, uncomment the following
# [ [allowed users list], [ allowed groups list], [ denied user list] ]
_spyro_authentication.permsobject['admin'] = [[],['admin'],[]]
_spyro_authentication.perms['index'] = True
# Note: In module objects the object name must be the name of the object. If an authobject is
# manages many objects, there may exists many object names

# For method level management
_spyro_authentication.perms['only_admin'] = [[],['admin'],[]]
_spyro_authentication.perms['only_valid'] = None

dbconn = db3k.Connection(name="admin",manager="sqlite3",database="admin")

try:
    dbconn.query("""SELECT * FROM admin_objects """)
except Exception:
    import spyropack
    spyropack.sql_script(dbconn, "sql/packadmin.sql")
try:
    dbconn.query("""SELECT * FROM admin_counter LIMIT 1""")
except Exception,e:
    warn.warn("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",e)
    dbconn.execute("""CREATE TABLE admin_counter (name char(16), counter integer)""")
    dbconn.execute("""INSERT INTO admin_counter VALUES ('global', 2030) """)

re_word = re.compile("\w+")
def counter(name):
    dbconn.execute("UPDATE admin_counter SET counter = counter + 1 WHERE name = ?", (name,))
    counter = dbconn.query("SELECT counter FROM admin_counter")[0][0]
    return counter
    
def index(groups="",excludegroups=""):
    res = ["""<table style="width: 100%"><tbody>"""]
    grp = {}
    groups = re_word.findall(groups)
    excludegroups = re_word.findall(excludegroups)
    if len(groups) == 0:
        groups = None
    desc = {}
    for obj in dbconn.hquery("""SELECT * FROM admin_objects """
                             """INNER JOIN admin_objgroups """
                             """ON admin_objects.groupname = admin_objgroups.id """
                             """ORDER BY precedence"""):
        if obj['imageurl'] is None:
            obj['imageurl'] = '/images/noimage.jpg'
        groupname = obj['groupname']
        desc[groupname] = obj['description']
        if groups and groupname not in groups:
            continue
        if groupname in excludegroups:
            continue
        if not obj['enabled']:
            continue
        try:
            xres = grp[groupname]
        except KeyError:
            grp[groupname] = xres = []
        xres.append("""<tr><th colspan="2" class="demoname">%(name)s</th></tr>"""
                    """<tr><td><img src="%(imageurl)s" /></td>"""
                    """<td><a href="%(indexurl)s">%(name)s</a>. %(description)s."""
                    """<p>Provider: <a href="%(homepage)s">%(provider)s</a></p>"""
                    """</td></tr>"""%obj)
    if groups is None:
        groups = grp.keys()
        groups.sort()
    for k in groups:
        try:
            v = grp[k]
        except KeyError:
            continue
        res.append("""<tr><th colspan="2" class="firsttitle">%s</th></tr>"""%desc[k])
        res.extend(v)
    res.append("</tbody></table>")
    return template3k.get_template(appconfig.template_admin).merge(
        Title = """Dweba's Manager Page""",
        JavascriptInit="""DOM3K_Call(function(d){});""",
        Content="".join(res)
        )


