import re
import ft3k
import db3k
import datetime
import time
import warn
import locale3k
import appconfig
import mailadmin
warn = warn.Warn("forum")

locale3k.insertlist([ {"objname": "forum", "name": "start_thread", "encoding": "utf8", "locale": "en", "translation": "Start a thread"},
                      {"objname": "forum", "name": "start_thread", "encoding": "utf8", "locale": "es", "translation": "Inicia un hilo"},
                      {"objname": "forum", "name": "parent", "encoding": "utf8", "locale": "en", "translation": "Parent"},
                      {"objname": "forum", "name": "parent", "encoding": "utf8", "locale": "es", "translation": "Padre"},
                      {"objname": "forum", "name": "top", "encoding": "utf8", "locale": "en", "translation": "Top"},
                      {"objname": "forum", "name": "top", "encoding": "utf8", "locale": "es", "translation": "Inicio"},
                      {"objname": "forum", "name": "message_title", "encoding": "utf8", "locale": "en", "translation": "Message"},
                      {"objname": "forum", "name": "message_title", "encoding": "utf8", "locale": "es", "translation": "Mensaje"},
                      {"objname": "forum", "name": "name", "encoding": "utf8", "locale": "en", "translation": "Name"},
                      {"objname": "forum", "name": "name", "encoding": "utf8", "locale": "es", "translation": "Nombre"},
                      {"objname": "forum", "name": "subject", "encoding": "utf8", "locale": "en", "translation": "Subject"},
                      {"objname": "forum", "name": "subject", "encoding": "utf8", "locale": "es", "translation": "Asunto"},
                      {"objname": "forum", "name": "more", "encoding": "utf8", "locale": "en", "translation": "more"},
                      {"objname": "forum", "name": "more", "encoding": "utf8", "locale": "es", "translation": "m&acute;s"},
                      {"objname": "forum", "name": "reply", "encoding": "utf8", "locale": "en", "translation": "reply"},
                      {"objname": "forum", "name": "reply", "encoding": "utf8", "locale": "es", "translation": "responder"},
                      {"objname": "forum", "name": "add", "encoding": "utf8", "locale": "en", "translation": "add"},
                      {"objname": "forum", "name": "add", "encoding": "utf8", "locale": "es", "translation": "Adicionar"},
                      {"objname": "forum", "name": "prev", "encoding": "utf8", "locale": "en", "translation": "Previous"},
                      {"objname": "forum", "name": "prev", "encoding": "utf8", "locale": "es", "translation": "Anterior"},
                      {"objname": "forum", "name": "next", "encoding": "utf8", "locale": "en", "translation": "Next"},
                      {"objname": "forum", "name": "next", "encoding": "utf8", "locale": "es", "translation": "Siguiente"},
                      ])
nummsg = 10

from auth3k import authweb
_spyro_authentication = authweb.Auth()

_spyro_authentication.permsobject['forum'] = [[],[],[]]
_spyro_authentication.perms['save'] = True
_spyro_authentication.perms['form'] = True
_spyro_authentication.perms['save_contact'] = True
_spyro_authentication.perms['list_contacts'] = True
_spyro_authentication.perms['list_messages'] = True
_spyro_authentication.perms['index'] = True
_spyro_authentication.perms['search'] = True
_spyro_authentication.perms['form_search'] = True
_spyro_authentication.perms['search_related'] = True

# if exists a previous definition of forum and contact they will be used,
# else it ueses this new definitions (see db3k doc)
forumdb = db3k.Connection(name="forum",database="forum",manager="sqlite3")
contactdb = db3k.Connection(name="contact",database="contact",manager="sqlite3")
ftindex = ft3k.sqlindex(name='forum', conn=forumdb)

warn.debug("checking for tables")
try:
    forumdb.query("SELECT * FROM forum WHERE id = 0 LIMIT 1")
except Exception:
    warn.debug("creating tables for forum")
    import spyropack
    spyropack.sql_script(forumdb,"sql/forum.sql")

try:
    contactdb.query("SELECT * FROM forum WHERE id = 0 LIMIT 1")
except Exception:
    warn.debug("creating tables for contact")
    import spyropack
    spyropack.sql_script(contactdb,"sql/forum.sql")

def list_contacts(*args, **kwargs):
    kwargs['db'] = 'contact'
    return list_messages(*args, **kwargs)

def output_message(rank,res):
    res["rank"] = rank
    return ("""<div>Subject: %(subject)s\n"""
            """Name: %(name)s, """
            """Postdate: %(postdate)s, """
            """Email: %(email)s\n"""
            """<div>Comment: <span>%(comment)s</span></div></div>"""%res)
    
def list_messages(datemin='2000-01-01',subject="",offset=0,datemax="",parentid=0,usegrandparent=0,db="forum", mensajes=None):
    if db == 'forum':
        conn = forumdb
    elif db == 'contact':
        conn = contactdb
    else:
        raise Exception("Unknown database %s"%db)
    parentid=int(parentid)
    offset=int(offset)
    if datemin == "":
        datemin = '2000-01-01'
    try:
        datetime.date(*map(int,datemin.split("-")))
    except:
        raise Exception,"The post date must be in YYYY-MM-DD format"
    datemaxsql = ''
    if len(datemax) >0:
        try:
            datetime.date(*map(int,datemax.split("-")))
            datemaxsql = "AND postdate<=('%(datemax)s 23:59:59')"%locals()
        except:
            raise Exception,"The postdate must be in YYYY-MM-DD format"
    if usegrandparent and int(parentid) != 0:
        parentid = forumdb.query("SELECT parentid FROM forum WHERE id = ?", (parentid,))[0][0]
    locale = locale3k.getweblocale()
    start_thread_label = locale3k.getname("forum","start_thread", locale)
    parent_label = locale3k.getname("forum", "parent", locale)
    top_label = locale3k.getname("forum", "top", locale)
    message_label = locale3k.getname("forum", "message_title", locale)
    search = form_search()
    res = ["""<div style="padding: 3pt;">"""
           """%(search)s<br/>"""
           """<a href="javascript: callto({'handler': function(d) { DOM3K_updateElement(d,'MessageList'); }},"""
           """'forum','list_messages', null, {'parentid': %(parentid)s, 'usegrandparent' : 1}); void(0);">%(parent_label)s</a>"""
           """ &nbsp; """
           """<a href="javascript: callto({'handler': function(d) { DOM3K_updateElement(d,'MessageList'); }},"""
           """'forum','list_messages', null, {'parentid': 0}); void(0);">%(top_label)s</a>"""
           """ &nbsp; """
           """<a href="javascript: """
           """callto({'handler': function(d) { DOM3K_createFrame(d,'title=\\'%(message_label)s\\''); }},"""
           """'forum','form', [0]); void(0);">%(start_thread_label)s</a>"""
           """</div>
           """%locals()]
    if datemin is None:
        datemin = '2000-01-01 00:00:00'
    if len(subject)>0:
        sqlsubject = " AND subject='%(subject)s' "%locals()
    else:
        sqlsubject = ''
    if not mensajes:
        mensajes = conn.hquery(("SELECT * FROM forum WHERE parentid = '"+str(parentid)+"' AND postdate >= %s " + sqlsubject + datemaxsql + " ORDER BY postdate DESC LIMIT %d, %d")%(datemin,offset,nummsg))
    siguiente = navigation_links(datemin,subject,offset,datemax,len(mensajes),parentid)
    for m in mensajes:
        m['name_label'] = locale3k.getname("forum", "name", locale)
        m['subject_label'] = locale3k.getname("forum", "subject", locale)
        m['more_label'] = locale3k.getname("forum", "more", locale)
        m['reply_label'] = locale3k.getname("forum", "reply", locale)
        m['add_label'] = locale3k.getname("forum", "add", locale)
        m['related_label'] = locale3k.getname("actions", "related", locale)

        res.append("""<div class="letrachica" style="padding: 5pt;">"""
                   """<div class="cell1">"""
                   """<em class="definicion">%(name_label)s:</em> %(name)s, %(postdate)s. <br />"""
                   """<em class="definicion">%(subject_label)s:</em> %(subject)s."""
                   """<div>"""
                   """%(comment)s"""
                   """</div>"""
                   """<a href="javascript: callto({'handler': function(d) { DOM3K_updateElement(d,'MessageList'); }}, 'forum','list_messages', null, {'parentid': %(id)s}); void(0);">%(more_label)s (%(reviewed)s)</a>"""
                   """ &nbsp; """
                   """<a href="javascript: callto({'handler': function(d) { DOM3K_createFrame(d,'title=\\'Message\\''); }}, 'forum','form', [%(id)s,'Re: %(subject)s']); void(0);">%(reply_label)s</a>"""
                   """ &nbsp; """
                   """<a href="javascript: callto({'handler': function(d) {"""
                   """DOM3K_createFrame(d,'title=\\'Message\\''); }},"""
                   """'forum','form', [%(parentid)s,'Re: %(subject)s']); void(0);">%(add_label)s</a>"""
                   """ &nbsp; """
                   """<a href="javascript: callto({'handler': function(d) { DOM3K_updateElement(d,'MessageList'); }}, 'forum','search_related', null, {'id': %(id)s}); void(0);">%(related_label)s</a>"""
                   """</div>"""
                   """</div>"""%m)
    res.append(siguiente)
    res.append("""</div>""")
    return '\n'.join(res)

def navigation_links(datemin,subject,offset,datemax,nummessages,parentid):
    offset2 = int(offset) + nummsg
    offset3 = int(offset) - nummsg 
    if offset == "0":anterior = ''
    locale = locale3k.getweblocale()
    prev_label = locale3k.getname("forum","prev", locale)
    next_label = locale3k.getname("forum","next", locale)

    anterior = """<a href="javascript: void(0);" onclick="callto({'showresults': function(d) {DOM3K_updateElement(d,'MessageList');}},'forum','list_messages',['%(datemin)s','%(subject)s','%(offset3)s','%(datemax)s',%(parentid)s]);">%(prev_label)s</a> """%locals()
    if nummessages < nummsg:
        siguiente = ''
    else:
        siguiente = """<a href="javascript: void(0);" onclick="callto({'showresults': function(d) {DOM3K_updateElement(d,'MessageList');}},'forum','list_messages',['%(datemin)s','%(subject)s','%(offset2)s','%(datemax)s',%(parentid)s]);">%(next_label)s</a> """%locals()
    return ( """<span class="contenido"> """
             """<em style="font-size: smaller;">%(anterior)s</em> """
             """</span> &nbsp;&nbsp;&nbsp;&nbsp; """
             """<span class="contenido">"""
             """<em style="font-size: smaller;">%(siguiente)s</em>"""
             """</span>""" )%locals()

def save_contact(*args, **kwargs):
    kwargs['db'] = 'contact'
    return save(*args, **kwargs)

def save(subject, comment, name = None, email=None, parentid=0, db="forum", **kwargs):
    if db == 'forum':
        conn = forumdb
    elif db == 'contact':
        conn = contactdb
    else:
        raise Exception("Unknown database %s"%db)
    if appconfig.mail_forum_post:
        mailadmin._sendmail(appconfig.mail_admin_from, appconfig.mail_forum_post, "Post to %s/%s"%(appconfig.sysname,db),
                            ("""Subject: %(subject)s\n"""
                             """Name: %(name)s\n"""
                             """Email: %(email)s\n"""
                             """Parent Id: %(parentid)s\n"""
                             """DB: %(db)s"""
                             """Comment: %(comment)s"""%locals()))
    if parentid is None:
        raise Exception("parentid is None")
    try:
        name = kwargs['auth'][0]
        email = "admin@threekong.com"
        dest = kwargs['dest']
    except KeyError, e:
        name = name.strip()
        email = email.strip()
        dest = None
    if len(name) == 0 or len(name)>60:
        raise Exception,"The name must have between 1 and 60 characteres (len: %s)"%name
    if len(email) > 0 and (not('@' in email)):
        raise Exception,"The email is not well formed, please review this issue before send the message"
    x = conn.execute("""INSERT INTO forum (name,email,subject,comment,postdate,reviewed,dest,parentid) """
                     """VALUES(?,?,?,?,current_timestamp,0,?,?)""",
                     (name,email,subject,comment,dest,parentid))
    conn.execute("""UPDATE forum SET reviewed = reviewed + 1 WHERE id = ?""",(parentid,))
    if db == 'contact':
        return ("""<div style="font-size: 0.5cm; padding: 1cm; text-align: center;">"""
                """Thanks for your time. Your message has been sent<br />"""
                """<form action="javascript: void(0);" onsubmit="DOM3K_deleteFrame(this);">"""
                """<input type="submit" name="Close" value="Close">"""
                """</form></div>""")
    else:
        ftindex.handle_insert(repr((name,email,subject, comment,dest,parentid)),
                              repr({'email': email, 'parentid': parentid}))
    return list_messages(parentid=parentid)

if False:
    for qh in forumdb.hquery("""SELECT * FROM forum"""):
        ftindex.handle_insert(repr(qh.values()),
                              repr({'email': qh['email'], 'parentid': qh['parentid']}))

def form_search(query='',**kwargs):
    dict_default = {'query': query}
    dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'MessageList'); }}, """
                                    r"""'forum','search',null,Easyform_formToDict(this));""")
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s" id="%(__id__)s">
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    <input name=":submit" value="Search" type="submit" />
    </form>
    """%dict_default

def search_related(id):
    return search(repr(forumdb.query("SELECT * FROM forum WHERE id = %s LIMIT 1"%int(id))))
    
def search(query,**kwargs):
    xres = []
    for rank, cond in ftindex.search(query):
        res = forumdb.hquery("SELECT * FROM forum WHERE %s LIMIT 1"%(forumdb.join_keys(eval(cond))))
        # xres.append(output_message(rank,res[0]))
        xres.extend(res)
    return "".join(list_messages(mensajes=xres)) # a hack to preserve the same output

import template3k
def form(parentid,subject='',idform="CommentForm",onsubmit=None):
    if not onsubmit:
        onsubmit = ("""formthis = this; callto({'handler':function(d) {"""
                    """DOM3K_updateElement(d, 'MessageList'); DOM3K_deleteFrame(formthis);} },'forum','save',null,DOM3K_formToDict(this));""")
    temp = template3k.get_template("templates/forum_message.html")
    return temp.merge(idform=idform,onsubmit=onsubmit,parentid=parentid,subject=subject)

def index():
    return list_messages()

