#coding: utf8;

__doc__ = ("""Locale support""")

import os
import re
import db3k
import warn
import template3k
import appconfig
import warn
warn = warn.Warn("admin")
import auth3k
import auth3k.authweb as authweb
import SPyRO  as spyro
_spyro_authentication = authweb.Auth()
# To set permisions to the global module or object, uncomment the following
# [ [allowed users list], [ allowed groups list], [ denied user list] ]
_spyro_authentication.permsobject['locale'] = [[],['admin'],[]]
_spyro_authentication.perms['index'] = True

db = db3k.Connection(name="locale",database="locale",manager="sqlite3")
import types

def insertlist(localelist):
    for data in localelist:
        try:
            if len(db.query("SELECT 1 FROM admin_locale WHERE %s"%db.join_keys(data))) == 0:
                db.insert("admin_locale",data)
        except db.dbm.IntegrityError:
            pass

def initialize():
    try:
        db.query("SELECT name FROM admin_locale LIMIT 1")
        return
    except Exception, e:
        import spyropack
        spyropack.sql_script(db, "sql/locale.sql")
    import basic_locales
    insertlist(basic_locales.basic_locales)

initialize()

def index():
    return template3k.get_template(appconfig.template_admin).merge(
        Title = """Locale Manager""",
        JavascriptInit="""DOM3K_Call(function(d){});""",
        Content=template3k.get_template("templates/locale.html").merge()
        )

_objcache = {}
_alias = {'en-en': 'en',
          'en-us': 'en',
          'en-gb': 'en',
          'en-au': 'en',
          'en': 'en',
          'es-es': 'es',
          'es-mx': 'es',
          'es': 'es'}

    
def setname(objname, name, locale, translation, encoding='utf8'):
    """ Set a translation and deletes the caches """
    try:
        locale = _alias[locale]
    except KeyError:
        locale = 'en'
    data = {"objname": objname, "name": name, "encoding": encoding, "locale": locale, "translation": translation}
    db.insert("admin_locale", data)
    try:
        del _objcache[objname][locale]
    except KeyError:
        pass

def getname(objname, name, locale=None, defaultvalue=None):
    """ Lookup for the text in locale |locale| of |name| in the namespace |objname|.
    If defaultvalue is given it must be a list of locale entries. e.g.
    
    [ {"encoding": "utf8", "locale": "es", "translation": "Editor de Localidad"}
      {"encoding": "latin1", "locale": "en", "translation": "Locale Editor"}
      ]
    Fields objname, locale, name, and translation are mandatory

    Locales en Guigo, cambiar documentacion template3k
    """
    if locale is None:
        locale = getweblocale()
    try:
        obj = getobject(objname, locale)
        data = obj[name]
    except KeyError, e:
        if defaultvalue:
            data = None
            for data in defaultvalue:
                try:
                    data["objname"] = objname
                    data["name"] = name
                    db.insert("admin_locale", data)
                except Exception:
                    pass
            try:
                del _objcache[objname][locale]
            except KeyError:
                pass
        else:
            raise
    try:
        enc = data["encoding"]
        if enc is None:
            data[None]
    except KeyError:
        return data["translation"]
    return data["translation"].decode(enc, "replace")

def getobject(objname, locale='en'):
    """ Returns the complete definition of objname for the locale |locale|.
    It caches the translation for faster access """
    try:
        locale = _alias[locale]
    except KeyError:
        locale = 'en'
    try:
        d = _objcache[objname]
    except KeyError:
        _objcache[objname] = d = {}
    try:
        res = d[locale]
    except KeyError:
        qres = db.hquery("SELECT name, encoding, translation FROM admin_locale WHERE objname = ? and locale = ?",(objname,locale))
        if len(qres) > 0:
            res = d[locale] = db3k.index_result(qres, "name")
        else:
            try:
                res = d['en']
            except KeyError:
                d.update(getfullobject(objname, "locale", 1))
                for k, v in getfullobject(objname, "locale", 1).items():
                    d[k] = db3k.index_result(v, "name")
            res = d['en']
    return res

def getfullobject(objname, key="locale", isdup=1):
    qres = db.hquery("SELECT name, locale, encoding, translation FROM admin_locale WHERE objname = ?",(objname,))
    if isdup:
        d = db3k.index_result_dup(qres, key)
    else:
        d = db3k.index_result(qres, key)
    return d

from shttp import http
def getweblocale():
    req = http.getrequest()
    try:
        loc = req['HTTP_ACCEPT_LANGUAGE'].split(",",1)[0].split(';')[0]
        try:
            return _alias[loc]
        except KeyError:
            return 'en'
    except (KeyError,IndexError,TypeError,ValueError):
        return 'en'

def Import(Data):
    pass

def Export(Objname, Lang):
    pass
