#coding: utf8;

__doc__ = ''' Easyform server to locale3k.locale_editor '''

import auth3k
import auth3k.authweb as authweb
_spyro_authentication = authweb.Auth()
# To set permisions to the global module or object, uncomment the following
# [ [allowed users list], [ allowed groups list], [ denied user list] ]
_spyro_authentication.permsobject['locale3k.locale_editor'] = [[],['admin'],[]]
# Note: In module objects the object name must be the name of the object. If an authobject is
# manages many objects, there may exists many object names

# For method level management
# _spyro_authentication.perms['methodname'] = [[],['admin'],[]]

# Gets automatically the connection because is already charged
import re
import warn
import db3k
import time
import locale3k
import template3k
import SPyRO as spyro
import appconfig

db = db3k.Connection(name='locale',
                     database='locale',
                     user=None,
                     password=None,
                     host=None,
                     manager='sqlite3')

#######################################
#######################################
#############
############  INDEX
#############
#######################################
#######################################
def index(**kwargs):
    objname = 'locale3k.locale_editor'
    title = 'Locale3K.Locale_Editor'
    temp = template3k.get_template(appconfig.template_admin)
    return temp.merge(PageTitle=objname.title(),
                      Menu='''<td><a href="index">%s</a></td>'''%objname.title(),
                      JavascriptInit='''callto({'handler':Show},'locale3k.locale_editor','showpage')''',
                      DevelQuote='',
                      Title='Module ' + title,
                      Content=''
                      )

def showpage(**kwargs):
    objname = 'locale3k.locale_editor'
    
    res = []
    res.append(('Admin Locale',list_admin_locale(),'admin_locale'))
    return res



#######################################
#####
####   COMMON CUSTOMIZABLE FUNCTIONS
#####
#######################################
def _sql_quote(f):
    return str(f).replace("'","''")

def _join_cond(d,joinmethod=None):
    try:
        items = d.items()
    except AttributeError:
        return ' 1=1 '
    if len(items) == 0:
        return ' 1=1 '
    else:
        if joinmethod == 'LIKE':
            return ' AND '.join([ "%s LIKE '%s%%'"%(_sql_quote(x[0]),_sql_quote(x[1])) for x in d.items()])
        else:
            return ' AND '.join([ "%s = '%s'"%(_sql_quote(x[0]),_sql_quote(x[1])) for x in d.items()])

# def _field_title(f):
#     return f.replace("_",' ').title()

# Field names transformations
_dictionary = {
    '_newitem' : 'New Item',
    '_delitem' : 'Delete',
    '_moditem' : 'Modify',
    }


def _title(g):
    """  To support accuted languages"""
    w = g.group(2)
    return " %s%s"%( w[0].title(),w[1:])
    
def _field_title(f):
    try:
        f = _dictionary[f]
    except KeyError:
        pass
    return re.sub(r"([\s_])([^_\s]+)",_title," " + f)
    # simpler, but doesn't support accuted characters
    # return f.replace("_",' ').title()


def _quote_html(f):
    return f.replace("<","&lt;").replace(">","&gt;") #.replace("&","&amp;")

import types
def _strip_field(value):
    # warn.debug("VVVVV   ",repr(value))
    if value is None:
        return ''
    elif isinstance(value, (types.FloatType, types.IntType, types.LongType)):
        return value
    else:
        for enc in ("utf8","latin1","latin2","latin3","utf16"):
            try:
                return value.encode(enc).decode(enc)
            except UnicodeEncodeError, e:
                warn.debug("Ignoring and Retrying on UnicodeError (enc, value, error): ", repr((enc, value, e)))
        enc = "utf8"
        return value.encode(enc).decode(enc,"replace")

def _strip_dict(d):
    for k,v in d.items():
        try:
            d[k] = _strip_field(d[k])
        except AttributeError:
            pass
    return d

def _pager(begin, count, total, template, num=15):
    xres = [ "Viewing %s elements (starting at %sth) from %s total entries "%(min(count,total-begin), begin, total) ]
    start = max(begin - num * count, 0)
    for x in range(num*2):
        page_number = start / count + 1
        if start == begin:
            xres.append("%s&nbsp;"%page_number)
        else:
            xres.append( template % locals() )
        start += count
        if start > total:
            if page_number == 1: return []
            break
    return xres


#######################################################################################
#######################################################################################
######
######   FORMS
######
#######################################################################################
#######################################################################################
modconfig = {}
#########################################
#########################################
###
### Table admin_locale
###

###
### Configuring admin_locale
###

modconfig['admin_locale'] = {
    'internal_fields' : [],
    'dict_default': { '' : '<python:locale id="general.submit" />','name' : '','encoding' : '','locale' : '','objname' : '','translation' : '',
                     '__objname__': 'locale3k.locale_editor',
                     '__tabname__': 'admin_locale'
                    },
    'editable': True,
    'count': 40,
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("admin_locale:form_element",
     """
            <strong>Admin Locale</strong>
            <form method="POST" enctype="multipart/form-data" id="form-admin_locale<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="admin_locale" >
                <table><tbody>
            
<tr><td>
<python:locale id="admin_locale.name">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Name'} ]
</python:locale>:</td><td><input name="name:string:mandatory" type="text" value="<python:keyword id="name" />" size="40" /></td></tr>


<tr><td>
<python:locale id="admin_locale.translation">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Translation'} ]
</python:locale>:</td><td><input name="translation:string:mandatory" type="text" value="<python:keyword id="translation" />" size="40" /></td></tr>


<tr><td>
<python:locale id="admin_locale.objname">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Objname'} ]
</python:locale>:</td><td><input name="objname:string:mandatory" type="text" value="<python:keyword id="objname" />" size="40" /></td></tr>


<tr><td>
<python:locale id="admin_locale.encoding">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Encoding'} ]
</python:locale>:</td><td><input name="encoding:string:" type="text" value="<python:keyword id="encoding" />" size="40" /></td></tr>


<tr><td>
<python:locale id="admin_locale.locale">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Locale'} ]
</python:locale>:</td><td><input name="locale:string:" type="text" value="<python:keyword id="locale" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("admin_locale:form_element_search",
     """
            <strong>Admin Locale</strong>
            <form method="POST" enctype="multipart/form-data" id="form-admin_locale<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="admin_locale" >
                <table><tbody>
            
<tr><td>
<python:locale id="admin_locale.name">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Name'} ]
</python:locale>:</td><td><input name="name:string" type="text" value="<python:keyword id="name" />" size="40" /></td></tr>


<tr><td>
<python:locale id="admin_locale.translation">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Translation'} ]
</python:locale>:</td><td><input name="translation:string" type="text" value="<python:keyword id="translation" />" size="40" /></td></tr>


<tr><td>
<python:locale id="admin_locale.objname">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Objname'} ]
</python:locale>:</td><td><input name="objname:string" type="text" value="<python:keyword id="objname" />" size="40" /></td></tr>


<tr><td>
<python:locale id="admin_locale.encoding">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Encoding'} ]
</python:locale>:</td><td><input name="encoding:string:" type="text" value="<python:keyword id="encoding" />" size="40" /></td></tr>


<tr><td>
<python:locale id="admin_locale.locale">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Locale'} ]
</python:locale>:</td><td><input name="locale:string:" type="text" value="<python:keyword id="locale" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration
###

###
### Beginning methods/functions
###

#_spyro_authentication.perms['form_admin_locale'] = False
#_spyro_authentication.perms['list_admin_locale'] = False
#_spyro_authentication.perms['modify_admin_locale'] = False
#_spyro_authentication.perms['delete_admin_locale'] = False

def _out_method_admin_locale(mode, condition_dict):
    tabname = 'admin_locale'
    return ((tabname,(list_admin_locale(condition_dict)),tabname),)

def _map_result_admin_locale(fieldname, value):
    foreigns = {}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        value = res[0][1]
    except (KeyError, IndexError):
        pass
    return _strip_field(value)

def form_admin_locale(mode = None,condition_dict = None, **kwargs):
    tabname = 'admin_locale'
    objname = 'locale3k.locale_editor'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_admin_locale(mode, data, cond, **kwargs):
    tabname = 'admin_locale'
    objname = 'locale3k.locale_editor'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_admin_locale)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _out_method_admin_locale(mode, cond)

def delete_admin_locale(cond, **kwargs):
    tabname = 'admin_locale'
    objname = 'locale3k.locale_editor'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_admin_locale)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    return _out_method_admin_locale("delete", cond)

def list_admin_locale(condition_dict = None, orderby = None, usecondmethod = None, **kwargs):
    tabname = 'admin_locale'
    objname = 'locale3k.locale_editor'
    suffix = 'admin_locale'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_admin_locale)
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    if condition_dict is None:
        condition_dict = {}
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = ['name', 'translation', 'objname', 'encoding', 'locale']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = _join_cond(condition_dict, usecondmethod)
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or len(condition_dict) > 0:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    for q in query:
        name_id = fields[0]
        data_id = q[0]
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_admin_locale(f, q[i]))# _strip_field(q[i]))
        if config['editable']:
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', {'%(name_id)s':'%(data_id)s'}]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[{'%(name_id)s':'%(data_id)s'}]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [%(condition_dict)s,%(strorderby)s,%(strcondmethod)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locals()
    res = [ ]
    if len(condition_dict) > 0:
        res.append("<div>Filter: %s</div>"%", ".join([ "%s: %s"%x for x in condition_dict.items()]))
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search and Filter on %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    res.append(searchlink + "".join( _pager(begin, count, rowcount, tem) ) )
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(res[0])
    return "".join(res)

def form_search_admin_locale(method=None, *args, **kwargs):
    tabname = 'admin_locale'
    objname = 'locale3k.locale_editor'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def search_admin_locale(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'admin_locale'
    objname = 'locale3k.locale_editor'
    config = modconfig[tabname]
    return (('', list_admin_locale(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_admin_locale(idtag, condition_dict, method="LIKE", outmethod="simple", previewsize=10, **kwargs):
    tabname = 'admin_locale'
    objname = 'locale3k.locale_editor'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_admin_locale)
    locale = locale3k.getweblocale()
    if condition_dict is None:
        condition_dict = {}
    fields = ['name', 'translation', 'objname', 'encoding', 'locale']
    count = previewsize
    begin = 0
    condition = _join_cond(condition_dict, method)
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or len(condition_dict) > 0:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']
    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    for q in query:
        name_id = fields[0]
        data_id = q[0]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_admin_locale(f, q[i]))
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,%s]], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),repr(name.encode("utf8")),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)
    
def preview_admin_locale(id, condition_dict=None, display = None, **kwargs):
    tabname = 'admin_locale'
    objname = 'locale3k.locale_editor'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_admin_locale)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        display = 'translation'
    return db.query('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id),_sql_quote(display),tabname,condition))
