#coding: utf8;

__doc__ = """
This will be a tutorial
"""
import auth3k
import auth3k.authweb as authweb
from shttp import http
import SPyRO  as spyro

_spyro_authentication = authweb.Auth()
# To set permisions to the global module or object, uncomment the following
# [ [allowed users list], [ allowed groups list], [ denied user list] ]
_spyro_authentication.permsobject['proxykong'] = [[],['admin'],[]]
# Note: In module objects the object name must be the name of the object. If an authobject is
# manages many objects, there may exists many object names

# For method level management
_spyro_authentication.perms['only_admin'] = [[],['admin'],[]]
_spyro_authentication.perms['only_registered'] = None
_spyro_authentication.perms['login'] = True

import socket
import sys
import urllib
import urlparse
import warn
import db3k
import time
import base64
import useradmin
import appconfig
from shttp import http
from shttp import ahttplib

def _init(spyroserver, httpserver, loginhosts, proxyhosts):
    warn.debug("Initializing proxy at ", proxyhosts)
    warn.debug("Initializing proxy setup at ", loginhosts)
    for virtual_host in proxyhosts:
        httpserver.register_urihandler('', _connect, virtual_host=virtual_host)
    for h in loginhosts:
        httpserver.register_urihandler('/spyro/', http.handlespyro(spyroserver), virtual_host=h, rewrite=appconfig.main_rewrite)
        httpserver.register_urihandler('/call/', http.httpcallspyro(spyroserver,'text/html'), virtual_host=h, rewrite=appconfig.main_rewrite)
    global LOGIN_HOST
    LOGIN_HOST = loginhosts[0]

LOGIN_HOST="localhost:8000" # Setup virtual host, this virtual host will respond like a normal server, and it will be put as the login server
MAX_HEADERS=30
MAX_INACTIVITY=60*30 # 30 minutes
IP_ADDRESS = {} # host: ip
ACCESS_COUNTER = {} # host: counter
LOGGED_USERS = {} # ip: (lastrequest, hostname)

def _checktime(username, now):
    try:
        lasttime, hostname = LOGGED_USERS[username]
    except KeyError,e:
        warn.debug(repr((username, now, e)))
        return False
    if (lasttime + MAX_INACTIVITY) < now:
        return False
    return True

def _checkauth(httpreq, env, connectlocals):
    return True
    now = time.time()
    warn.debug(env)
    try:
        authtype, authproxy = env['HTTP_PROXY_AUTHORIZATION'].split()
        if authtype == 'Basic':
            username,password=base64.decodestring(authproxy).split(":")
            if useradmin.validate_user(username, password):
                if not _checktime(username, now):
                    LOGGED_USERS[username] = (now, env['REMOTE_ADDR'])
                    first_login(username)
                    return # never reached
                LOGGED_USERS[username] = (now, env['REMOTE_ADDR'])
            else:
                raise KeyError("user and password don't match for %s"%username)
    except KeyError, e:
        warn.log("proxykong _checkauth error: ", e)
        request_login()
        return # never reaches here, login raises CustomResponse
    return True

def request_login():
    location = "http://%s/call/proxykong/login"%LOGIN_HOST
    headers = (('Proxy-Authenticate', 'Basic realm="ProxyKong. threekong.com Login", uri="%s"'%LOGIN_HOST),)
    status = 407
    res = "<html><body><a href='%s'>click</a></body></html>"%location
    raise http.CustomResponse(res, status=status, content_type="text/html", headers=headers)

def first_login(username):
    headers = (('Location', 'http://threekong.com/call/proxykong/hello/index'),)
    raise http.CustomResponse('Redirecting to <a href="http://threekong.com/call/proxykong/hello/index">ProxyKong</a> at threekong.com',
                              status=302, content_type="text/html", headers=headers)

class solving_in_background(Exception):
    pass

from medusa import producers
class proxy_output:
    def __init__(self, httpreq):
        self.httpreq = httpreq
        self.sentheaders = False

    def write(self, s):
        assert self.sentheaders, "Headers not sent"
        self.httpreq.channel.push_with_producer(producers.scanning_producer(s))
        
    def seek(self, s):
        pass

    def endcallback(self, client):
        print "endcallback-XXXXXXXXXXXXXXXXXXXXXXXXX"
        self.httpreq.channel.close_when_done()
        client.close()
        
    def begincallback(self, client):
        if len(client.headers) > MAX_HEADERS:
            raise Exception("Too many headers in the response")
        status = int(client.path)
        self.httpreq.reply_code = status
        #             if status == 404:
        #                 resp = _userhtml(Title="The page was not found",
        #                                  Content="The remote server don't have the page that you request")
        #             elif status == 501:
        #                 resp = _userhtml(Title="Remote Server Error",
        #                                  Content="The remote server has an error due to remote problems")
        for k, v in client.headers:
            k = k.lower()
            #if k.startswith("x"):
            #    continue
            if k.startswith("proxy"):
                continue
            if (k == 'connection'):
                v = 'close'
            if (k == 'transfer-encoding') and (v == 'chunked'):
                continue
            # if (k == 'etag'):
            #    continue
            self.httpreq[k.title()] = v
        self.httpreq['Proxy-Connection'] = 'close'
        self.httpreq['Connection'] = 'close'
        h = self.httpreq.build_reply_header()
        print "----------------------------------------------"
        print repr(h)
        self.sentheaders = True
        self.httpreq.channel.push_with_producer( producers.simple_producer(h) )
            
def _connect(httpreq, env):
    try:
        _dispatch(httpreq, env)
    except solving_in_background:
        print "solving in background"
        return
    except http.CustomResponse:
        raise
    except:
        warn.warn("proxy error")
        resp = _userhtml(Title="Connection Error",
                         Content="Connection Error Solving Request")
        raise http.CustomResponse(resp, status=501,content_type="text/html")

def _dispatch(httpreq, env):
    method, url, version = httpreq.command, httpreq.uri, httpreq.version
    # (path, params, query, fragment) = request.split_uri()
    parsed = urlparse.urlparse(url)
    host = parsed[1]
    if host == '':
        host = httpreq.get_header('host')
    # host con pruerto?
    host, port = urllib.splitport(host)
    if port is None:
        port = 80
    else:
        port = int(port)
    try:
        ip = IP_ADDRESS[host]
        ACCESS_COUNTER[host] += 1
    except KeyError:
        ip = IP_ADDRESS[host] = socket.gethostbyname(host)
        ACCESS_COUNTER[host] = 1
    # warn.debug(IP_ADDRESS)
    # warn.debug("TIMEOUT SET: ",conn.sock.settimeout(0))
    path = parsed[2]
    if parsed[-2] != '':
        path = path + "?" + parsed[-2]
    # warn.debug(httpreq.requestline)
    reqmethod = env["REQUEST_METHOD"]
    _checkauth(httpreq, env, locals())
    conn_manager = proxy_output(httpreq)
    conn = ahttplib.HTTPConnection(ip, port,
                                   outobj=conn_manager,
                                   begincallback=conn_manager.begincallback,
                                   endcallback=conn_manager.endcallback)
    conn.putrequest(reqmethod, path, httpreq.version)
    # conn.putrequest(reqmethod, path)
    items = [ x.split(":",1) for x in httpreq.header ]
    if len(items) > MAX_HEADERS:
        raise Exception("Too many headers")
    for k,v in items:
        k = k.lower().strip()
        v = v.strip()
        if k == 'host':
            v = host
        if k.startswith('proxy'): # or k.startswith('accept'):
            continue
        # warn.debug(repr((k,v)))
        conn.putheader(k.title(), v)
    if reqmethod.lower() == 'post':
        s = httpreq.input_data
    else:
        s = None
    conn.endheaders()
    if s:
        conn.push(s)
    raise solving_in_background,"out"

# def sleep():
#     warn.debug("RUNNING SLEEP")
#     import time
#     time.sleep(20)
#     return "OK SLEEP"

# def runsleep3():
#     return runsleep()

# def runsleep():
#     conn = httplib.HTTPConnection("localhost",8000)
#     warn.debug("running sleep")
#     conn.request("GET","/call/proxykong/sleep")
#     resp = conn.getresponse()
#     raise http.CustomResponse(resp, content_type="text/plain")

import template3k
def _userhtml(**kwargs):
    temp = template3k.get_template(appconfig.template_index)
    kwargs['Quote'] = ''
    kwargs['CallTestB'] = ''
    kwargs['DevelQuote']=("""<strong>Proxy Kong</strong> """)
    return temp.merge(kwargs)

def _makehtml(**kwargs):
    temp = template3k.get_template(appconfig.template_admin)
    kwargs['Quote'] = "Proxing, authenticating, and filtering as easy like eat bananas, for a python developer :)"
    kwargs['DevelQuote']=("""<strong>Proxy Kong:</strong> """
                          """<a href="index">Statistics</a> | """
                          """<a href="cmd_showhosts">Show Hosts</a> | """
                          """<a href="cmd_showusers">Show Users</a> | """
                          """<a href="cmd_clearipcache">Clean IP Cache</a> """
                          """""")
    kwargs["Content"] += ("""<br />Note: All the statistics and caches are volatil information, """
                          """if you change the module or shutdown your server or the process they """
                          """will be reset (If you need to store all this data, please contact us at """
                          """<a href="">http://threekong.com</a>)""")
    return temp.merge(kwargs)

def cmd_clearipcache():
    x = len(IP_ADDRESS)
    IP_ADDRESS.clear()
    return _makehtml(Title = "Clearing ip cache",
                     Content = "Removed %s addresses"%x)

def cmd_showhosts():
    res = ["<table>"]
    items = IP_ADDRESS.items()
    for host, ip in items:
        res.append("<tr><td>%s</td><td>%s</td></tr>"%(host,ip))
    res.append("</table>")
    return _makehtml(Title = "List of Accessed Hosts",
                     Content = "".join(res))

def cmd_showusers():
    res = ["<table>"]
    items = LOGGED_USERS.items()
    for username, data in items:
        lasttime, clientname = data
        res.append("<tr><td>xx%s</td><td>%s</td><td></td></tr>"%(username,clientname,lasttime))
    res.append("</table>")
    return _makehtml(Title = "List of Users",
                     Content = "".join(res))

def index(**kwargs):
    res = ["<table><tbody>"]
    items = ACCESS_COUNTER.items()
    for host, ip in items:
        res.append("<tr><td>%s</td><td>%s</td></tr>"%(host,ip))
    res.append("</tbody></table>")

    return _makehtml(Title = "Proxy Kong",
                     Content = "".join(res))
