CREATE TABLE lib3k_user
(
	xid integer primary key,
	email varchar(32) unique, 
	city varchar(32),
	country varchar(32)
);

insert into lib3k_user VALUES(0, 'anonymous@localhost', '', '');

create table lib3k_resource (
	xid integer primary key,
        foreignid integer,
	sha1 varchar(40),
	url varchar(127),
	contenttype varchar(24),
	owner integer references lib3k_user(xid),
	description text,
	keywords text,
	access_policies varchar(32)
);

CREATE INDEX l3kressha ON lib3k_resource(sha1);
CREATE INDEX l3kforid ON lib3k_resource(foreignid);

create table lib3k_annotation (
	resourceid integer references lib3k_resource(xid),
	annotation_owner integer references lib3k_user(xid) default 0,
	annotation text
);

CREATE INDEX l3kannot ON lib3k_annotation(resourceid);