CREATE TABLE admin_objgroups (
       id char(12) UNIQUE,
       description char(48)
);

CREATE TABLE admin_objects(
       name char(24), -- any name
       description char(24), -- 
       imageurl char(24), 
       version char(12), -- normalization
       indexurl char(64), -- relative to packadmin
       license char(16),
       ownermail char(48), -- owner mail
       homepage char(48), -- homepage
       provider char(48), -- provider or company name
       groupname char(12) references admin_objgroups(id), -- application group
       precedence integer DEFAULT 0, -- application order
       enabled integer DEFAULT 1, -- application order
       UNIQUE(name, version)
);

CREATE INDEX admobjgrp ON admin_objects(groupname);

INSERT INTO admin_objgroups VALUES('admin','Administrator Objects');

INSERT INTO admin_objects VALUES('User Manager',
       'Manage your users and groups', NULL, NULL,
       '../useradmin/index', 'GPL', 'donsadit@gmail.com', 'http://threekong.com', 'threekong.com',
       'admin', 1, 1);

INSERT INTO admin_objects VALUES('Admin Objects',
       'Document and group links to objects of SPyRO. A Simple register of the objects', NULL, NULL,
       '../packadmin/admin_objects/index', 'GPL','donsadit@gmail.com', 'http://threekong.com', 'threekong.com',
       'admin', 0, 1);		    

INSERT INTO admin_objects VALUES('Locale Manager',
       'Locale Manager for SPyRO objects', NULL, NULL,
       '../locale3k/locale_editor/index', 'GPL','donsadit@gmail.com', 'http://threekong.com', 'threekong.com',
       'admin', 0, 1);		    

INSERT INTO admin_objects VALUES('Package Manager',
       'Install, delete or modify packages. Create and modify modules using a simple web interface', NULL, NULL,
       '../packadmin/index', 'GPL','donsadit@gmail.com', 'http://threekong.com', 'threekong.com',
       'admin', 0, 1);		    
INSERT INTO admin_objects VALUES('Proxy Kong',
       'A simple HTTP proxy that claims to be as easy like eat bananas, for python develpers :)', NULL, NULL,
       '../proxykong/index', 'GPL', 'donsadit@gmail.com', 'http://threekong.com', 'threekong.com',
       'admin', 3, 1);

INSERT INTO admin_objects VALUES('Mini Forum', 'A lightweight forum for message posting', NULL, NULL,
       '../forum/index', 'GPL', 'donsadit@gmail.com', 'http://threekong.com', 'threekong.com',
       'admin', 4, 1);

