#coding: utf8;
<python:exec id="FirstCommands">
import time

</python>

"""
Graphical User Interface Object generated by Guigo!

    - Date: <python:call id="GuigoGenerationTime">time.ctime()</call>
    - Original object's name:  <python:keyword id="Objname" />

Guigo creates an API for create AJAX Web UIs to manage databases providing capabilities for
listing, updates, inserts, structured searches, fulltext searches, linking foreign data, related searches,
and more...
Guigo claims to have fully customizable options. In addition to the API, it creates
a basic AJAX Web UI with all the capabilities, proving a tool to work over a database schema.

To setup the operations it's based on handlers over tables.

"""

import auth3k
import auth3k.authweb as authweb
_spyro_authentication = authweb.Auth()
# To set permisions to the global module or object, uncomment the following
# [ [allowed users list], [ allowed groups list], [ denied user list] ]
_spyro_authentication.permsobject[<python:keyword id="QuotedObjname" />] = [[],['admin'],[]]
# Note: In module objects the object name must be the name of the object. If an authobject is
# manages many objects, there may exists many object names

# For method level management
# _spyro_authentication.perms['methodname'] = [[], ['admin'], []]

# Gets automatically the connection because is already charged
import re
import warn
import db3k
import time
import locale3k
import template3k
import SPyRO as spyro
import appconfig
import ft3k
import types
# import marshal

dbmanager=<python:keyword id="QuotedDbmanager" />
if dbmanager.startswith('sqlite'): # param style qmark
    # sqlite can't use indexes with like operator,  we use a work around (see _like_cond function for details)
    likechar = None 
    _kwargs = {'timeout': 60 * 60}
else:
    likechar = '%%'
    _kwargs = {}
# elif param style = qmark: likechar = '%s'

# db = db3k.Connection(name=<python:keyword id="QuotedDbname" />,
#                      database=<python:keyword id="QuotedDbname" />,
#                      user=<python:keyword id="QuotedDbuser" />,
#                      password=<python:keyword id="QuotedDbpass" />,
#                      host=<python:keyword id="QuotedDbhost" />,
#                      manager=dbmanager,
#                      kwargs=_kwargs)

ftname="ft%s"%(<python:keyword id='QuotedDbname' />)
def ftpool_create(name):
    conn = db3k.create2(name=name)
    spyro.register_exit_handler(ftpool_exit_handler)
    return conn

ftpool=db3k.ThreadPool(ftname, dbmanager, ftpool_create)
dbftindex = db3k.Connection(
                     name=ftname,
                     database=<python:keyword id="QuotedDbname" />,
                     user=<python:keyword id="QuotedDbuser" />,
                     password=<python:keyword id="QuotedDbpass" />,
                     host=<python:keyword id="QuotedDbhost" />,
                     manager=dbmanager,
                     pool=ftpool)
db = dbftindex # transactional database connection

def ftpool_exit_handler():
    """
    Exit request handler. Used by the fulltext database to commit changes.
    Currently, all the objects are generated using a transactional scheme by spyro request.
    
    This behaviour can be changed editing this module
    """
    try:
        ftpool.delconn(1)
    except KeyError, e:
        warn.debug("ftpool_exit_handler ", <python:keyword id="QuotedObjname" />, ": ", e)

#######################################
#######################################
#############
############  INDEX
#############
#######################################
#######################################
def index(**kwargs):
    """
    Shows the index page for this object.
    @return: html page
    """
    objname = <python:keyword id="QuotedObjname" />
    title = <python:keyword id="Title" />
    temp = template3k.get_template(appconfig.template_admin)
    return temp.merge(PageTitle=objname.title(),
                      Menu='''<td><a href="index">%s</a></td>'''%objname.title(),
                      JavascriptInit='''callto({'handler': handle_commands},<python:keyword id="QuotedObjname" />,'showpage')''',
                      DevelQuote='',
                      Title='Module ' + title,
                      Content=''
                      )

TABLES=<python:keyword id="ListForms" />
def showpage(tables=TABLES):
    """
    Main listing method
    
    @param tables: The list of tables to be shown
    @return: A list of commands to list via javascript
    """
    objname = <python:keyword id="QuotedObjname" />
    itime = time.time()
    warn.debug("""If you want to index for a first time an existing database, """
               """you must enable the following piece of code (%s.showpage)"""%objname)
    if False:
        for x in TABLES:
            # print "DDDDD manage ft: ", x
            eval("manage_fulltext_%s"%x)(0, 1)
        print "***********************************> index time: ", time.time() - itime
    res = []
    for tabname in tables:
        res.extend(_list_method(tabname, None, None))
    return res

#######################################
#####
####   COMMON CUSTOMIZABLE FUNCTIONS
#####
#######################################
def _sql_quote(f):
    """
    Quotes sql strings
    
    @param f: string to be quoted
    @return: Quoted string
    """
    return _strip_field(f).replace("'","''")

def _like_cond(f, a):
    """
    Creates an SQL LIKE equivalent using hacks to sqlite3 (range query)
    @param f: field to be searched
    @param a: pattern
    @return: SQL LIKE equivalent string
    """
    if likechar is None:
        b = a[:-1] + chr(ord(a[-1]) + 1)
        return "(%s >= '%s' AND %s < '%s')"%(f, a, f, b)
    else:
        return "%s LIKE '%s%s'"%(f, a, likechar)

def _join_cond(d,joinmethod=None):
    """
    Join's an SQL condition
    @param d: Dictionary of conditions
    @param joinmethod: Method to join (LIKE, AND)
    @return: SQL string condition
    """
    try:
        items = d.items()
    except AttributeError:
        return ' 1=1 '
    if len(items) == 0:
        return ' 1=1 '
    else:
        if joinmethod == 'LIKE':
            return ' AND '.join([ _like_cond(_sql_quote(k), _sql_quote(v)) for k, v in d.items() ])
        else:
            return ' AND '.join([ "%s = '%s'"%(_sql_quote(k), _sql_quote(v)) for k, v in d.items() ])

def _quote_html(f):
    """
    Quote an HTML string
    @param f: String to quote
    @return: Quoted HTML string
    """
    return f.replace("<","&lt;").replace(">","&gt;") #.replace("&","&amp;")

def _strip_field(value):
    """
    Strip and encode an string or object, trying to match the right encoding
    @param value: String or object to be processed
    @return: Encoded and quoted string
    """
    if value is None:
        return ''
    elif type(value) in types.StringTypes:
        for enc in ("utf8","latin1","latin2","latin3","utf16"):
            try:
                return value.encode(enc).decode(enc)
                # return value.encode(enc)
            except (UnicodeDecodeError,UnicodeEncodeError), e:
                warn.debug("Ignoring and Retrying on UnicodeError (enc, value, error): ", repr((enc, value, e)))
        enc = "utf8"
        return value.decode(enc,"replace")
        # return value.encode(enc,"replace")
    else:
        return str(value)

def _strip_dict(d):
    """
    Applies L{_strip_field} to every data in a dictionary
    @param d: Dictionary to be I{stripped}
    @return: Strippped dictionary
    """
    for k,v in d.items():
        try:
            d[k] = _strip_field(d[k])
        except AttributeError:
            pass
    return d

def _pager(begin, count, total, template, num=15):
    """
    Creates the pager of a listing
    """
    xres = [ "Viewing %s elements (starting at %sth) from %s total entries "%(min(count,total-begin), begin, total) ]
    start = max(begin - num * count, 0)
    for x in range(num*2):
        page_number = start / count + 1
        if start == begin:
            xres.append("%s&nbsp;"%page_number)
        else:
            xres.append( template % locals() )
        start += count
        if start > total:
            if page_number == 1: return []
            break
    return xres

def _get_config(config, tabname):
    """
    Computes the dictionary of options to a common call
    
    @param config: Initial configuration dictionary 
    @param tabname: table name to retrieve the base configuration
    @return: The updated configuration dictionary 
    """
    if config is None:
        return modconfig[tabname]
    try:
        config['__sentinel__']
    except KeyError:
        _config = dict(modconfig[tabname])
        _config.update(config)
    else:
        _config = config
    return _config
        
def _control_generator(xlocals):
    """
    Default control generator
    """
    res = [
        (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
        r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%xlocals),
        (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
        r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%xlocals)
        ]
    if xlocals['config']['indexable']():
        res.append("""<a href="javascript: void(0)" """
                   """onclick="guigo_related(this, '%(objname)s', '%(tabname)s');">%(_related)s</a>"""%xlocals)
    return res

######
##### Global data
######

objname = <python:keyword id="QuotedObjname" />

#######################################################################################
#######################################################################################
######
######   FORMS
######
#######################################################################################
#######################################################################################
modconfig = {}

def _map_result(tabname, fieldname, value, outmap=None, config=None):
    """
    Maps one value to another (used to wrap foreign values and encode unicode strings)
    
    @param tabname: Table's name (useful to know the context)
    @param fieldname: Field name (useful to know the context)
    @param value: Value to map
    @param outmap: An external mapper function
    @param config: Call setup
    @return: Mapped or just encoded unicode string
    
    """
    objname = <python:keyword id="QuotedObjname" />
    config = _get_config(config, tabname)
    foreigns = config['foreign_mapper']
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = _preview(foreigntable, foreignfield, {foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _preview(tabname, id, condition_dict=None, display=None, config=None, preview_maxsize=None, **kwargs):
    """
    Creates a one line description of a register, it must be customized in order to provide an specific
    output
    
    @param tabname: Table's name
    @param id: Identifier to return
    @param condition_dict: SQL condition dict to select the desired records
    @param display: Display fields
    @param config: Call setup
    @param preview_maxsizer: Maximum length of a result entry
    @return: A list of list [ (id, display-string), (id2, display-string2), ... ]
    """
    # tabname = <-python:keyword id="QuotedTabname" />
    config = _get_config(config, tabname)
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_<-python:keyword id="Tabname" />)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    if not preview_maxsize:
        preview_maxsize = config['preview_maxsize']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display), tabname, condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result(tabname, qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:preview_maxsize]])
    return res

def _get_rowid(tabname, cond, config=None):
    """
    Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    
    @param tabname: Table's name
    @param cond: Condition dict to construct rowid for it
    @param config: Config call dictionary
    """
    config = _get_config(config, tabname)
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _out_list(tabname, fields, query, dopager=None, config=None):
    """
    Compose the html output of a list of results (in the same format than db3k.Connection.query)
    
    @param tabname: Table's name
    @param fields: List of field's name
    @param query: List of query results (list of lists of string or objects)
    @param dopager: Function to create an html pager (if any)
    @param config: Configuration to this call. The direct config options to this method are:
        - editable (function() -> bool)
        - insertable (function() -> bool)
        - indexable (function() -> bool)
        - structured_search (function() -> bool)
        - internal_fields (list of strings)
        - header_generator (function(field name, etc) -> html string)
        - output_table_header (function -> html table's header)
        - output_table_row (function -> html table's row)
        - output_table_control_row (function -> html table's row control)
        - output_table (function -> html tables)
        - outmap (function -> mapper foreign fields)
        - map_result (function -> mapper)
    """
    objname = <python:keyword id="QuotedObjname" />
    suffix = tabname
    config = _get_config(config, tabname)
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    editable = config['editable']()
    internal = config['internal_fields']
    try:
        hgen = config['header_generator']
        # it must has the same prototype than locale3k.getname and can be None, when it's None
        # the generation of headers will be skipped
    except KeyError:
        hgen = locale3k.getname
    out = []
    l = []
    viewfields = []
    for i, f in enumerate(fields):
        if f in internal:
            continue
        viewfields.append((i, f))
        if hgen:
            out.append(hgen(tabname, f, locale))
    l.append( config['output_table_header'](out) )
    try:
        outmap = config['outmap']
    except KeyError:
        outmap = lambda x: """<a href="javascript: callto({'handler': handle_commands_frames()}, '%(objname)s', 'list_view_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        try:
            dgen = config['map_result']
        except KeyError:
            dgen = _map_result
        for i, f in viewfields:
            r.append(dgen(tabname, f, q[i], outmap, config))
        l.append(config['output_table_row'](r, q, fields))
        if editable:
            rowid = _get_rowid(tabname, q, config)
            controls = config['control_generator'](locals())
            l.append(config['output_table_control_row'](r, controls, q, fields))
            # l.append('<tr><td style="text-align: right;" colspan="%s">%s</td></tr>'%(len(r), " &nbsp; ".join(controls)))
    # cursor.close()
    if editable:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    insertable=config['insertable']()
    if insertable:
        res.append(newitemlink)
    if config['structured_search']():
        searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    else:
        searchlink = ''
    if config['indexable']():
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r"""<span id="%(tabname)s-ftsearch"><a href="javascript: callto({'showresults': function(d) {DOM3K_updateElement(d,'%(tabname)s-ftsearch')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a></span> &nbsp;"""%locals()
    if dopager:
        searchlink += dopager() 
        res.append(searchlink)
    res.append(config['output_table'](l, query, fields))
    if insertable:
        res.append(newitemlink)
    res.append(" &nbsp; ")
    res.append(searchlink)
    return "".join(res)

def _list_select(db, tabname, config, condition, orderby, begin, count):
    """
    Used as default function to retrieve query results to all listing methods.
    It can be changed via modconfig[tabname]['select'] = new_function_list_select
    @param db: db3k.Connection object
    @param tabname: Table's name
    @param config: Config to this call
    @param condition: Condition (sql string)
    @param orderby: Sql I{order by} (list of fields)
    @param begin: SQL OFFSET
    @type begin: int
    @param count: SQL LIMIT
    @type count: int
    @return: Tuple (query, rowcount)
    """
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote, orderby)))
    rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname, condition, orderby))[0][0]
    query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(config['list_fields']), tabname, condition, orderby, limits))
    return query, rowcount

def _list(tabname, condition_dict=None, orderby=None, usecondmethod=None, list_condition_dict=None, begin=None, count=None, config=None, **kwargs):
    """
    Generic listing method.
    
    @param tabname:
    @param condition_dict: A condition dict
    @param orderby: List of fields to order
    @param usecondmethod: Condition method (e.g. LIKE, AND, etc). See L{_join_cond} for more options
    @param list_condition_dict: a list of condition_dict (exclusive with condition_dict)
    @param begin: SQL OFFSET
    @param count: SQL LIMIT 
    @param config: Call's configuration
    @return: HTML listing of condition_dict or list_condition_dict in the given context (args and config)
    """
    objname = <python:keyword id="QuotedObjname" />
    suffix = tabname
    config = _get_config(config, tabname)
    # auth = spyro.getrequest()['auth']
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    fields = config['list_fields']
    if count is None:
        count = config['count']
    if begin is None:
        begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition']() or not emptycond:
        query, rowcount = config['select'](db, tabname, config, condition, orderby, begin, count)
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            if len(qx) > 0:
                res.append("<div>%s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: DOM3K_calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list(tabname, fields, query, dopager, config)

def _out_choose_search(tabname, fields, query, idtag, previewsize, config=None):
    """
    Outputs an structured search for a choose widget (HTML select tag)
    
    @param tabname: Table's name
    @param fields: List of fields
    @param query: Query results
    @param idtag: Tag to put the results (via handle_commands)
    @param previewsize: The size of the preview
    @param config: Call context
    @return: HTML result to this query data
    """
    config = _get_config(config, tabname)
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_<-python:keyword id="Tabname" />)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'handler': handle_commands_frames()}, '%(objname)s', 'list_view_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result(tabname, f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def _form(tabname, mode, condition_dict, config=None, **kwargs):
    """
    Outputs an structured search for a choose widget (HTML select tag)
    
    @param tabname: Table's name
    @param mode: Form mode ('insert' or 'update', or None as 'insert' alias)
    @param condition_dict: The condition dict if mode is 'update'
    @param config: Call context
        - 'form_element': String template to create a form
        - 'editable': Boolean function
    @return: HTML form
    """
    config = _get_config(config, tabname)
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']():
        dict_default['__onsubmit__'] = r"DOM3K_commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def _list_method(tabname, mode, condition_dict, config=None, **kwargs):
    """
    Outputs a listing as commands to DOM3K's handle_commands hadler
    
    @param tabname: Table's name
    @param mode: list mode (anything, historical usage)
    @param condition_dict: The condition_dict to list
    @param config: Call context
        - 'output_showpage': String template to create a form
        - The config is sent to L{_list}
    @return: HTML form
    """

    config = _get_config(config, tabname)
    return (config['output_showpage'](tabname.title().replace('_', ' '), _list(tabname, condition_dict, config=config, **kwargs), tabname), )

def _modify(tabname, mode, data, cond, dbconn=None, doreturn=1, config=None, **kwargs):
    """
    Perform a modification (insert or update) to a table.
    
    @param tabname: Table's name
    @param mode: Form mode ('insert' or 'update')
    @param data: Data to be inserted or to update
    @param cond: If mode is 'update' the condition to be accomplish by the updated records
    @param dbconn: The database connection to perform the modifications, if None then the default connection (object scope) is used
    @param doreturn: If it's true, then it returns the modified data listed by L{_list_method}, else returns None
    @param config: Call context
        - 'editable': Boolean function
        - 'indexable': Boolean function
        - 'ftindex': Full text index
    @return: HTML form
    """
    config = _get_config(config, tabname)
    if dbconn is None:
        dbconn = db
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_<-python:keyword id="Tabname" />)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = dbconn.update(tabname, _strip_dict(data), cond)
        if config['indexable']():
            rowid = _get_rowid(tabname, cond, config)
            ftindex = config['ftindex']
            ftindex.handle_update(_preview(tabname, '1', data, config=config, preview_maxsize=512)[0][1], rowid)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = dbconn.insert(tabname, _strip_dict(data))
        if config['indexable']():
            xdata = _preview(tabname, config['list_fields'][0], data, config=config, preview_maxsize=512)[0]
            rowid = _get_rowid(tabname, xdata, config)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    if doreturn:
        return _list_method(tabname, mode, cond)
    else:
        return None

def _delete(tabname, cond, dbconn = None, doreturn = 1, config = None, **kwargs):
    """
    Perform a deletion in the table
    
    @param tabname: Table's name
    @param cond: The condition to match to the deleted tables
    @param dbconn: The database connection to perform the modifications, if None then the default connection (object scope) is used
    @param doreturn: If it's true, then it returns the modified data listed by L{_list_method} (It must be an empty set on success), else returns None 
    @param config: Call context
        - 'editable': Boolean function
        - 'indexable': Boolean function
        - 'ftindex': Full text index
    @return: list of commands
    """

    config = _get_config(config, tabname)
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_<-python:keyword id="Tabname" />)
    if dbconn is None:
        dbconn = db
    if config['indexable']():
        rowid = _get_rowid(tabname, cond, config)
        try:
            xdata = _preview(tabname, '1', cond, config=config, preview_maxsize=512)[0][1]
        except IndexError:
            pass
        else:
            ftindex = config['ftindex']
            ftindex.handle_delete(xdata, rowid)
    x = dbconn.execute('DELETE FROM %s WHERE %s'%(tabname, _join_cond(cond)))
    if doreturn:
        return _list_method(tabname, "delete", cond)
    else:
        return None

def _search_fulltext(tabname, query, output="", idtag="", residtag="", config=None, **kwargs):
    """
    Perform a fulltext search in the fulltext index related to a table
    
    @param tabname: Table's name to find the associated fulltext index
    @param query: String query to search
    @param output: The output mode:
                        - 'raw': A list of raw results (Query result to the specified records)
                        - 'ftraw': A list of tuples (rank, docid), where doc id it's represented by L{_get_rowid} output of the matched record
                        - 'choose_search': Output of _out_choose_search method
                        - 'list': Output of _out_list method
    @param doreturn: If it's true, then it returns the modified data listed by L{_list_method}, else returns None
    @param config: Call context
        - 'editable': Boolean function
        - 'indexable': Boolean function
        - 'ftindex': Full text index
        - 'list_fields'
        - 'output_showpage'
    @return: An object (see output parameter)
    """

    config = _get_config(config, tabname)
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if output == 'ftraw':
        return searchres
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'raw':
        return res
    if output == 'choose_search':
        return _out_choose_search(tabname, fields, res, idtag, size)
    else:
        x = _out_list(tabname, fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return (config['output_showpage'](tabname, x, tabname), )

def _choose_search(tabname, idtag, condition_dict = None, method="LIKE", outmethod="simple",
                    previewsize=10, list_condition_dict = None, config=None, **kwargs):
    """
    Performs an structured search
    
    @param tabname: Table's name
    @param idtag: Tag to put the results (via handle_commands)
    @param condition_dict: The condition to create the choose
    @param list_condition_dict: The condition to create the choose, see L{_list}
    @param previewsize: The size of the preview (number of results)
    @param method: SQL condition method, see L{_join_cond}
    @param outmethod: The output method
    @param config: Call context
    @return: HTML result to this query data
    """

    config = _get_config(config, tabname)
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_<-python:keyword id="Tabname" />)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = config['list_fields']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition']() or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search(tabname, fields, query, idtag, previewsize)

####
##
## Particular methods
##
####