###############################################################################################
###############################################################################################
###
### Table <python:keyword id="Tabname" /> UI
###

### Configuring <python:keyword id="Tabname" />

# TODO: Change all values of editable, insertable, indexable, etc to predicates
# TODO: in order to be able to give a behaviour dependable of the user, or auth

modconfig[<python:keyword id="QuotedTabname" />] = {
    'internal_fields' : <python:keyword id="InternalFields" />,
    'dict_default': { <python:keyword id="DictDefault" />,
                     '__objname__': <python:keyword id="QuotedObjname" />,
                     '__tabname__': <python:keyword id="QuotedTabname" />,
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': lambda: True,
    'insertable': lambda: True,
    'indexable': lambda: True,
    'structured_search': lambda: True,
    'ftindex': ft3k.sqlindex(name=<python:keyword id='QuotedTabname' />, conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': <python:keyword id="ListFields" />,
    'preview_fields': <python:keyword id="ListFields" />,
    'list_with_empty_condition': lambda: True,
    'control_generator': _control_generator,
    'preview_maxsize': 64,
    'output_table_header': lambda r: "<tr>%s</tr>"%("<th>%s</th>"%("</th><th>".join(r))),
    'output_table_row': lambda r, q, fields: "<tr>%s</tr>"%("<td>%s</td>"%("</td><td>".join(r))),
    'output_table_control_row': lambda r, controls, q, fields: '<tr><td style="text-align: right;" colspan="%s">%s</td></tr>'%(len(r), " &nbsp; ".join(controls)),
    'output_table': lambda r, query, fields: """<table style="width: 100%%"><tbody>%s</tbody></table>"""%("".join(r)),
    'output_showpage': lambda title, data, id: ('insert',
                                                       {'title': title,
                                                        'data': data,
                                                        'id': id,
                                                        'rowclasses': (['cell1', 'cell1', 'cell2', 'cell2'], 'header')
                                                       }),
    'select': _list_select,
    'foreign_mapper': <python:keyword id="ForeignDictionary" />,
    'form_element': template3k.get_template("""<python:keyword id='Tabname' />:form_element""",
                                            """<python:keyword id="FormElement" />"""),
    'form_element_search': template3k.get_template("""<python:keyword id="Tabname" />:form_element_search""",
                                                   """<python:keyword id="FormElementNoMandatory" />"""),
    '__sentinel__': True
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_<python:keyword id="Tabname" />'] = False
#_spyro_authentication.perms['list_<python:keyword id="Tabname" />'] = False
#_spyro_authentication.perms['modify_<python:keyword id="Tabname" />'] = False
#_spyro_authentication.perms['delete_<python:keyword id="Tabname" />'] = False
 
def list_view_<python:keyword id="Tabname" />(*args, **kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    config = _get_config(None, tabname)
    kwargs['config'] = config
    return (config['output_showpage'](tabname, _list(tabname, *args, **kwargs), tabname), )

def form_<python:keyword id="Tabname" />(mode = None, condition_dict = None, **kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    kwargs['config'] = _get_config(None, tabname)
    return _form(tabname, mode, condition_dict, **kwargs)

def modify_<python:keyword id="Tabname" />(mode, data, cond, dbconn=None, doreturn=1, **kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    config = _get_config(None, tabname)
    assert config['editable'](), "View only entity, can't %s"%mode
    tabname = <python:keyword id="QuotedTabname" />
    return _modify(tabname, mode, data, cond, dbconn, doreturn, config=config, **kwargs)

def delete_<python:keyword id="Tabname" />(cond, dbconn = None, doreturn = 1, **kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    config = _get_config(None, tabname)
    assert config['editable'](), "View only entity, can't delete"
    return _delete(tabname, cond, dbconn, doreturn, config=config, **kwargs)

def list_<python:keyword id="Tabname" />(*args, **kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    kwargs['config'] = _get_config(None, tabname)
    # assert _spyro_authentication._rawauth(auth,  objname, list_<python:keyword id="Tabname" />)
    return _list(tabname, *args, **kwargs)

def form_search_<python:keyword id="Tabname" />(method=None, *args, **kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    config = _get_config(None, tabname)
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': handle_commands}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_<python:keyword id='Tabname' />(drop_index, reindex):
    tabname = <python:keyword id="QuotedTabname" />
    config = _get_config(None, tabname)
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in _preview(tabname, config['list_fields'][0], config=config, preview_maxsize=512):
            _rowid = _get_rowid(tabname, x)
            ftindex.handle_insert(x[1], _rowid)

def form_search_fulltext_<python:keyword id="Tabname" />(output='list', idtag='', query='',**kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"""callto({'handler': handle_commands_frames()}, '%s', 'search_fulltext_%s', """
                                        r"""null, Easyform_formToDict(this));"""%(objname, tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
        dict_default['residtag'] = residtag
    else:
        dict_default['residtag'] = tabname
        dict_default['__onsubmit__'] = r"callto({'handler': handle_commands}, '%s', 'search_fulltext_%s', null, Easyform_formToDict(this));"%(objname, tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    <input name="residtag:string" value="residtag" type="hidden" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default

def search_fulltext_<python:keyword id="Tabname" />(query, output="", idtag="", residtag="", **kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    kwargs['config'] = None
    return _search_fulltext(tabname, query, output, idtag, residtag, **kwargs)


def search_<python:keyword id="Tabname" />(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    config = _get_config(None, tabname)
    x = list_<python:keyword id="Tabname" />(cond, orderby, usecondmethod=usecondmethod)
    return (config['output_showpage']('Search results', x, tabname), )

def choose_search_<python:keyword id="Tabname" />(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    config = _get_config(None, tabname)
    kwargs['config'] = config
    return _choose_search(tabname, idtag, condition_dict, method, outmethod, previewsize, list_condition_dict, **kwargs)

def preview_<python:keyword id="Tabname" />(*args, **kwargs):
    tabname = <python:keyword id="QuotedTabname" />
    kwargs['config'] = _get_config(None, tabname)
    # kwargs['display'] = <python:keyword id="Display" />
    return _preview(tabname, *args, **kwargs)

###
### end of <python:keyword id="Tabname" /> UI
###
###############################################################################################
###############################################################################################
