
function handle_commands(res, kwargs, transformation)
{
    for (var i = 0; i < res.length; i++) {
	var data = res[i];
	/*
	  insert. Inserts and element with given data. If it exists, the data inside the dom element will be replaced.
	  insert-list
	  replace. If exists the id=data[2] the dom element will be replaced.
	  replace-list
	  If not exists data[2] it will be inserted
	  frame. Creates a frame with title data[0], the content body as data[1],
	  frame-list
	  and data[2] as second argument to DOM3K_createFrame
	  javascript. Evaluates data[0] as javascript source. data[1] and data[2] can be
	  set to arbitraty data, and can be used inside the javascript source too.
	  Useful to send unquoted data. Any local and global data can be used, we must note the
	  data and res variables.
	*/
	if (typeof(transformation) == 'string') {
	    eval(transformation);
	} else if (typeof(transformation) == 'function') {
	    transformation(data)
	}
	var command = data[0];
	if (command == 'frame') {
	    var args =  data[1];
	    var f = DOM3K_createFrame(args['data'], args['config']);
	    f.setTitle(args['title']);
	    if (args['rowcolors']) {
		var colorargs = args['rowcolors'];
		DOM3K_BackgroundRowColors(f.div, colorargs[0], colorargs[1], colorargs[2]);
	    }
   	    if (args['rowclasses']) {
		var colorargs = args['rowclasses'];
		DOM3K_TableClass(f.div, colorargs[0], colorargs[1], colorargs[2]);
	    }
	    continue;
	}
	if (command == 'javascript') {
	    eval(data[1]);
	    continue;
	}
        if (command == 'insert-list' || command == 'update-list' || command == 'frame-list') {
            if (command == 'frame-list') {
                data[0] = command = 'frame';
            } else {
                data[0] = command = 'insert';
            }
            data[1] = {'title': data[1], 'data': data[2], 'id': data[3], 'rowclasses': data[4] }
        }
	if (command == 'insert' || command == 'update') {
	    var args = data[1];
	    var elem = DOM3K_getElement(args['id']);
	    var target = args['target'];
	    var index = args['index'];
	    if (!target) target = 'Content';
	    if (!index) index = 'Index';
	    if (elem == null) {
		var elem = DOM3K_createElement([args['data']],"div");
		var title = DOM3K_createElement([args['title']],"h3");
		var anchor = DOM3K_createElement([title],"a");
		anchor.setAttribute("name", "link-"+args['id']);
		title.style.width = '100%';
		title.className="thirdtitle";
		var d = DOM3K_createElement([anchor, elem], "div");
		DOM3K_appendToElement(d, target);
		var link = DOM3K_createElement([args['title']],'a');
		link.setAttribute("href","#link-" + args['id']);
		DOM3K_appendToElement(link, index);
		DOM3K_appendToElement(" &nbsp;&nbsp; ", index);
	    } else {
		if (command == 'replace') {
		    var newelem = DOM3K_createElement([args['data']],"div");
		    DOM3K_replaceChild(elem, newelem);
		    elem = newelem;
		} else {
		    DOM3K_updateElement(args['data'], elem);
		}
	    }
    	    elem.setAttribute("id",args['id']);
	    elem.id = args['id'];
	    if (args['rowcolors']) {
		var colorargs = args['rowcolors'];
		/* idtag, listofcolors, headercolor, changeevery*/
		DOM3K_BackgroundRowColors(elem, colorargs[0], colorargs[1], colorargs[2]);
	    }
      	    if (args['rowclasses']) {
		var colorargs = args['rowclasses'];
		DOM3K_TableClass(elem, colorargs[0], colorargs[1], colorargs[2]);
	    }

	}
    }
}

function handle_commands_closure(transformation)
{
    function f(res, kwargs) {
	handle_commands(res, kwargs, transformation);
    }
    return f;
}

function handle_commands_frames()
{
    return handle_commands_closure(function(d){d[0] = 'frame';});
}

function handle_commands_insert()
{
    return handle_commands_closure(function(d){d[0] = 'insert';});
}

function Show(res)
{
    var endfun = function(elem, data, showmethod) {
	DOM3K_BackgroundRowColors(elem, ['rgb(240,240,250)', 'inherit']);
    }
    for (var i = 0; i < res.length; i++) {
	var data = res[i];
	var e = data[2];
	var showmethod = data[3];
	/*
	  insert. Inserts and element with given data. If it exists, the data inside the dom element will be replaced.
	  replace. If exists the id=data[2] the dom element will be replaced.
	  If not exists data[2] it will be inserted
	  frame. Creates a frame with title data[0], the content body as data[1],
	  and data[2] as second argument to DOM3K_createFrame
	  javascript. Evaluates data[0] as javascript source. data[1] and data[2] can be
	  set to arbitraty data, and can be used inside the javascript source too.
	  Useful to send unquoted data. Any local and global data can be used, we must note the
	  data and res variables.
	*/
	if (showmethod == null) {
	    showmethod = 'insert'; 
	}
	if (showmethod == 'frame') {
	    var f = DOM3K_createFrame(data[1], data[2]);
	    f.setTitle(data[0]);
	    continue;
	}
	if (showmethod == 'javascript') {
	    eval(data[0]);
	    continue;
	}
	var elem = DOM3K_getElement(e);
	if (elem == null) {
	    var elem = DOM3K_createElement([data[1]],"div");
	    var title = DOM3K_createElement([data[0]],"h3");
	    var anchor = DOM3K_createElement([title],"a");
	    anchor.setAttribute("name","link-"+e);
	    title.style.width = '100%';
	    title.className="thirdtitle";
	    var d = DOM3K_createElement([anchor, elem],"div");
	    elem.id = e;
	    elem.setAttribute("id",e);
	    DOM3K_appendToElement(d, "Content");
	    var link = DOM3K_createElement([data[0]],'a');
	    link.setAttribute("href","#link-" + e);
	    DOM3K_appendToElement(link, "Index");
	    DOM3K_appendToElement(" &nbsp;&nbsp; ", "Index");
	} else {
	    if (showmethod == 'replace') {
		var newelem = DOM3K_createElement([data[1]],"div");
		DOM3K_replaceChild(elem, newelem);
	    } else {
		DOM3K_updateElement(data[1], elem);
	    }
	}
	endfun(elem, data, showmethod);
    }
}

/* function ShowClosure(endfun)

Returns a Closure with function Show
*/
 
function ShowClosure(endfun)
{
    return function(res) {
	return Show(res, endfun);
    }
}
