#coding: utf8;

__doc__ = ''' Easyform server to expediente_medico.expediente_medico '''

import auth3k
import auth3k.authweb as authweb
_spyro_authentication = authweb.Auth()
# To set permisions to the global module or object, uncomment the following
# [ [allowed users list], [ allowed groups list], [ denied user list] ]
_spyro_authentication.permsobject['expediente_medico.expediente_medico'] = [[],['admin'],[]]
# Note: In module objects the object name must be the name of the object. If an authobject is
# manages many objects, there may exists many object names

# For method level management
# _spyro_authentication.perms['methodname'] = [[],['admin'],[]]

# Gets automatically the connection because is already charged
import re
import warn
import db3k
import time
import locale3k
import template3k
import SPyRO as spyro
import appconfig
import ft3k
import types
# import marshal

dbmanager='sqlite3'
if dbmanager.startswith('sqlite'): # param style qmark
    likechar = '%'
else:
    likechar = '%%'
db = db3k.Connection(name='db/expediente_medico',
                     database='db/expediente_medico',
                     user='',
                     password='',
                     host=None,
                     manager=dbmanager)

ftname="ft%s"%('db/expediente_medico')
ftpool=db3k.ThreadPool(ftname, dbmanager)
dbftindex = db3k.Connection(
                     name=ftname,
                     database='db/expediente_medico',
                     user='',
                     password='',
                     host=None,
                     manager=dbmanager,
                     pool=ftpool)

#######################################
#######################################
#############
############  INDEX
#############
#######################################
#######################################
def index(**kwargs):
    objname = 'expediente_medico.expediente_medico'
    title = 'Expediente_Medico.Expediente_Medico'
    temp = template3k.get_template(appconfig.template_admin)
    return temp.merge(PageTitle=objname.title(),
                      Menu='''<td><a href="index">%s</a></td>'''%objname.title(),
                      JavascriptInit='''callto({'handler':Show},'expediente_medico.expediente_medico','showpage')''',
                      DevelQuote='',
                      Title='Module ' + title,
                      Content=''
                      )

def showpage(**kwargs):
    objname = 'expediente_medico.expediente_medico'
    import time
    itime = time.time()
    if True:
        for x in ['pais', 'estado', 'ciudad', 'persona', 'vacuna', 'cartilla_vacunacion', 'enfermedad', 'citas', 'persona_enfermedad']:
            # print "DDDDD manage ft: ", x
            eval("manage_fulltext_%s"%x)(0,1)
    print "***********************************> index time: ", time.time() - itime
    
    res = []
    res.append(('Pais',list_pais(),'pais'))
    res.append(('Estado',list_estado(),'estado'))
    res.append(('Ciudad',list_ciudad(),'ciudad'))
    res.append(('Persona',list_persona(),'persona'))
    res.append(('Vacuna',list_vacuna(),'vacuna'))
    res.append(('Cartilla Vacunacion',list_cartilla_vacunacion(),'cartilla_vacunacion'))
    res.append(('Enfermedad',list_enfermedad(),'enfermedad'))
    res.append(('Citas',list_citas(),'citas'))
    res.append(('Persona Enfermedad',list_persona_enfermedad(),'persona_enfermedad'))
    return res



#######################################
#####
####   COMMON CUSTOMIZABLE FUNCTIONS
#####
#######################################
def _sql_quote(f):
    return _strip_field(f).replace("'","''")

def _join_cond(d,joinmethod=None):
    try:
        items = d.items()
    except AttributeError:
        return ' 1=1 '
    if len(items) == 0:
        return ' 1=1 '
    else:
        if joinmethod == 'LIKE':
            return ' AND '.join([ "%s LIKE '%s%s'"%(_sql_quote(x[0]),_sql_quote(x[1]),likechar) for x in d.items()])
        else:
            return ' AND '.join([ "%s = '%s'"%(_sql_quote(x[0]),_sql_quote(x[1])) for x in d.items()])

def _quote_html(f):
    return f.replace("<","&lt;").replace(">","&gt;") #.replace("&","&amp;")

def _strip_field(value):
    if value is None:
        return ''
    elif type(value) in types.StringTypes:
        for enc in ("utf8","latin1","latin2","latin3","utf16"):
            try:
		return value.encode(enc).decode(enc)
                # return value.encode(enc)
            except (UnicodeDecodeError,UnicodeEncodeError), e:
                warn.debug("Ignoring and Retrying on UnicodeError (enc, value, error): ", repr((enc, value, e)))
        enc = "utf8"
        return value.decode(enc,"replace")
        # return value.encode(enc,"replace")
    else:
        return str(value)

def _strip_dict(d):
    for k,v in d.items():
        try:
            d[k] = _strip_field(d[k])
        except AttributeError:
            pass
    return d

def _pager(begin, count, total, template, num=15):
    xres = [ "Viewing %s elements (starting at %sth) from %s total entries "%(min(count,total-begin), begin, total) ]
    start = max(begin - num * count, 0)
    for x in range(num*2):
        page_number = start / count + 1
        if start == begin:
            xres.append("%s&nbsp;"%page_number)
        else:
            xres.append( template % locals() )
        start += count
        if start > total:
            if page_number == 1: return []
            break
    return xres

######
##### Global data
######

objname = 'expediente_medico.expediente_medico'

#######################################################################################
#######################################################################################
######
######   FORMS
######
#######################################################################################
#######################################################################################
modconfig = {}
###############################################################################################
###############################################################################################
###
### Table pais UI
###

### Configuring pais

modconfig['pais'] = {
    'internal_fields' : [u'xid'],
    'dict_default': { '' : '<python:locale id="general.submit" />','nombre' : '','xid' : '','nombre_corto' : '',
                     '__objname__': 'expediente_medico.expediente_medico',
                     '__tabname__': 'pais',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='pais', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['xid', 'nombre', 'nombre_corto'],
    'preview_fields': ['xid', 'nombre', 'nombre_corto'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("pais:form_element",
     """
            <strong>Pais</strong>
            <form method="POST" enctype="multipart/form-data" id="form-pais<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="pais" >
                <table><tbody>
            
<tr><td>
<python:locale id="pais.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string:mandatory" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="pais.nombre_corto">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre Corto'} ]
</python:locale>:</td><td><input name="nombre_corto:string:mandatory" type="text" value="<python:keyword id="nombre_corto" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("pais:form_element_search",
     """
            <strong>Pais</strong>
            <form method="POST" enctype="multipart/form-data" id="form-pais<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="pais" >
                <table><tbody>
            
<tr><td>
<python:locale id="pais.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="pais.nombre_corto">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre Corto'} ]
</python:locale>:</td><td><input name="nombre_corto:string" type="text" value="<python:keyword id="nombre_corto" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_pais'] = False
#_spyro_authentication.perms['list_pais'] = False
#_spyro_authentication.perms['modify_pais'] = False
#_spyro_authentication.perms['delete_pais'] = False
 
def _get_rowid_pais(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'pais'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_pais(mode, condition_dict):
    tabname = 'pais'
    return ((tabname,(list_pais(condition_dict)),tabname),)

def _map_result_pais(fieldname, value, outmap=None):
    tabname = 'pais'
    objname = 'expediente_medico.expediente_medico'
    foreigns = {}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_pais(fields, query, dopager=None):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'pais'
    suffix = 'pais'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_pais(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_pais(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_pais(fields, query, idtag, previewsize):
    tabname = 'pais'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_pais)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_pais(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_pais(mode = None,condition_dict = None, **kwargs):
    tabname = 'pais'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_pais(mode, data, cond, **kwargs):
    tabname = 'pais'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_pais)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_pais(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_pais('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_pais(config['list_fields'][0],data)[0]
            rowid = _get_rowid_pais(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_pais(mode, cond)

def delete_pais(cond, **kwargs):
    tabname = 'pais'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_pais)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_pais(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_pais("delete", cond)

def list_pais(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'pais'
    suffix = 'pais'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_pais)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_pais(fields, query, dopager)

def form_search_pais(method=None, *args, **kwargs):
    tabname = 'pais'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_pais(drop_index, reindex):
    tabname = 'pais'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_pais(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_pais(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_pais(output='list', idtag='', query='',**kwargs):
    tabname = 'pais'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_pais(query, output="", idtag="", **kwargs):
    tabname = 'pais'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_pais(fields, res, idtag, size)
    else:
        x = _out_list_pais(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_pais(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'pais'
    config = modconfig[tabname]
    return (('', list_pais(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_pais(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'pais'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_pais)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['xid', 'nombre', 'nombre_corto']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_pais(fields, query, idtag, previewsize)

def preview_pais(id, condition_dict=None, display = None, **kwargs):
    tabname = 'pais'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_pais)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'nombre'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_pais(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of pais UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table estado UI
###

### Configuring estado

modconfig['estado'] = {
    'internal_fields' : [u'xid'],
    'dict_default': { '' : '<python:locale id="general.submit" />','nombre' : '','xid' : '','nombre_corto' : '','idpais' : '',
                     '__objname__': 'expediente_medico.expediente_medico',
                     '__tabname__': 'estado',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='estado', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['xid', 'nombre', 'nombre_corto', 'idpais'],
    'preview_fields': ['xid', 'nombre', 'nombre_corto', 'idpais'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("estado:form_element",
     """
            <strong>Estado</strong>
            <form method="POST" enctype="multipart/form-data" id="form-estado<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="estado" >
                <table><tbody>
            
<tr><td>
<python:locale id="estado.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string:mandatory" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="estado.nombre_corto">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre Corto'} ]
</python:locale>:</td><td><input name="nombre_corto:string:mandatory" type="text" value="<python:keyword id="nombre_corto" />" size="40" /></td></tr>


<tr><td>
<python:locale id="estado.idpais">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Idpais'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="idpais" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_pais',['xid'])" name="idpais:int"  id="select-pais_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-pais_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'pais'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_pais', ['choose_search','select-pais_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_pais', ['choose_search','select-pais_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("estado:form_element_search",
     """
            <strong>Estado</strong>
            <form method="POST" enctype="multipart/form-data" id="form-estado<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="estado" >
                <table><tbody>
            
<tr><td>
<python:locale id="estado.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="estado.nombre_corto">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre Corto'} ]
</python:locale>:</td><td><input name="nombre_corto:string" type="text" value="<python:keyword id="nombre_corto" />" size="40" /></td></tr>


<tr><td>
<python:locale id="estado.idpais">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Idpais'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="idpais" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_pais',['xid'])" name="idpais:int"  id="select-pais_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-pais_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'pais'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_pais', ['choose_search','select-pais_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_pais', ['choose_search','select-pais_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_estado'] = False
#_spyro_authentication.perms['list_estado'] = False
#_spyro_authentication.perms['modify_estado'] = False
#_spyro_authentication.perms['delete_estado'] = False
 
def _get_rowid_estado(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'estado'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_estado(mode, condition_dict):
    tabname = 'estado'
    return ((tabname,(list_estado(condition_dict)),tabname),)

def _map_result_estado(fieldname, value, outmap=None):
    tabname = 'estado'
    objname = 'expediente_medico.expediente_medico'
    foreigns = {u'idpais': (u'pais', u'xid')}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_estado(fields, query, dopager=None):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'estado'
    suffix = 'estado'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_estado(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_estado(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_estado(fields, query, idtag, previewsize):
    tabname = 'estado'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_estado)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_estado(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_estado(mode = None,condition_dict = None, **kwargs):
    tabname = 'estado'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_estado(mode, data, cond, **kwargs):
    tabname = 'estado'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_estado)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_estado(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_estado('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_estado(config['list_fields'][0],data)[0]
            rowid = _get_rowid_estado(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_estado(mode, cond)

def delete_estado(cond, **kwargs):
    tabname = 'estado'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_estado)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_estado(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_estado("delete", cond)

def list_estado(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'estado'
    suffix = 'estado'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_estado)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_estado(fields, query, dopager)

def form_search_estado(method=None, *args, **kwargs):
    tabname = 'estado'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_estado(drop_index, reindex):
    tabname = 'estado'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_estado(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_estado(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_estado(output='list', idtag='', query='',**kwargs):
    tabname = 'estado'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_estado(query, output="", idtag="", **kwargs):
    tabname = 'estado'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_estado(fields, res, idtag, size)
    else:
        x = _out_list_estado(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_estado(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'estado'
    config = modconfig[tabname]
    return (('', list_estado(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_estado(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'estado'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_estado)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['xid', 'nombre', 'nombre_corto', 'idpais']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_estado(fields, query, idtag, previewsize)

def preview_estado(id, condition_dict=None, display = None, **kwargs):
    tabname = 'estado'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_estado)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'nombre'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_estado(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of estado UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table ciudad UI
###

### Configuring ciudad

modconfig['ciudad'] = {
    'internal_fields' : [u'xid'],
    'dict_default': { '' : '<python:locale id="general.submit" />','nombre' : '','xid' : '','nombre_corto' : '','idestado' : '',
                     '__objname__': 'expediente_medico.expediente_medico',
                     '__tabname__': 'ciudad',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='ciudad', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['xid', 'nombre', 'nombre_corto', 'idestado'],
    'preview_fields': ['xid', 'nombre', 'nombre_corto', 'idestado'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("ciudad:form_element",
     """
            <strong>Ciudad</strong>
            <form method="POST" enctype="multipart/form-data" id="form-ciudad<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="ciudad" >
                <table><tbody>
            
<tr><td>
<python:locale id="ciudad.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string:mandatory" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="ciudad.nombre_corto">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre Corto'} ]
</python:locale>:</td><td><input name="nombre_corto:string:mandatory" type="text" value="<python:keyword id="nombre_corto" />" size="40" /></td></tr>


<tr><td>
<python:locale id="ciudad.idestado">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Idestado'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="idestado" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_estado',['xid'])" name="idestado:int"  id="select-estado_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-estado_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'estado'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_estado', ['choose_search','select-estado_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_estado', ['choose_search','select-estado_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("ciudad:form_element_search",
     """
            <strong>Ciudad</strong>
            <form method="POST" enctype="multipart/form-data" id="form-ciudad<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="ciudad" >
                <table><tbody>
            
<tr><td>
<python:locale id="ciudad.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="ciudad.nombre_corto">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre Corto'} ]
</python:locale>:</td><td><input name="nombre_corto:string" type="text" value="<python:keyword id="nombre_corto" />" size="40" /></td></tr>


<tr><td>
<python:locale id="ciudad.idestado">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Idestado'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="idestado" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_estado',['xid'])" name="idestado:int"  id="select-estado_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-estado_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'estado'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_estado', ['choose_search','select-estado_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_estado', ['choose_search','select-estado_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_ciudad'] = False
#_spyro_authentication.perms['list_ciudad'] = False
#_spyro_authentication.perms['modify_ciudad'] = False
#_spyro_authentication.perms['delete_ciudad'] = False
 
def _get_rowid_ciudad(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'ciudad'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_ciudad(mode, condition_dict):
    tabname = 'ciudad'
    return ((tabname,(list_ciudad(condition_dict)),tabname),)

def _map_result_ciudad(fieldname, value, outmap=None):
    tabname = 'ciudad'
    objname = 'expediente_medico.expediente_medico'
    foreigns = {u'idestado': (u'estado', u'xid')}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_ciudad(fields, query, dopager=None):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'ciudad'
    suffix = 'ciudad'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_ciudad(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_ciudad(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_ciudad(fields, query, idtag, previewsize):
    tabname = 'ciudad'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_ciudad)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_ciudad(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_ciudad(mode = None,condition_dict = None, **kwargs):
    tabname = 'ciudad'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_ciudad(mode, data, cond, **kwargs):
    tabname = 'ciudad'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_ciudad)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_ciudad(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_ciudad('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_ciudad(config['list_fields'][0],data)[0]
            rowid = _get_rowid_ciudad(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_ciudad(mode, cond)

def delete_ciudad(cond, **kwargs):
    tabname = 'ciudad'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_ciudad)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_ciudad(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_ciudad("delete", cond)

def list_ciudad(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'ciudad'
    suffix = 'ciudad'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_ciudad)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_ciudad(fields, query, dopager)

def form_search_ciudad(method=None, *args, **kwargs):
    tabname = 'ciudad'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_ciudad(drop_index, reindex):
    tabname = 'ciudad'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_ciudad(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_ciudad(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_ciudad(output='list', idtag='', query='',**kwargs):
    tabname = 'ciudad'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_ciudad(query, output="", idtag="", **kwargs):
    tabname = 'ciudad'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_ciudad(fields, res, idtag, size)
    else:
        x = _out_list_ciudad(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_ciudad(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'ciudad'
    config = modconfig[tabname]
    return (('', list_ciudad(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_ciudad(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'ciudad'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_ciudad)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['xid', 'nombre', 'nombre_corto', 'idestado']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_ciudad(fields, query, idtag, previewsize)

def preview_ciudad(id, condition_dict=None, display = None, **kwargs):
    tabname = 'ciudad'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_ciudad)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'nombre'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_ciudad(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of ciudad UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table persona UI
###

### Configuring persona

modconfig['persona'] = {
    'internal_fields' : [u'xid'],
    'dict_default': { '' : '<python:locale id="general.submit" />','calle' : '','fax' : '','xid' : '','curp' : '','adicional' : '','colonia' : '','extnumero' : '','fecha_nacimiento' : '','intnumero' : '','ciudad_idciudad' : '','rfc' : '','celular' : '','nombre' : '','nss' : '','telefono' : '','email' : '','exttelefono' : '',
                     '__objname__': 'expediente_medico.expediente_medico',
                     '__tabname__': 'persona',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='persona', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['xid', 'email', 'nombre', 'curp', 'rfc', 'nss', 'telefono', 'celular', 'fax', 'exttelefono', 'calle', 'colonia', 'extnumero', 'intnumero', 'adicional', 'ciudad_idciudad', 'fecha_nacimiento'],
    'preview_fields': ['xid', 'email', 'nombre', 'curp', 'rfc', 'nss', 'telefono', 'celular', 'fax', 'exttelefono', 'calle', 'colonia', 'extnumero', 'intnumero', 'adicional', 'ciudad_idciudad', 'fecha_nacimiento'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("persona:form_element",
     """
            <strong>Persona</strong>
            <form method="POST" enctype="multipart/form-data" id="form-persona<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="persona" >
                <table><tbody>
            
<tr><td>
<python:locale id="persona.email">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Email'} ]
</python:locale>:</td><td><input name="email:string:" type="text" value="<python:keyword id="email" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string:mandatory" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.curp">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Curp'} ]
</python:locale>:</td><td><input name="curp:string:" type="text" value="<python:keyword id="curp" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.rfc">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Rfc'} ]
</python:locale>:</td><td><input name="rfc:string:" type="text" value="<python:keyword id="rfc" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.nss">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nss'} ]
</python:locale>:</td><td><input name="nss:string:" type="text" value="<python:keyword id="nss" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.telefono">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Telefono'} ]
</python:locale>:</td><td><input name="telefono:string:" type="text" value="<python:keyword id="telefono" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.celular">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Celular'} ]
</python:locale>:</td><td><input name="celular:string:" type="text" value="<python:keyword id="celular" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.fax">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fax'} ]
</python:locale>:</td><td><input name="fax:string:" type="text" value="<python:keyword id="fax" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.exttelefono">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Exttelefono'} ]
</python:locale>:</td><td><input name="exttelefono:string:" type="text" value="<python:keyword id="exttelefono" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.calle">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Calle'} ]
</python:locale>:</td><td><input name="calle:string:" type="text" value="<python:keyword id="calle" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.colonia">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Colonia'} ]
</python:locale>:</td><td><input name="colonia:string:" type="text" value="<python:keyword id="colonia" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.extnumero">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Extnumero'} ]
</python:locale>:</td><td><input name="extnumero:int:" type="text" value="<python:keyword id="extnumero" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.intnumero">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Intnumero'} ]
</python:locale>:</td><td><input name="intnumero:int:" type="text" value="<python:keyword id="intnumero" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.adicional">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Adicional'} ]
</python:locale>:</td><td><input name="adicional:string:" type="text" value="<python:keyword id="adicional" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.ciudad_idciudad">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Ciudad Idciudad'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="ciudad_idciudad" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_ciudad',['xid'])" name="ciudad_idciudad:int"  id="select-ciudad_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-ciudad_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'ciudad'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_ciudad', ['choose_search','select-ciudad_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_ciudad', ['choose_search','select-ciudad_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona.fecha_nacimiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Nacimiento'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" />
            <input type="text" name="fecha_nacimiento:date:" value="<python:keyword id="fecha_nacimiento" />" onclick="Easyform_frameReadDate(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("persona:form_element_search",
     """
            <strong>Persona</strong>
            <form method="POST" enctype="multipart/form-data" id="form-persona<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="persona" >
                <table><tbody>
            
<tr><td>
<python:locale id="persona.email">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Email'} ]
</python:locale>:</td><td><input name="email:string:" type="text" value="<python:keyword id="email" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.curp">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Curp'} ]
</python:locale>:</td><td><input name="curp:string:" type="text" value="<python:keyword id="curp" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.rfc">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Rfc'} ]
</python:locale>:</td><td><input name="rfc:string:" type="text" value="<python:keyword id="rfc" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.nss">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nss'} ]
</python:locale>:</td><td><input name="nss:string:" type="text" value="<python:keyword id="nss" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.telefono">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Telefono'} ]
</python:locale>:</td><td><input name="telefono:string:" type="text" value="<python:keyword id="telefono" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.celular">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Celular'} ]
</python:locale>:</td><td><input name="celular:string:" type="text" value="<python:keyword id="celular" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.fax">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fax'} ]
</python:locale>:</td><td><input name="fax:string:" type="text" value="<python:keyword id="fax" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.exttelefono">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Exttelefono'} ]
</python:locale>:</td><td><input name="exttelefono:string:" type="text" value="<python:keyword id="exttelefono" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.calle">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Calle'} ]
</python:locale>:</td><td><input name="calle:string:" type="text" value="<python:keyword id="calle" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.colonia">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Colonia'} ]
</python:locale>:</td><td><input name="colonia:string:" type="text" value="<python:keyword id="colonia" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.extnumero">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Extnumero'} ]
</python:locale>:</td><td><input name="extnumero:int:" type="text" value="<python:keyword id="extnumero" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.intnumero">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Intnumero'} ]
</python:locale>:</td><td><input name="intnumero:int:" type="text" value="<python:keyword id="intnumero" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.adicional">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Adicional'} ]
</python:locale>:</td><td><input name="adicional:string:" type="text" value="<python:keyword id="adicional" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona.ciudad_idciudad">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Ciudad Idciudad'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="ciudad_idciudad" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_ciudad',['xid'])" name="ciudad_idciudad:int"  id="select-ciudad_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-ciudad_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'ciudad'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_ciudad', ['choose_search','select-ciudad_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_ciudad', ['choose_search','select-ciudad_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona.fecha_nacimiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Nacimiento'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" />
            <input type="text" name="fecha_nacimiento:date:" value="<python:keyword id="fecha_nacimiento" />" onclick="Easyform_frameReadDate(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_persona'] = False
#_spyro_authentication.perms['list_persona'] = False
#_spyro_authentication.perms['modify_persona'] = False
#_spyro_authentication.perms['delete_persona'] = False
 
def _get_rowid_persona(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'persona'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_persona(mode, condition_dict):
    tabname = 'persona'
    return ((tabname,(list_persona(condition_dict)),tabname),)

def _map_result_persona(fieldname, value, outmap=None):
    tabname = 'persona'
    objname = 'expediente_medico.expediente_medico'
    foreigns = {u'ciudad_idciudad': (u'ciudad', u'xid')}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_persona(fields, query, dopager=None):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'persona'
    suffix = 'persona'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_persona(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_persona(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_persona(fields, query, idtag, previewsize):
    tabname = 'persona'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_persona(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_persona(mode = None,condition_dict = None, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_persona(mode, data, cond, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_persona)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_persona(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_persona('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_persona(config['list_fields'][0],data)[0]
            rowid = _get_rowid_persona(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_persona(mode, cond)

def delete_persona(cond, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_persona)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_persona(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_persona("delete", cond)

def list_persona(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'persona'
    suffix = 'persona'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_persona(fields, query, dopager)

def form_search_persona(method=None, *args, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_persona(drop_index, reindex):
    tabname = 'persona'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_persona(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_persona(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_persona(output='list', idtag='', query='',**kwargs):
    tabname = 'persona'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_persona(query, output="", idtag="", **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_persona(fields, res, idtag, size)
    else:
        x = _out_list_persona(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_persona(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    return (('', list_persona(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_persona(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['xid', 'email', 'nombre', 'curp', 'rfc', 'nss', 'telefono', 'celular', 'fax', 'exttelefono', 'calle', 'colonia', 'extnumero', 'intnumero', 'adicional', 'ciudad_idciudad', 'fecha_nacimiento']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_persona(fields, query, idtag, previewsize)

def preview_persona(id, condition_dict=None, display = None, **kwargs):
    tabname = 'persona'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_persona)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'email'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_persona(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of persona UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table vacuna UI
###

### Configuring vacuna

modconfig['vacuna'] = {
    'internal_fields' : [u'xid'],
    'dict_default': { 'descripcion' : '','nombre' : '','xid' : '','marca' : '','' : '<python:locale id="general.submit" />',
                     '__objname__': 'expediente_medico.expediente_medico',
                     '__tabname__': 'vacuna',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='vacuna', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['xid', 'nombre', 'descripcion', 'marca'],
    'preview_fields': ['xid', 'nombre', 'descripcion', 'marca'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("vacuna:form_element",
     """
            <strong>Vacuna</strong>
            <form method="POST" enctype="multipart/form-data" id="form-vacuna<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="vacuna" >
                <table><tbody>
            
<tr><td>
<python:locale id="vacuna.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string:" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="vacuna.descripcion">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Descripcion'} ]
</python:locale>:</td><td><input name="descripcion:string:" type="text" value="<python:keyword id="descripcion" />" size="40" /></td></tr>


<tr><td>
<python:locale id="vacuna.marca">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Marca'} ]
</python:locale>:</td><td><input name="marca:string:" type="text" value="<python:keyword id="marca" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("vacuna:form_element_search",
     """
            <strong>Vacuna</strong>
            <form method="POST" enctype="multipart/form-data" id="form-vacuna<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="vacuna" >
                <table><tbody>
            
<tr><td>
<python:locale id="vacuna.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string:" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="vacuna.descripcion">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Descripcion'} ]
</python:locale>:</td><td><input name="descripcion:string:" type="text" value="<python:keyword id="descripcion" />" size="40" /></td></tr>


<tr><td>
<python:locale id="vacuna.marca">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Marca'} ]
</python:locale>:</td><td><input name="marca:string:" type="text" value="<python:keyword id="marca" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_vacuna'] = False
#_spyro_authentication.perms['list_vacuna'] = False
#_spyro_authentication.perms['modify_vacuna'] = False
#_spyro_authentication.perms['delete_vacuna'] = False
 
def _get_rowid_vacuna(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'vacuna'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_vacuna(mode, condition_dict):
    tabname = 'vacuna'
    return ((tabname,(list_vacuna(condition_dict)),tabname),)

def _map_result_vacuna(fieldname, value, outmap=None):
    tabname = 'vacuna'
    objname = 'expediente_medico.expediente_medico'
    foreigns = {}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_vacuna(fields, query, dopager=None):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'vacuna'
    suffix = 'vacuna'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_vacuna(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_vacuna(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_vacuna(fields, query, idtag, previewsize):
    tabname = 'vacuna'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_vacuna)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_vacuna(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_vacuna(mode = None,condition_dict = None, **kwargs):
    tabname = 'vacuna'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_vacuna(mode, data, cond, **kwargs):
    tabname = 'vacuna'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_vacuna)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_vacuna(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_vacuna('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_vacuna(config['list_fields'][0],data)[0]
            rowid = _get_rowid_vacuna(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_vacuna(mode, cond)

def delete_vacuna(cond, **kwargs):
    tabname = 'vacuna'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_vacuna)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_vacuna(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_vacuna("delete", cond)

def list_vacuna(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'vacuna'
    suffix = 'vacuna'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_vacuna)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_vacuna(fields, query, dopager)

def form_search_vacuna(method=None, *args, **kwargs):
    tabname = 'vacuna'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_vacuna(drop_index, reindex):
    tabname = 'vacuna'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_vacuna(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_vacuna(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_vacuna(output='list', idtag='', query='',**kwargs):
    tabname = 'vacuna'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_vacuna(query, output="", idtag="", **kwargs):
    tabname = 'vacuna'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_vacuna(fields, res, idtag, size)
    else:
        x = _out_list_vacuna(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_vacuna(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'vacuna'
    config = modconfig[tabname]
    return (('', list_vacuna(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_vacuna(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'vacuna'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_vacuna)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['xid', 'nombre', 'descripcion', 'marca']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_vacuna(fields, query, idtag, previewsize)

def preview_vacuna(id, condition_dict=None, display = None, **kwargs):
    tabname = 'vacuna'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_vacuna)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'nombre'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_vacuna(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of vacuna UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table cartilla_vacunacion UI
###

### Configuring cartilla_vacunacion

modconfig['cartilla_vacunacion'] = {
    'internal_fields' : [u'xid'],
    'dict_default': { '' : '<python:locale id="general.submit" />','fecha_vacunacion' : '','xid' : '','tipo_vacuna' : '','persona_vacunada' : '',
                     '__objname__': 'expediente_medico.expediente_medico',
                     '__tabname__': 'cartilla_vacunacion',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='cartilla_vacunacion', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['xid', 'fecha_vacunacion', 'persona_vacunada', 'tipo_vacuna'],
    'preview_fields': ['xid', 'fecha_vacunacion', 'persona_vacunada', 'tipo_vacuna'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("cartilla_vacunacion:form_element",
     """
            <strong>Cartilla Vacunacion</strong>
            <form method="POST" enctype="multipart/form-data" id="form-cartilla_vacunacion<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="cartilla_vacunacion" >
                <table><tbody>
            
<tr><td>
<python:locale id="cartilla_vacunacion.fecha_vacunacion">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Vacunacion'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" />
            <input type="text" name="fecha_vacunacion:date:" value="<python:keyword id="fecha_vacunacion" />" onclick="Easyform_frameReadDate(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>


<tr><td>
<python:locale id="cartilla_vacunacion.persona_vacunada">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Persona Vacunada'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="persona_vacunada" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['xid'])" name="persona_vacunada:int"  id="select-persona_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="cartilla_vacunacion.tipo_vacuna">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Tipo Vacuna'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="tipo_vacuna" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_vacuna',['xid'])" name="tipo_vacuna:int"  id="select-vacuna_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-vacuna_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'vacuna'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_vacuna', ['choose_search','select-vacuna_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_vacuna', ['choose_search','select-vacuna_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("cartilla_vacunacion:form_element_search",
     """
            <strong>Cartilla Vacunacion</strong>
            <form method="POST" enctype="multipart/form-data" id="form-cartilla_vacunacion<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="cartilla_vacunacion" >
                <table><tbody>
            
<tr><td>
<python:locale id="cartilla_vacunacion.fecha_vacunacion">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Vacunacion'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" />
            <input type="text" name="fecha_vacunacion:date:" value="<python:keyword id="fecha_vacunacion" />" onclick="Easyform_frameReadDate(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>


<tr><td>
<python:locale id="cartilla_vacunacion.persona_vacunada">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Persona Vacunada'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="persona_vacunada" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['xid'])" name="persona_vacunada:int"  id="select-persona_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="cartilla_vacunacion.tipo_vacuna">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Tipo Vacuna'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="tipo_vacuna" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_vacuna',['xid'])" name="tipo_vacuna:int"  id="select-vacuna_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-vacuna_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'vacuna'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_vacuna', ['choose_search','select-vacuna_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_vacuna', ['choose_search','select-vacuna_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_cartilla_vacunacion'] = False
#_spyro_authentication.perms['list_cartilla_vacunacion'] = False
#_spyro_authentication.perms['modify_cartilla_vacunacion'] = False
#_spyro_authentication.perms['delete_cartilla_vacunacion'] = False
 
def _get_rowid_cartilla_vacunacion(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_cartilla_vacunacion(mode, condition_dict):
    tabname = 'cartilla_vacunacion'
    return ((tabname,(list_cartilla_vacunacion(condition_dict)),tabname),)

def _map_result_cartilla_vacunacion(fieldname, value, outmap=None):
    tabname = 'cartilla_vacunacion'
    objname = 'expediente_medico.expediente_medico'
    foreigns = {u'tipo_vacuna': (u'vacuna', u'xid'), u'persona_vacunada': (u'persona', u'xid')}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_cartilla_vacunacion(fields, query, dopager=None):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'cartilla_vacunacion'
    suffix = 'cartilla_vacunacion'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_cartilla_vacunacion(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_cartilla_vacunacion(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_cartilla_vacunacion(fields, query, idtag, previewsize):
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_cartilla_vacunacion)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_cartilla_vacunacion(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_cartilla_vacunacion(mode = None,condition_dict = None, **kwargs):
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_cartilla_vacunacion(mode, data, cond, **kwargs):
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_cartilla_vacunacion)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_cartilla_vacunacion(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_cartilla_vacunacion('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_cartilla_vacunacion(config['list_fields'][0],data)[0]
            rowid = _get_rowid_cartilla_vacunacion(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_cartilla_vacunacion(mode, cond)

def delete_cartilla_vacunacion(cond, **kwargs):
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_cartilla_vacunacion)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_cartilla_vacunacion(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_cartilla_vacunacion("delete", cond)

def list_cartilla_vacunacion(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'cartilla_vacunacion'
    suffix = 'cartilla_vacunacion'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_cartilla_vacunacion)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_cartilla_vacunacion(fields, query, dopager)

def form_search_cartilla_vacunacion(method=None, *args, **kwargs):
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_cartilla_vacunacion(drop_index, reindex):
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_cartilla_vacunacion(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_cartilla_vacunacion(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_cartilla_vacunacion(output='list', idtag='', query='',**kwargs):
    tabname = 'cartilla_vacunacion'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_cartilla_vacunacion(query, output="", idtag="", **kwargs):
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_cartilla_vacunacion(fields, res, idtag, size)
    else:
        x = _out_list_cartilla_vacunacion(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_cartilla_vacunacion(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    return (('', list_cartilla_vacunacion(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_cartilla_vacunacion(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_cartilla_vacunacion)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['xid', 'fecha_vacunacion', 'persona_vacunada', 'tipo_vacuna']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_cartilla_vacunacion(fields, query, idtag, previewsize)

def preview_cartilla_vacunacion(id, condition_dict=None, display = None, **kwargs):
    tabname = 'cartilla_vacunacion'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_cartilla_vacunacion)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'fecha_vacunacion'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_cartilla_vacunacion(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of cartilla_vacunacion UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table enfermedad UI
###

### Configuring enfermedad

modconfig['enfermedad'] = {
    'internal_fields' : [u'xid'],
    'dict_default': { '' : '<python:locale id="general.submit" />','nombre' : '','sintomatologia' : '','xid' : '','protocolo_tratamiento' : '',
                     '__objname__': 'expediente_medico.expediente_medico',
                     '__tabname__': 'enfermedad',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='enfermedad', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['xid', 'nombre', 'sintomatologia', 'protocolo_tratamiento'],
    'preview_fields': ['xid', 'nombre', 'sintomatologia', 'protocolo_tratamiento'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("enfermedad:form_element",
     """
            <strong>Enfermedad</strong>
            <form method="POST" enctype="multipart/form-data" id="form-enfermedad<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="enfermedad" >
                <table><tbody>
            
<tr><td>
<python:locale id="enfermedad.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string:" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="enfermedad.sintomatologia">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Sintomatologia'} ]
</python:locale>:</td><td><input name="sintomatologia:string:" type="text" value="<python:keyword id="sintomatologia" />" size="40" /></td></tr>


<tr><td>
<python:locale id="enfermedad.protocolo_tratamiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Protocolo Tratamiento'} ]
</python:locale>:</td><td><input name="protocolo_tratamiento:string:" type="text" value="<python:keyword id="protocolo_tratamiento" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("enfermedad:form_element_search",
     """
            <strong>Enfermedad</strong>
            <form method="POST" enctype="multipart/form-data" id="form-enfermedad<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="enfermedad" >
                <table><tbody>
            
<tr><td>
<python:locale id="enfermedad.nombre">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Nombre'} ]
</python:locale>:</td><td><input name="nombre:string:" type="text" value="<python:keyword id="nombre" />" size="40" /></td></tr>


<tr><td>
<python:locale id="enfermedad.sintomatologia">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Sintomatologia'} ]
</python:locale>:</td><td><input name="sintomatologia:string:" type="text" value="<python:keyword id="sintomatologia" />" size="40" /></td></tr>


<tr><td>
<python:locale id="enfermedad.protocolo_tratamiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Protocolo Tratamiento'} ]
</python:locale>:</td><td><input name="protocolo_tratamiento:string:" type="text" value="<python:keyword id="protocolo_tratamiento" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_enfermedad'] = False
#_spyro_authentication.perms['list_enfermedad'] = False
#_spyro_authentication.perms['modify_enfermedad'] = False
#_spyro_authentication.perms['delete_enfermedad'] = False
 
def _get_rowid_enfermedad(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'enfermedad'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_enfermedad(mode, condition_dict):
    tabname = 'enfermedad'
    return ((tabname,(list_enfermedad(condition_dict)),tabname),)

def _map_result_enfermedad(fieldname, value, outmap=None):
    tabname = 'enfermedad'
    objname = 'expediente_medico.expediente_medico'
    foreigns = {}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_enfermedad(fields, query, dopager=None):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'enfermedad'
    suffix = 'enfermedad'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_enfermedad(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_enfermedad(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_enfermedad(fields, query, idtag, previewsize):
    tabname = 'enfermedad'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_enfermedad)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_enfermedad(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_enfermedad(mode = None,condition_dict = None, **kwargs):
    tabname = 'enfermedad'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_enfermedad(mode, data, cond, **kwargs):
    tabname = 'enfermedad'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_enfermedad)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_enfermedad(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_enfermedad('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_enfermedad(config['list_fields'][0],data)[0]
            rowid = _get_rowid_enfermedad(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_enfermedad(mode, cond)

def delete_enfermedad(cond, **kwargs):
    tabname = 'enfermedad'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_enfermedad)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_enfermedad(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_enfermedad("delete", cond)

def list_enfermedad(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'enfermedad'
    suffix = 'enfermedad'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_enfermedad)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_enfermedad(fields, query, dopager)

def form_search_enfermedad(method=None, *args, **kwargs):
    tabname = 'enfermedad'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_enfermedad(drop_index, reindex):
    tabname = 'enfermedad'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_enfermedad(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_enfermedad(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_enfermedad(output='list', idtag='', query='',**kwargs):
    tabname = 'enfermedad'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_enfermedad(query, output="", idtag="", **kwargs):
    tabname = 'enfermedad'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_enfermedad(fields, res, idtag, size)
    else:
        x = _out_list_enfermedad(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_enfermedad(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'enfermedad'
    config = modconfig[tabname]
    return (('', list_enfermedad(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_enfermedad(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'enfermedad'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_enfermedad)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['xid', 'nombre', 'sintomatologia', 'protocolo_tratamiento']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_enfermedad(fields, query, idtag, previewsize)

def preview_enfermedad(id, condition_dict=None, display = None, **kwargs):
    tabname = 'enfermedad'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_enfermedad)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'nombre'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_enfermedad(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of enfermedad UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table citas UI
###

### Configuring citas

modconfig['citas'] = {
    'internal_fields' : [u'xid'],
    'dict_default': { '' : '<python:locale id="general.submit" />','fecha_cita' : '','xid' : '','paciente' : '','razon' : '',
                     '__objname__': 'expediente_medico.expediente_medico',
                     '__tabname__': 'citas',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='citas', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['xid', 'paciente', 'razon', 'fecha_cita'],
    'preview_fields': ['xid', 'paciente', 'razon', 'fecha_cita'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("citas:form_element",
     """
            <strong>Citas</strong>
            <form method="POST" enctype="multipart/form-data" id="form-citas<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="citas" >
                <table><tbody>
            
<tr><td>
<python:locale id="citas.paciente">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Paciente'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="paciente" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['xid'])" name="paciente:int"  id="select-persona_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="citas.razon">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Razon'} ]
</python:locale>:</td><td><input name="razon:string:" type="text" value="<python:keyword id="razon" />" size="40" /></td></tr>


<tr><td>
<python:locale id="citas.fecha_cita">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Cita'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" /> 
            <python:locale id="date.format_time" /> 
            <input type="text" name="fecha_cita:datetime:" value="<python:keyword id="fecha_cita" />" onclick="Easyform_frameReadDatetime(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("citas:form_element_search",
     """
            <strong>Citas</strong>
            <form method="POST" enctype="multipart/form-data" id="form-citas<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="citas" >
                <table><tbody>
            
<tr><td>
<python:locale id="citas.paciente">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Paciente'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="paciente" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['xid'])" name="paciente:int"  id="select-persona_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="citas.razon">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Razon'} ]
</python:locale>:</td><td><input name="razon:string:" type="text" value="<python:keyword id="razon" />" size="40" /></td></tr>


<tr><td>
<python:locale id="citas.fecha_cita">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Cita'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" /> 
            <python:locale id="date.format_time" /> 
            <input type="text" name="fecha_cita:datetime:" value="<python:keyword id="fecha_cita" />" onclick="Easyform_frameReadDatetime(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_citas'] = False
#_spyro_authentication.perms['list_citas'] = False
#_spyro_authentication.perms['modify_citas'] = False
#_spyro_authentication.perms['delete_citas'] = False
 
def _get_rowid_citas(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'citas'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_citas(mode, condition_dict):
    tabname = 'citas'
    return ((tabname,(list_citas(condition_dict)),tabname),)

def _map_result_citas(fieldname, value, outmap=None):
    tabname = 'citas'
    objname = 'expediente_medico.expediente_medico'
    foreigns = {u'paciente': (u'persona', u'xid')}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_citas(fields, query, dopager=None):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'citas'
    suffix = 'citas'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_citas(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_citas(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_citas(fields, query, idtag, previewsize):
    tabname = 'citas'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_citas)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_citas(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_citas(mode = None,condition_dict = None, **kwargs):
    tabname = 'citas'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_citas(mode, data, cond, **kwargs):
    tabname = 'citas'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_citas)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_citas(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_citas('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_citas(config['list_fields'][0],data)[0]
            rowid = _get_rowid_citas(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_citas(mode, cond)

def delete_citas(cond, **kwargs):
    tabname = 'citas'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_citas)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_citas(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_citas("delete", cond)

def list_citas(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'citas'
    suffix = 'citas'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_citas)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_citas(fields, query, dopager)

def form_search_citas(method=None, *args, **kwargs):
    tabname = 'citas'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_citas(drop_index, reindex):
    tabname = 'citas'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_citas(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_citas(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_citas(output='list', idtag='', query='',**kwargs):
    tabname = 'citas'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_citas(query, output="", idtag="", **kwargs):
    tabname = 'citas'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_citas(fields, res, idtag, size)
    else:
        x = _out_list_citas(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_citas(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'citas'
    config = modconfig[tabname]
    return (('', list_citas(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_citas(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'citas'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_citas)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['xid', 'paciente', 'razon', 'fecha_cita']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_citas(fields, query, idtag, previewsize)

def preview_citas(id, condition_dict=None, display = None, **kwargs):
    tabname = 'citas'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_citas)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'paciente'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_citas(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of citas UI
###
###############################################################################################
###############################################################################################
###############################################################################################
###############################################################################################
###
### Table persona_enfermedad UI
###

### Configuring persona_enfermedad

modconfig['persona_enfermedad'] = {
    'internal_fields' : [u'xid'],
    'dict_default': { '' : '<python:locale id="general.submit" />','xid' : '','persona_enferma' : '','peso_actual' : '','fecha_inicio' : '','padecimiento' : '','descripcion_detallada' : '','cita' : '','tratamiento' : '','seguimiento' : '',
                     '__objname__': 'expediente_medico.expediente_medico',
                     '__tabname__': 'persona_enfermedad',
                     #'__fulltextsearch__': '', # disables the fulltext search in the modify frame
                    },
    'editable': True,
    'indexable': True,
    'ftindex': ft3k.sqlindex(name='persona_enfermedad', conn=dbftindex),
    'ftsearch_size': 10,
    'count': 30,
    'list_fields': ['xid', 'cita', 'persona_enferma', 'padecimiento', 'fecha_inicio', 'descripcion_detallada', 'tratamiento', 'seguimiento', 'peso_actual'],
    'preview_fields': ['xid', 'cita', 'persona_enferma', 'padecimiento', 'fecha_inicio', 'descripcion_detallada', 'tratamiento', 'seguimiento', 'peso_actual'],
    'list_with_empty_condition': True,
    'form_element': template3k.get_template("persona_enfermedad:form_element",
     """
            <strong>Persona Enfermedad</strong>
            <form method="POST" enctype="multipart/form-data" id="form-persona_enfermedad<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="persona_enfermedad" >
                <table><tbody>
            
<tr><td>
<python:locale id="persona_enfermedad.cita">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Cita'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="cita" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_citas',['xid'])" name="cita:int"  id="select-citas_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-citas_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'citas'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_citas', ['choose_search','select-citas_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_citas', ['choose_search','select-citas_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona_enfermedad.persona_enferma">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Persona Enferma'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="persona_enferma" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['xid'])" name="persona_enferma:int"  id="select-persona_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona_enfermedad.padecimiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Padecimiento'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="padecimiento" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_enfermedad',['xid'])" name="padecimiento:int"  id="select-enfermedad_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-enfermedad_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'enfermedad'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_enfermedad', ['choose_search','select-enfermedad_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_enfermedad', ['choose_search','select-enfermedad_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona_enfermedad.fecha_inicio">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Inicio'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" />
            <input type="text" name="fecha_inicio:date:" value="<python:keyword id="fecha_inicio" />" onclick="Easyform_frameReadDate(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>


<tr><td>
<python:locale id="persona_enfermedad.descripcion_detallada">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Descripcion Detallada'} ]
</python:locale>:</td><td><input name="descripcion_detallada:string:" type="text" value="<python:keyword id="descripcion_detallada" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_enfermedad.tratamiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Tratamiento'} ]
</python:locale>:</td><td><input name="tratamiento:string:" type="text" value="<python:keyword id="tratamiento" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_enfermedad.seguimiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Seguimiento'} ]
</python:locale>:</td><td><input name="seguimiento:string:" type="text" value="<python:keyword id="seguimiento" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_enfermedad.peso_actual">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Peso Actual'} ]
</python:locale>:</td><td><input name="peso_actual:float:" type="text" value="<python:keyword id="peso_actual" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    'form_element_search': template3k.get_template("persona_enfermedad:form_element_search",
     """
            <strong>Persona Enfermedad</strong>
            <form method="POST" enctype="multipart/form-data" id="form-persona_enfermedad<python:keyword id='__id__' />" action="javascript: void(0);" onsubmit="<python:keyword id="__onsubmit__" />" name="persona_enfermedad" >
                <table><tbody>
            
<tr><td>
<python:locale id="persona_enfermedad.cita">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Cita'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="cita" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_citas',['xid'])" name="cita:int"  id="select-citas_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-citas_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'citas'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_citas', ['choose_search','select-citas_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_citas', ['choose_search','select-citas_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona_enfermedad.persona_enferma">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Persona Enferma'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="persona_enferma" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_persona',['xid'])" name="persona_enferma:int"  id="select-persona_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-persona_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'persona'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_persona', ['choose_search','select-persona_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona_enfermedad.padecimiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Padecimiento'} ]
</python:locale>:</td><td><select onfocus="callto({'rawhandler': createhandlerselect('<python:keyword id="padecimiento" />'), 'handlerargs': this},'<python:keyword id="__objname__" />','preview_enfermedad',['xid'])" name="padecimiento:int"  id="select-enfermedad_xid_<python:keyword id='__id__' />" ></select>
<a style="text-decoration: none;" href="javascript: DOM3K_replaceListOptions([['','']],'select-enfermedad_xid_<python:keyword id="__id__" />'); void(0);"><python:locale id="actions.clear" /></a><python:keyword id="__editmode__">

/
<a style="text-decoration: none;" href="javascript: showformmodify('<python:keyword id="__objname__" />', 'enfermedad'); void(0);"><python:locale id="actions.new" /></a></python:keyword>

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_enfermedad', ['choose_search','select-enfermedad_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search" /></a><python:keyword id="__fulltextsearch__">

/
<a style="text-decoration: none;" href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\\'<python:locale id="actions.search_form" />\\' ');}},  '<python:keyword id="__objname__" />', 'form_search_fulltext_enfermedad', ['choose_search','select-enfermedad_xid_<python:keyword id="__id__" />']); void(0);"><python:locale id="actions.search_fulltext" /></a></python:keyword>

</td></tr>


<tr><td>
<python:locale id="persona_enfermedad.fecha_inicio">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Fecha Inicio'} ]
</python:locale>:</td><td>
            <python:locale id="date.format_date" />
            <input type="text" name="fecha_inicio:date:" value="<python:keyword id="fecha_inicio" />" onclick="Easyform_frameReadDate(DOM3K_readInput(this), DOM3K_updateInput, this, event.clientY, event.clientX)"  />
            </td></tr>


<tr><td>
<python:locale id="persona_enfermedad.descripcion_detallada">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Descripcion Detallada'} ]
</python:locale>:</td><td><input name="descripcion_detallada:string:" type="text" value="<python:keyword id="descripcion_detallada" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_enfermedad.tratamiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Tratamiento'} ]
</python:locale>:</td><td><input name="tratamiento:string:" type="text" value="<python:keyword id="tratamiento" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_enfermedad.seguimiento">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Seguimiento'} ]
</python:locale>:</td><td><input name="seguimiento:string:" type="text" value="<python:keyword id="seguimiento" />" size="40" /></td></tr>


<tr><td>
<python:locale id="persona_enfermedad.peso_actual">
[ {'encoding': 'utf8', 'locale': 'en', 'translation': 'Peso Actual'} ]
</python:locale>:</td><td><input name="peso_actual:float:" type="text" value="<python:keyword id="peso_actual" />" size="40" /></td></tr>

<tr><td><input type="submit" name=":submit" value="<python:locale id="general.submit" />" /></td></tr>
                </tbody></table>
            </form>
            <python:keyword id="__bottom__"></python:keyword>
            """),
    }

### End configuration

###
### Beginning methods/functions

#_spyro_authentication.perms['form_persona_enfermedad'] = False
#_spyro_authentication.perms['list_persona_enfermedad'] = False
#_spyro_authentication.perms['modify_persona_enfermedad'] = False
#_spyro_authentication.perms['delete_persona_enfermedad'] = False
 
def _get_rowid_persona_enfermedad(cond):
    """ Returns the rowid identifing any row in the table, it's calculated
    using the condition or the insertion data. This method must be replaced
    using knowledge about the table. You must override this function with
    the correct behaviour if the default is not what you need.
    """
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    idname = config['list_fields'][0]
    if isinstance(cond, types.DictType):
        try:
            data = cond[idname]
        except KeyError:
            return repr(_strip_dict(cond)).replace("u'","'")
    else:
        data = cond[0]
    x = repr({str(idname): _strip_field(data)})
    x = x.replace("u'","'")
    return x

def _list_method_persona_enfermedad(mode, condition_dict):
    tabname = 'persona_enfermedad'
    return ((tabname,(list_persona_enfermedad(condition_dict)),tabname),)

def _map_result_persona_enfermedad(fieldname, value, outmap=None):
    tabname = 'persona_enfermedad'
    objname = 'expediente_medico.expediente_medico'
    foreigns = {u'persona_enferma': (u'persona', u'xid'), u'cita': (u'citas', u'xid'), u'padecimiento': (u'enfermedad', u'xid')}
    try:
        # This is the default behaviour, you must create caches of this values in order to speed up
        # this requests
        foreigntable, foreignfield = foreigns[fieldname]
        res = eval("preview_%s"%foreigntable)(foreignfield,{foreignfield:value})
        display = _strip_field(res[0][1])
        if outmap is None:
            return display
        else:
            return outmap(locals())            
    except (KeyError, IndexError), e:
        return _strip_field(value)

def _out_list_persona_enfermedad(fields, query, dopager=None):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'persona_enfermedad'
    suffix = 'persona_enfermedad'
    config = modconfig[tabname]
    locale = locale3k.getweblocale()
    _newitem = locale3k.getname("actions", "new", locale)
    _delitem = locale3k.getname("actions", "delete", locale)
    _moditem = locale3k.getname("actions", "modify", locale)
    _related = locale3k.getname("actions","related",locale)
    l = [ '<tr>' ]
    internal = config['internal_fields']
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append('</tr>')
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        if len(q) > 1:
            index = 1
        else:
            index = 0
        name_name = fields[index]
        data_name = q[index]
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_persona_enfermedad(f, q[i], outmap))# _strip_field(q[i]))
        if config['editable']:
            rowid = _get_rowid_persona_enfermedad(q)
            controls = [
                (r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s', """
                r"""['update', %(rowid)s]);void(0);">%(_moditem)s</a>"""%locals()),
                (r"""<a href="javascript: calldelete('%(objname)s', '%(suffix)s',  """
                r"""[%(rowid)s]);void(0);">%(_delitem)s</a>"""%locals())
                ]
            if config['indexable']:
                # qstr = str(q).replace("'"," ")
                controls.append("""<a href="javascript: void(0)" """
                                """onclick="var text = DOM3K_readText(this.parentNode.parentNode); callto({'showresults': DOM3K_createFrame}, """
                                """'%(objname)s', 'search_fulltext_%(tabname)s', """
                                """ [text] ); void(0);">%(_related)s</a>"""%locals())
            r.append(" &nbsp; ".join(controls))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s,r)) + '</tr>')
    # cursor.close()
    if config['editable']:
        newitemlink = r"""<a href="javascript: showformmodify('%(objname)s', '%(suffix)s'); ">%(_newitem)s</a>"""%locals()
    else:
        newitemlink = ""
    res = []
    searchname = locale3k.getname("actions","search",locale)
    searchlink = r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search %(tabname)s\'')}}, '%(objname)s', 'form_search_%(tabname)s'); void(0);">%(searchname)s</a> &nbsp; """%locals()
    if config['indexable']:
        searchname_fulltext = locale3k.getname("actions","search_fulltext",locale)
        searchlink += r""" <a href="javascript: callto({'showresults': function(d) {DOM3K_createFrame(d,'title=\'Search Fulltext on %(tabname)s\'')}}, '%(objname)s', 'form_search_fulltext_%(tabname)s'); void(0);">%(searchname_fulltext)s</a> &nbsp; """%locals()

    if dopager:
        searchlink += dopager() 
    res.append(searchlink)
    res.append("".join(['<table><tbody>', '\n'.join(l),' </tbody></table>',newitemlink," &nbsp; "]) )
    res.append(searchlink)
    return "".join(res)

def _out_choose_search_persona_enfermedad(fields, query, idtag, previewsize):
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona_enfermedad)
    locale = locale3k.getweblocale()
    l = [ '<table><tbody><tr>' ]
    internal = config['internal_fields']    
    for f in fields:
        if f in internal:
            continue
        l.append("<th>%s</th>"%locale3k.getname(tabname, f, locale))
    l.append("<th></th>")
    l.append('</tr>')
    # if begin > 0: cursor.scroll(begin)
    # for q in cursor.fetchmany(count):
    outmap = lambda x: """<a href="javascript: callto({'showresults': DOM3K_createFrame}, '%(objname)s', 'list_%(foreigntable)s', [{'%(foreignfield)s':  '%(value)s'}]); void(0);">%(display)s</a>"""%x
    for q in query:
        name_id = fields[0]
        data_id = str(q[0])
        r = []
        for i,f in enumerate(fields):
            if f in internal:
                continue
            r.append(_map_result_persona_enfermedad(f, q[i])) # outmap
        name = ". ".join(r)
        r.append("""<a href="javascript: void(0);" onclick="DOM3K_replaceListOptions([[%s,'%s']], %s); DOM3K_deleteFrame(this); void(0);">%s</a>"""%(repr(data_id),_strip_field(name),repr(idtag),locale3k.getname("general","choose_this",locale)))
        l.append('<tr>' + " ".join(map(lambda s: "<td>%s</td>"%s, r)) + '</tr>')
    if len(query) >= previewsize:
        l.append("""<tr><td>...</td><td class="thirdtitle" colspan="%s">%s</td></tr>"""%(len(fields),locale3k.getname("general","too_many_results", locale)))
    l.append("</tbody></table>")
    return "".join(l)

def form_persona_enfermedad(mode = None,condition_dict = None, **kwargs):
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    if mode is None:
        mode = 'insert'
    dict_default = dict(config['dict_default'])
    if condition_dict is None:
        cond = '{}'
    else:
        cond = condition_dict
    if config['editable']:
        dict_default['__onsubmit__'] = r"commitform(this, '%s','%s',['%s',Easyform_formToDict(this),%s]);"%(objname,tabname,mode,cond)
    else:
        dict_default['__onsubmit__'] = r"DOM3K_deleteFrame(this);"
        dict_default['__editmode__'] = ""
    if mode == 'update':
        qupdate = 'SELECT * FROM %s WHERE %s'%(tabname,_join_cond(condition_dict))
        dict_default.update(db.hquery(qupdate)[0])
        _strip_dict(dict_default)
    elif mode != 'insert':
        raise AttributeError, "Attribute mode is set to an unknown value (insert|update) '%s'"%mode
    dict_default['__id__'] = str(time.time())
    return config['form_element'].merge(dict_default)

def modify_persona_enfermedad(mode, data, cond, **kwargs):
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't %s"%mode
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, modify_persona_enfermedad)
    if mode == 'update':
        if None in (data,cond): raise Exception("Unable to update table %s with empty data"%tabname)
        if len(cond) == 0: raise Exception("Unable to update %s without condition"%tabname)
        # It's a good idea overwrite user id fields with information of the authentications
        # For example:
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.update(tabname, _strip_dict(data), cond)
        if config['indexable']:
            rowid = _get_rowid_persona_enfermedad(cond)
            ftindex = config['ftindex']
            ftindex.handle_update(preview_persona_enfermedad('1',data)[0][1], rowid)
            ftpool.delconn(1)
    elif mode == 'insert':
        if data is None: raise Exception("Unable to insert into table %s with empty data"%tabname)
        #cond['userid'] = spyro.getrequest()['auth'][0]
        x = db.insert(tabname, _strip_dict(data))
        if config['indexable']:
            xdata = preview_persona_enfermedad(config['list_fields'][0],data)[0]
            rowid = _get_rowid_persona_enfermedad(xdata)
            ftindex = config['ftindex']
            ftindex.handle_insert(xdata[1], rowid)
            ftpool.delconn(1)
    else:
        raise Exception("Unknown action to modify %s"%tabname)
    return _list_method_persona_enfermedad(mode, cond)

def delete_persona_enfermedad(cond, **kwargs):
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    assert config['editable'], "View only entity, can't delete"
    if None is cond: raise Exception("Unable to delete table with empty condition")
    if len(cond) == 0: raise Exception("Unable to delete without condition")
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, delete_persona_enfermedad)
    x = db.execute('DELETE FROM %s WHERE %s'%(tabname,_join_cond(cond)))
    if config['indexable']:
        rowid = _get_rowid_persona_enfermedad(cond)
        ftindex = config['ftindex']
        ffindex.handle_delete(rowid)
        ftpool.delconn(1)
    return _list_method_persona_enfermedad("delete", cond)

def list_persona_enfermedad(condition_dict = None, orderby = None, usecondmethod = None, list_condition_dict = None, **kwargs):
    objname = 'expediente_medico.expediente_medico'
    tabname = 'persona_enfermedad'
    suffix = 'persona_enfermedad'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona_enfermedad)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    _orderby = orderby
    if orderby is None:
        orderby = ''
    else:
        orderby = 'ORDER BY ' + (','.join(map(_sql_quote,orderby)))
    fields = config['list_fields']
    count = kwargs.get('count',config['count'])
    begin = kwargs.get('begin',0)
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, usecondmethod) for cd in list_condition_dict ] )
    # Using cursors yields to a very poor performance (maybe we use it in a wrong way).
    # Using count and limit to enhance performance (2 queries :( )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    # cursor = db.conn.cursor()
    # cursor.execute('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,orderby))
    # This was tested in postgresql
    if config['list_with_empty_condition'] or not emptycond:
        rowcount = db.query('SELECT COUNT(*) FROM %s WHERE %s %s'%(tabname,condition,orderby))[0][0]
        query = db.query('SELECT %s FROM %s WHERE %s %s %s'%(",".join(fields),tabname,condition,orderby,limits))
    else:
        rowcount = 0
        query = []
    if usecondmethod is None:
        strcondmethod = 'null'
    else:
        strcondmethod = repr(usecondmethod)
    if len(list_condition_dict) == 0 or len(list_condition_dict[0]) == 0:
        str_list_condition_dict = 'null'
    else:
        str_list_condition_dict = repr(list_condition_dict)
    if _orderby is None:
        strorderby = 'null'
    else:
        strorderby = repr(_orderby)
    locs = locals()
    def dopager():
        res = []
        if len(list_condition_dict) > 0:
            qx = []
            for qc in list_condition_dict:
                try:
                    items = qc.items()
                except AttributeError:
                    items = ()
                    qx.append(", ".join([ "%s: %s"%(k,v) for k,v in items ]))
            res.append("<div>Filter: %s</div>"%". ".join(qx))
        tem = r"""<a href="javascript: calllist('%(objname)s', '%(suffix)s', [null,%(strorderby)s,%(strcondmethod)s,%(str_list_condition_dict)s], { 'begin' : %%(start)s, 'count' : %%(count)s } ) ; void(0);" >%%(page_number)s</a> """%locs
        res.extend(_pager(begin, count, rowcount, tem))
        return "".join(res)
    return _out_list_persona_enfermedad(fields, query, dopager)

def form_search_persona_enfermedad(method=None, *args, **kwargs):
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    dict_default = dict(config['dict_default']) # dictionary
    dict_default['__editmode__'] = ""
    if method == "choose_search":
        idtag = args[0]
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','choose_search_%s',null,{'condition_dict': Easyform_formToDict(this), 'idtag': %s });"""
                                        r""" """%(residtag,residtag,objname,tabname,repr(idtag)))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': Show}, '%s','search_%s',[Easyform_formToDict(this), null, 'LIKE']);"%(objname,tabname)
    dict_default['__id__'] = str(time.time())
    x = config['form_element_search'].merge(dict_default)
    return x

def manage_fulltext_persona_enfermedad(drop_index, reindex):
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    if drop_index:
        ftindex.drop_index()
    if reindex:
        ftindex.create_index()
        for x in preview_persona_enfermedad(config['list_fields'][0]):
            # warn.debug("========>", tabname, ":::>", x)
            _rowid = _get_rowid_persona_enfermedad(x)
            ftindex.handle_insert(x[1], _rowid)
    ftpool.delconn(1)

def form_search_fulltext_persona_enfermedad(output='list', idtag='', query='',**kwargs):
    tabname = 'persona_enfermedad'
    dict_default = {'query': query, 'output': output, 'idtag': idtag}
    if output == "choose_search":
        residtag = 'choose-search-%s'%idtag
        dict_default['__onsubmit__'] = (r"callto({'showresults': function(d){ DOM3K_updateElement(d,'%s'); """
                                        r"""DOM3K_BackgroundRowColors('%s',['rgb(200,200,230);','inherit']);}}, """
                                        r"""'%s','search_fulltext_%s',null,Easyform_formToDict(this));"""
                                        r""" """%(residtag,residtag,objname,tabname))
        dict_default['__bottom__'] = """<div id="%s"></div>"""%residtag
        dict_default['__idtag__'] = """<input name="idtag:string:mandatory" value="%s" type="hidden" />"""%idtag
    else:
        dict_default['__onsubmit__'] = r"callto({'handler': function(d){Show([['%s',d,'%s']])}}, '%s','search_fulltext_%s',null,Easyform_formToDict(this));"%(tabname, tabname, objname,tabname)
        dict_default['__idtag__'] = ""
        dict_default['__bottom__'] = ""
    dict_default['__id__'] = str(time.time())
    return """<form action="javascript: void(0);" onsubmit="%(__onsubmit__)s">
    <input name="output:string:mandatory" value="%(output)s" type="hidden" />
    <input name="query:string:mandatory" value="%(query)s" size="40" type="text" />
    %(__idtag__)s
    <input name=":submit" value="Search" type="submit" />
    </form>
    %(__bottom__)s
    """%dict_default
    
def search_fulltext_persona_enfermedad(query, output="", idtag="", **kwargs):
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    ftindex = config['ftindex']
    size = config['ftsearch_size']
    searchres = ftindex.search(query, size)
    if len(searchres) == 0:
        return ""
    res = []
    fields = config['list_fields']
    for rank, cond in searchres:
        warn.debug( "XXXXXXXXXXXXXX Fulltext results: %s"%tabname, cond )
        cond = eval(cond)
        res.extend( db.query("""SELECT %s FROM %s WHERE %s LIMIT 1"""%(", ".join(fields),tabname,_join_cond(cond,"="))) )
    # we loose the ranking, but we standardize the output
    if output == 'choose_search':
        return _out_choose_search_persona_enfermedad(fields, res, idtag, size)
    else:
        x = _out_list_persona_enfermedad(fields, res, idtag)
        if len(res) >= size:
            x+="<br/>" + locale3k.getname("general","too_many_results")
        return x

def search_persona_enfermedad(cond,orderby=None,usecondmethod=None,**kwargs):
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    return (('', list_persona_enfermedad(cond, orderby, usecondmethod=usecondmethod), tabname),)

def choose_search_persona_enfermedad(idtag, condition_dict = None, method="LIKE", outmethod="simple",
                                                  previewsize=10, list_condition_dict = None, **kwargs):
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, list_persona_enfermedad)
    emptycond = False
    if condition_dict is None:
        condition_dict = {}
        emptycond = True
    if (list_condition_dict is None) or (len(list_condition_dict) == 0):
        list_condition_dict = [condition_dict]
    else:
        emptycond = False
    fields = ['xid', 'cita', 'persona_enferma', 'padecimiento', 'fecha_inicio', 'descripcion_detallada', 'tratamiento', 'seguimiento', 'peso_actual']
    count = previewsize
    begin = 0
    condition = " OR ".join( [ "(%s)"%_join_cond(cd, method) for cd in list_condition_dict ] )
    limits = 'LIMIT %d OFFSET %d'%(count,begin)
    if config['list_with_empty_condition'] or not emptycond:
        query = db.query('SELECT %s FROM %s WHERE %s %s'%(",".join(fields),tabname,condition,limits))
    else:
        query = []
    return _out_choose_search_persona_enfermedad(fields, query, idtag, previewsize)

def preview_persona_enfermedad(id, condition_dict=None, display = None, **kwargs):
    tabname = 'persona_enfermedad'
    config = modconfig[tabname]
    if condition_dict is None: condition_dict = {}
    # auth = spyro.getrequest()['auth']
    # assert _spyro_authentication._rawauth(auth,  objname, preview_persona_enfermedad)
    # cond = ' 1=1 '
    condition = _join_cond(condition_dict)
    if display is None:
        # display = 'cita'
        fields = config['preview_fields']
        display = ",".join(fields)
    else:
        fields = None
    res = []
    internal = config['internal_fields']
    for qres in db.hquery('SELECT %s,%s FROM %s WHERE %s'%(_sql_quote(id), _sql_quote(display),tabname,condition)):
        row = []
        if fields is None:
            fields = qres.keys()
            fields.sort()
        for qk in fields:
            qv = qres[qk]
            if qk in internal:
                continue
            if qv:
                row.append(_map_result_persona_enfermedad(qk, qv)) # posible infinite loops due to foreign resolution
        res.append([qres[id], ", ".join(row)[:64] ])
    # warn.debug(("PREVIEW:",tabname, display, internal, res))
    return res

###
### end of persona_enfermedad UI
###
###############################################################################################
###############################################################################################
